/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1998.
************************************************************************

For more information or to receive an up to date version of this module,
you may call Patrick Gioia at patrick.gioia@rd.francetelecom.com
----------------------------------------------------------------------*/

#if !defined(_WaveSurfDec_h)	// Sentry, use file only if it's not already included.
#define _WaveSurfDec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       WaveSurfDec.h
AUTHOR:     Patrick Gioia (France Telecom R & D)
OVERVIEW:   Definition of WaveSurfDecoder 
-------------------------------------------------------------------------*/
#include "..\AFX.h"
#include "zerotree\data.h"
#include "zerotree\ZTEncDec.h"

class WMDecoderSpecificInfo;

class WaveSurfDecoder : public AFXTemplate
{
public:
	WaveSurfDecoder(); 
public:
	virtual BOOL Setup (
		AFXExtDescriptor *pSpecificInfo
	);
	BOOL Setup ();
	virtual int GetOptimalOutputSize ();
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
  int SetBaseMesh(MediaObject* WaveSurfNode);
	
	


public:
	FILE *m_fDump;
	BOOL m_bActive;

public:
	Mesh* m_BM;
	WMDecoderSpecificInfo *m_pDecSpecificInfo;
	Mesh m_RecMesh;
	bool m_isDecoded;
	ZTEncDec *ZTED;
	
};

#endif                                      // _WaveSurfDec_h sentry.
