#include "data.h"
#include "3d.h"
#include "WaveDec.h" //header for WaveDec.lib
#include "wavecore.h"

/*-----------------------------------------------------
  Classe dcodeur/encodeur de maillage par ondelettes
-----------------------------------------------------*/

#ifndef _CWMESHDEFINED_
#define _CWMESHDEFINED_

class CWMesh {

/*----------
Attributes
----------*/
public:
	Mesh *m_Mesh;
	Mesh *m_baseMesh;
	WaveRep *m_pWr;
	Qtree *m_Q;
	VertexPerCoeff *m_pVPC;
	DatMesh *DM;

/*-----
Methods
-------*/

public:

	bool SetQ(Qtree *Q);
	bool AllocateAll(bool,bool,bool,bool,bool,bool);

	//I
	CWMesh();
	bool init(char *lpszPathName);
	bool getTheMesh(char *);
	bool readBaseMesh(char *);
	bool lisCoeffs(char *);
	bool initQuadTree();
	bool getDAT(char *);
	bool getDAT(DatMesh *newDM);
	inline bool evaluate() {evaluateQueue(m_Q, m_Mesh);return true;}	/*--------------------------------------
																		cascade evaluation of vertices positions
																		--------------------------------------*/
	inline bool evaluate(Qtree*Q) {evaluateQueue(Q, m_Mesh);
								render(Q, m_Mesh);
								return true;}
	//O
	bool ecritBaseMesh(char*);
	bool ecritMesh(char*);
	bool ecritWV(char*);
	bool ecritDAT(char*);

	//Synthesis
	bool receptionCoeffLazy(int *Invite, int first, int last, double dist);
	bool completeRebuildNLB(int *Invite, int first, int last, double dist, int tension);

	//Analysis
	int LazyAnalysis();
	int ZDAnalysis();
	int ButterflyAnalysis();
	int LiftedButterflyAnalysis();
	int LoopAnalysis();

	//temporary methods
	bool MakeSphere(char *);

	//Utilities
	bool L2NormalizeCoeffs ();
	bool L2UnNormalizeCoeffs ();
	

	////////
	//Debug
	////////
	bool WriteTriangles(char *, char *);

	//GetSet
	bool copyMesh(Mesh *mesh);
	void SetBaseMesh(Mesh *mesh);
	int MakeConnectivity();

	//Translations
	bool moveQToDM();




	
private:
	
};
#endif