// proto.cpp: implementation of the Cproto class.
//
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include "proto.h"
#include "visu.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////

void getMesh(Mesh *mesh, char nom[512], unsigned int *text, char texture[512]) {
	char tmp[512];
	FILE *f;
	int i, j, n;
//	double u[3], v[3], w[3];
	unsigned int textured=0;

	/* Lecture du fichier contenant le maillage initial */

    /* Analyse syntaxique : recherche du maillage */

	if ((f=fopen(nom,"r"))==NULL) 
		fprintf(stderr,"main : can't read file\n");

	for (fscanf(f,"%s", tmp); strcmp(tmp, "point") && 
		strcmp(tmp, "texture"); fscanf(f,"%s", tmp)) ;
	
	if (strcmp(tmp, "point")) {
	//Si on a une texture
		textured=1;
		for (fscanf(f,"%s", tmp); strcmp(tmp, "url"); fscanf(f,"%s", tmp));
		fscanf(f, "%s", tmp);
		strncpy(texture, &(tmp[1]), strlen(tmp)-6);
		texture[strlen(tmp)-6]=0;

		//Comme si de rien n'tait...
		for (fscanf(f,"%s", tmp); strcmp(tmp, "point"); fscanf(f,"%s", tmp));
	}
	/* Lecture des sommets */
	
	for (i=0, fscanf(f, "%s", tmp); strcmp(tmp, "]"); i++) {
		mesh->SommetPresent[i]=1;
		mesh->FaceVoisine[i]=NULL;
		for (j=0; j<3; j++) fscanf(f, "%lf", &(mesh->Vertex[i][j]));
		fscanf(f, "%s", tmp);
	}
	
	mesh->NbVertex=i; 
	
    /* Lecture des facettes */

	for (fscanf(f,"%s", tmp); strcmp(tmp, "coordIndex"); fscanf(f,"%s", tmp)) ;

    for (i=0, fscanf(f, "%s", tmp); strcmp(tmp, "]"); i++) {
		mesh->FacePresente[i]=1;
		mesh->couleur[i]=7;
		for (j=0; j<3; j++) {
			fscanf(f, "%d", &n);
			mesh->Face[i][j]=n;
			ajouteFace(mesh, i, n);	/*Liste des voisins*/		
			fscanf(f, "%c", &tmp);
		}
		fscanf(f, "%d%c", &n, &tmp);
	}

	mesh->NbFace=i;

	// Lecture de la texture
	if (textured) {
		for (fscanf(f,"%s", tmp); strcmp(tmp, "point"); fscanf(f,"%s", tmp));
		for (i=0, fscanf(f, "%s", tmp); strcmp(tmp, "]"); i++) {
			for (j=0; j<2; j++) fscanf(f, "%lf", &(mesh->TexCoord[i][j]));
			fscanf(f, "%s", tmp);
		}
	}	

    fclose(f);

	*text=textured;

	//Ajout d'une normale par face
/*	for (i=0; i<mesh->NbFace; i++) {
		moins(mesh->Vertex[mesh->Face[i][1]],
			mesh->Vertex[mesh->Face[i][0]], u);
		moins(mesh->Vertex[mesh->Face[i][2]],
			mesh->Vertex[mesh->Face[i][0]], v);
		vect(u, v, w);
		normalize(w);
		egale(mesh->Normale[i], w);
	}*/
}

void getMesh2(Mesh *mesh, char nom[512], unsigned int *text, char texture[512]) {

	//Cause problme de parsing

	char tmp[512];
	char tmpc;
	FILE *f;
	int i, j, n;
//	double u[3], v[3], w[3];
	unsigned int textured=0;

	/* Lecture du fichier contenant le maillage initial */

    /* Analyse syntaxique : recherche du maillage */

	if ((f=fopen(nom,"r"))==NULL) 
		fprintf(stderr,"main : can't read file\n");

	for (fscanf(f,"%s", tmp); strcmp(tmp, "point") && 
		strcmp(tmp, "texture"); fscanf(f,"%s", tmp)) ;
	
	if (strcmp(tmp, "point")) {
	//Si on a une texture
		textured=1;
		for (fscanf(f,"%s", tmp); strcmp(tmp, "url"); fscanf(f,"%s", tmp));
		fscanf(f, "%s", tmp);
		strncpy(texture, &(tmp[1]), strlen(tmp)-6);
		texture[strlen(tmp)-6]=0;

		//Comme si de rien n'tait...
		for (fscanf(f,"%s", tmp); strcmp(tmp, "point"); fscanf(f,"%s", tmp));
	}
	/* Lecture des sommets */
	
	for (i=0, fscanf(f, "%s", tmp); strcmp(tmp, "]"); i++) {
		mesh->SommetPresent[i]=1;
		mesh->FaceVoisine[i]=NULL;
		for (j=0; j<3; j++) fscanf(f, "%lf", &(mesh->Vertex[i][j]));
		fscanf(f, "%s", tmp);
	}
	
	mesh->NbVertex=i; 
	
    /* Lecture des facettes */

	for (fscanf(f,"%s", tmp); strcmp(tmp, "coordIndex"); fscanf(f,"%s", tmp)) ;

    for (i=0, fscanf(f, "%s", tmp); /*strcmp(tmp, "]")*/tmpc!=']'; i++) {
		mesh->FacePresente[i]=1;
		mesh->couleur[i]=7;
		for (j=0; j<3; j++) {
			fscanf(f, "%d", &n);
			mesh->Face[i][j]=n;
			ajouteFace(mesh, i, n);	/*Liste des voisins*/		
			fscanf(f, "%c", &tmpc);
		}
		fscanf(f, "%d%c", &n, &tmpc);
	}

	mesh->NbFace=i;

	// Lecture de la texture
	if (textured) {
		for (fscanf(f,"%s", tmp); strcmp(tmp, "point"); fscanf(f,"%s", tmp));
		for (i=0, fscanf(f, "%s", tmp); strcmp(tmp, "]"); i++) {
			for (j=0; j<2; j++) fscanf(f, "%lf", &(mesh->TexCoord[i][j]));
			fscanf(f, "%s", tmp);
		}
	}	

    fclose(f);

	*text=textured;

	//Ajout d'une normale par face
/*	for (i=0; i<mesh->NbFace; i++) {
		moins(mesh->Vertex[mesh->Face[i][1]],
			mesh->Vertex[mesh->Face[i][0]], u);
		moins(mesh->Vertex[mesh->Face[i][2]],
			mesh->Vertex[mesh->Face[i][0]], v);
		vect(u, v, w);
		normalize(w);
		egale(mesh->Normale[i], w);
	}*/
}

void getMeshContact(Mesh *mesh, char nom[512], char dsif[512], char bsf[512]) {
	char tmp[512];
	char dsi[512];
	char bs[512];
	FILE *f;
	int i, j, n;
//	double u[3], v[3], w[3];
//	unsigned int textured=0;

	/* Lecture du fichier contenant le maillage initial */

    /* Analyse syntaxique : recherche du maillage */

	if ((f=fopen(nom,"r"))==NULL) 
		fprintf(stderr,"main : can't read file\n");


	//Fichiers config
	for (fscanf(f,"%s", tmp); strcmp(tmp, "DecoderSpecificInfo") ; fscanf(f,"%s", tmp)) ;	
	fscanf(f, "%s", dsi);
	for (fscanf(f,"%s", tmp); strcmp(tmp, "WSBitstream") ; fscanf(f,"%s", tmp)) ;	
	fscanf(f, "%s", bs);

	/* Lecture des sommets */
	for (fscanf(f,"%s", tmp); strcmp(tmp, "point") ; fscanf(f,"%s", tmp)) ;	
	for (i=0, fscanf(f, "%s", tmp); strcmp(tmp, "]"); i++) {
		for (j=0; j<3; j++) fscanf(f, "%lf", &(mesh->Vertex[i][j]));
		fscanf(f, "%s", tmp);
	}
	
	mesh->NbVertex=i; 
	
    /* Lecture des facettes */

	for (fscanf(f,"%s", tmp); strcmp(tmp, "coordIndex"); fscanf(f,"%s", tmp)) ;

    for (i=0, fscanf(f, "%s", tmp); strcmp(tmp, "]"); i++) {
		for (j=0; j<3; j++) {
			fscanf(f, "%d", &n);
			mesh->Face[i][j]=n;		
			fscanf(f, "%s", tmp);
		}
		fscanf(f, "%d%s", &n, tmp);
	}

	mesh->NbFace=i;

	

    fclose(f);

	strcpy(dsif, dsi);
	strcpy(bsf, bs);


}


void ajouteFace(Mesh *mesh, int face, int sommet) {
	Lint *ptr;

	if ((ptr=(Lint*)malloc(sizeof(Lint)))==NULL) fprintf(stderr, " ajouteFace : can't allocate memory");

	ptr->facette=face; 
	ptr->suivant=mesh->FaceVoisine[sommet];
	mesh->FaceVoisine[sommet]=ptr;
}

void lisCoeff(char entree[512], WaveRep *wr, Mesh *mzero, unsigned int *text, char texture[512]) {

	FILE *f=fopen(entree, "r");
	int i=0;
	unsigned int potiche;
	char deco[512];

	fscanf(f, "%s", wr->mzero);
	if (!strcmp(wr->mzero, "Texture")) {
		fscanf(f, "%s", texture);
		(*text)=1;
		fscanf(f, "%s", wr->mzero);
	} else {
		(*text)=0;
	}
	if ((wr->tab[i]=(WaveCo*)malloc(sizeof(WaveCo)))==NULL) fprintf(stderr, "lisCoeff : can't allocate memory");
	fscanf(f, "%d", &(wr->tab[0]->F0));
	while (wr->tab[i]->F0!=-1) {
		fscanf(f, "%d", &(wr->tab[i]->alpha));
		fscanf(f, "%d", &(wr->tab[i]->beta));
		fscanf(f, "%d", &(wr->tab[i]->gamma));
		//if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma>16) break; // Juste pour la demo pour limiter les niveaux
		fscanf(f, "%f", &(wr->tab[i]->x));
		fscanf(f, "%f", &(wr->tab[i]->y));
		fscanf(f, "%f", &(wr->tab[i]->z));
		if (*text) {
			fscanf(f, "%f", &(wr->tab[i]->u));
			fscanf(f, "%f", &(wr->tab[i]->v));
		}
		i++;
		if ((wr->tab[i]=(WaveCo*)malloc(sizeof(WaveCo)))==NULL) fprintf(stderr, "lisCoeff : can't allocate memory");
		fscanf(f, "%d", &(wr->tab[i]->F0));
	}
	wr->NbCoeff=i;
	getMesh(mzero, wr->mzero, &potiche, deco); 

}



void invMatLin(float mat[16], float inv[9]) {
	//Inverse la partie lineaire d'une matrice projective
	//Tout en ligne

	float det;

	det=inv[0]*(inv[5]*inv[10]-inv[9]*inv[6])+inv[4]*(inv[9]*inv[2]-inv[1]*inv[10])+inv[8]*(inv[1]*inv[6]-inv[5]*inv[2]);

	inv[0]=(inv[5]*inv[10]-inv[9]*inv[6])/det;
	inv[4]=(inv[6]*inv[8]-inv[4]*inv[10])/det;
	inv[8]=(inv[4]*inv[9]-inv[8]*inv[5])/det;
	inv[1]=(inv[9]*inv[2]-inv[1]*inv[10])/det;
	inv[5]=(inv[10]*inv[0]-inv[8]*inv[2])/det;
	inv[9]=(inv[0]*inv[9]-inv[8]*inv[1])/det;
	inv[2]=(inv[1]*inv[6]-inv[5]*inv[2])/det;
	inv[6]=(inv[2]*inv[4]-inv[0]*inv[6])/det;
	inv[10]=(inv[0]*inv[5]-inv[4]*inv[1])/det;

}

void lecture_m0(Mesh *mesh, char nom[512]) {
	char tmp[512];
	FILE *f;
	int i, j, n;

	/* Lecture du fichier contenant le maillage initial */

    /* Analyse syntaxique : recherche du maillage */

	if ((f=fopen(nom,"r"))==NULL) 
		fprintf(stderr,"main : can't read file\n");

	for (fscanf(f,"%s", tmp); strcmp(tmp, "point"); fscanf(f,"%s", tmp)) ;

	/* Lecture des sommets */
	
	for (i=0, fscanf(f, "%s", tmp); strcmp(tmp, "]"); i++) {
		mesh->SommetPresent[i]=1;
		mesh->FaceVoisine[i]=NULL;
		for (j=0; j<3; j++) fscanf(f, "%lf", &(mesh->Vertex[i][j]));
		fscanf(f, "%s", tmp);
	}
	
	mesh->NbVertex=i; 
	
    /* Lecture des facettes */

	for (fscanf(f,"%s", tmp); strcmp(tmp, "coordIndex"); fscanf(f,"%s", tmp)) ;

    for (i=0, fscanf(f, "%s", tmp); strcmp(tmp, "]"); i++) {
		mesh->FacePresente[i]=1;
		mesh->couleur[i]=7;
		for (j=0; j<3; j++) {
			fscanf(f, "%d", &n);
			mesh->Face[i][j]=n;
			ajouteFace(mesh, i, n);	/*Liste des voisins*/		
			fscanf(f, "%s", tmp);
		}
		fscanf(f, "%d%s", &n, tmp);
	}

    fclose(f);
	
	mesh->NbFace=i;

	fprintf(stderr,"Maillage initial: %d sommets et %d facettes \n", mesh->NbVertex, mesh->NbFace);

}

void ecriture(Mesh *mesh, FILE *g) {

	/* g doit etre ouvert */

	int i, j, n;

	/* Ecriture dans un fichier VRML2 */
	
	/* Entete */

    fprintf(g, "#VRML V2.0 utf8\n");   
	fprintf(g, "\n");
	fprintf(g, "Shape {\n");
	fprintf(g, "  appearance Appearance {\n");
	fprintf(g, "    material Material {\n");
	fprintf(g, "      diffuseColor 1.0 .8 .3\n");
	fprintf(g, "    }\n");
	fprintf(g, "  }\n");
	fprintf(g, "  geometry IndexedFaceSet {\n");
	fprintf(g, "    coord Coordinate {\n");
	fprintf(g, "      point [\n");

	/* Sommets */

    for (i=0; i<mesh->NbVertex; i++) {
		if (/*mesh->SommetPresent[i]*/1) {
			for (j=0; j<3; j++) fprintf(g, "%f ", mesh->Vertex[i][j]);
		}
		else {
			for (j=0; j<3; j++) fprintf(g, "0 ");
		}
		if (i<mesh->NbVertex-1) {
			fprintf(g, " ,\n");
		}
		else 
			fprintf(g, " \n]\n");
	}

	fprintf(g, "    }\n");
	fprintf(g, "    coordIndex [\n");

	/* Facettes */

    for (i=0; i<mesh->NbFace; i++) {
		if (/*mesh->FacePresente[i]*/1) {
			n=0;
			for (j=0; j<3; j++) {
				fprintf(g, "%d, ", mesh->Face[i][j]);
				n=mesh->Face[j][i];
			}         
			fprintf(g, "-1");
		}
		if (i<mesh->NbFace-1) {
			if (/*mesh->FacePresente[i]*/1) fprintf(g, ",\n"); 
		}
		else
			fprintf(g, "]\n");
	}

	fprintf(g, "  }\n");
	fprintf(g, "}\n");  




}

void ecritureColor(Mesh *mesh, FILE *g) {

	/* g doit etre ouvert */

	int i, j, n, R, G, B;

	/* Ecriture dans un fichier VRML2 */
	
	/* Entete */

    fprintf(g, "#VRML V2.0 utf8\n");   
	fprintf(g, "\n");
	fprintf(g, "Shape {\n");
	fprintf(g, "  appearance Appearance {\n");
	fprintf(g, "    material Material {\n");
	fprintf(g, "      diffuseColor 0 1.0 0\n");
	fprintf(g, "    }\n");
	fprintf(g, "  }\n");
	fprintf(g, "  geometry IndexedFaceSet {\n");
	fprintf(g, "    coord Coordinate {\n");
	fprintf(g, "      point [\n");

	/* Sommets */

    for (i=0; i<mesh->NbVertex; i++) {
		if (mesh->SommetPresent[i]) {
			for (j=0; j<3; j++) fprintf(g, "%f ", mesh->Vertex[i][j]);
		}
		else {
			for (j=0; j<3; j++) fprintf(g, "0 ");
		}
		if (i<mesh->NbVertex-1) {
			fprintf(g, " ,\n");
		}
		else 
			fprintf(g, " \n]\n");
	}

	fprintf(g, "    }\n");
	fprintf(g, "    coordIndex [\n");

	/* Facettes */

    for (i=0; i<mesh->NbFace; i++) {
		if (mesh->FacePresente[i]) {
			n=0;
			for (j=0; j<3; j++) {
				fprintf(g, "%d, ", mesh->Face[i][j]);
				n=mesh->Face[j][i];
			}         
			fprintf(g, "-1, ");
		}
		if (i<mesh->NbFace-1) {
			if (mesh->FacePresente[i]) fprintf(g, "\n"); 
		}
		else
			fprintf(g, " \n]\n");
	}

	/* Coloration des faces */

	fprintf(g, " color Color {\n");
	fprintf(g, "  color [\n");

	for (i=0; i<mesh->NbFace; i++) {
		if (mesh->FacePresente[i]!=0) {
			trouveCouleur2(mesh->couleur[i], &R, &G, &B);
			fprintf(g, "%d %d %d,\n", R, G, B);
		}
	}
	fprintf(g, "    ]\n  }\n colorPerVertex FALSE\n ");

	fprintf(g, "  }\n");
	fprintf(g, "}\n");  

	fclose(g);

	


}

void lisCoeffNoTexture(char entree[512], WaveRep *wr, Mesh *mzero) {

	FILE *f=fopen(entree, "r");
	int i=0;
	unsigned int potiche;
	char deco[512];

	fscanf(f, "%s", wr->mzero);
	if ((wr->tab[i]=(WaveCo*)malloc(sizeof(WaveCo)))==NULL) fprintf(stderr, "lisCoeff : can't allocate memory");
	fscanf(f, "%d", &(wr->tab[0]->F0));
	while (wr->tab[i]->F0!=-1) {
		fscanf(f, "%d", &(wr->tab[i]->alpha));
		fscanf(f, "%d", &(wr->tab[i]->beta));
		fscanf(f, "%d", &(wr->tab[i]->gamma));
		//if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma>16) break; // Juste pour la demo pour limiter les niveaux
		fscanf(f, "%f", &(wr->tab[i]->x));
		fscanf(f, "%f", &(wr->tab[i]->y));
		fscanf(f, "%f", &(wr->tab[i]->z));
		i++;
		if ((wr->tab[i]=(WaveCo*)malloc(sizeof(WaveCo)))==NULL) fprintf(stderr, "lisCoeff : can't allocate memory");
		fscanf(f, "%d", &(wr->tab[i]->F0));
	}
	wr->NbCoeff=i;
	getMesh(mzero, wr->mzero, &potiche, deco); 
	fclose(f);

}






