
#include <stdio.h>
#include "proto.h"
#include "Q.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif



void render(Qtree *Q, Mesh *mesh) {

	/* Ecrit le fichier VRML correspondant a l'arbre Q */

	int i;
	int position;

	/* Definition des sommets */


	for (i=0; i<Q->Top; i++) {
		mesh->Vertex[i][0]=/*Q->VertexTable[i]->fGeom[0]+*/Q->VertexTable[i]->g[0];
		mesh->Vertex[i][1]=/*Q->VertexTable[i]->fGeom[1]+*/Q->VertexTable[i]->g[1];
		mesh->Vertex[i][2]=/*Q->VertexTable[i]->fGeom[2]+*/Q->VertexTable[i]->g[2];

		mesh->TexCoord[i][0]=Q->VertexTable[i]->u;
		mesh->TexCoord[i][1]=Q->VertexTable[i]->v;
	}
	mesh->NbVertex=i;
	mesh->NbFace=0;
	
	/* Parcours des feuilles de Q pour la definition des faces */

	position=0;
	for (i=0; i<Q->NbRacine; i++) {
		ajoute(mesh, Q->racines[i], &position);
	}
}

void renderLight(Qtree *Q, Mesh *mesh) { 

	/* Ecrit le fichier VRML correspondant a l'arbre Q */
	// Alleg de la recopie des sommets

	int i;
//	int position;

	/* Definition des sommets */


	for (i=0; i<Q->Top; i++) {
		if (Q->VertexTable[i]!=NULL) {
			mesh->TexCoord[i][0]=Q->VertexTable[i]->u;
			mesh->TexCoord[i][1]=Q->VertexTable[i]->v;
		}
	}
	mesh->NbVertex=i;
//	mesh->NbFace=0;
	
	/* Parcours des feuilles de Q pour la definition des faces */

//	position=0;
//	for (i=0; i<Q->NbRacine; i++) {
//		ajoute(mesh, Q->racines[i], &position);
//	}
}

void ajoute(Mesh *mesh, Face_WSZT* face, int *position) {
	
	/* Fonction recursive */

	/* Si la face n'est pas une feuille */
	
	if (face->children[0]!=NULL) {
		ajoute(mesh, face->children[0], position);
		ajoute(mesh, face->children[1], position);
		ajoute(mesh, face->children[2], position);
		ajoute(mesh, face->children[3], position);
	}
	else {
		// Activation de *indice*
		face->indice=*position;

		mesh->Face[*position][0]=face->sommetCoin[0]->indice;
		mesh->Face[*position][1]=face->sommetCoin[1]->indice;
		mesh->Face[*position][2]=face->sommetCoin[2]->indice;
		(*position)++;
		mesh->NbFace++;
	}
}




void initQ4(Qtree *Q, Mesh *mesh) {
	
	// Va avec receptionCoeff4
	// Initialise les liste de coeff des facettes

	int i, j;       

	/* Extraction des sommets */

	for (i=0; i<mesh->NbVertex; i++) {
		if ((Q->VertexTable[i]=(Sommet*)malloc(sizeof(Sommet)))==NULL);// fprintf(stderr, " initQ : can't allocate memory");
		Q->VertexTable[i]->parentV[0]=Q->VertexTable[i]->parentV[1]=NULL;
		Q->VertexTable[i]->parentF[0]=Q->VertexTable[i]->parentF[1]=NULL;
		Q->VertexTable[i]->fGeom[0]=0;
		Q->VertexTable[i]->fGeom[1]=0;
		Q->VertexTable[i]->fGeom[2]=0;
		Q->VertexTable[i]->g[0]=mesh->Vertex[i][0];
		Q->VertexTable[i]->g[1]=mesh->Vertex[i][1];
		Q->VertexTable[i]->g[2]=mesh->Vertex[i][2];
		//Q->VertexTable[i]->hGeom[0][0]=;
		//Q->VertexTable[i]->hGeom[0][1]=mesh->Vertex[i][1];
		//Q->VertexTable[i]->hGeom[0][2]=mesh->Vertex[i][2];
		for (j=0; j<NbNiveauMax; j++) { 
			Q->VertexTable[i]->hGeom[j][0]=0;
			Q->VertexTable[i]->hGeom[j][1]=0;
			Q->VertexTable[i]->hGeom[j][2]=0;
		}
		Q->VertexTable[i]->indice=i;
		Q->VertexTable[i]->level=0;
	}
	Q->NbVertex=Q->Top=i;

	/* Initialisation des racines */

	for (i=0; i<mesh->NbFace; i++) {
		Face_WSZT *tmp;
		if ((tmp=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " initQ : can't allocate memory");
		tmp->children[0]=tmp->children[1]=tmp->children[2]=tmp->children[3]=NULL;
		tmp->sommetCoin[0]=Q->VertexTable[mesh->Face[i][0]];
		tmp->sommetCoin[1]=Q->VertexTable[mesh->Face[i][1]];
		tmp->sommetCoin[2]=Q->VertexTable[mesh->Face[i][2]];
		tmp->sommetArete[0]=tmp->sommetArete[1]=tmp->sommetArete[2]=NULL;
		tmp->indice=-1;
		if (tmp->sommetCoin[0]->parentF[0]==NULL)
			tmp->sommetCoin[0]->parentF[0]=tmp;
		else
			tmp->sommetCoin[0]->parentF[1]=tmp;
		if (tmp->sommetCoin[1]->parentF[0]==NULL)
			tmp->sommetCoin[1]->parentF[0]=tmp;
		else
			tmp->sommetCoin[1]->parentF[1]=tmp;
		if (tmp->sommetCoin[2]->parentF[0]==NULL)
			tmp->sommetCoin[2]->parentF[0]=tmp;
		else
			tmp->sommetCoin[2]->parentF[1]=tmp;
		tmp->level=0;
		//Normale (cacule systmatiquement pour les faces de niveau 0 et  la demande pour les autres niveaux).
		//double N[3], u[3], v[3];
		//moins(u, mesh->Vertex[mesh->Face[i][1]], mesh->Vertex[mesh->Face[i][0]]);
		//moins(v, mesh->Vertex[mesh->Face[i][2]], mesh->Vertex[mesh->Face[i][0]]);
		//vect(u, v, N);
		//normalize(N);
		//egale(mesh->Normale[i], N);
		Q->racines[i]=tmp;
	}
	Q->NbRacine=i;
//	Q->Top=i;
	Q->Remember=-1;

	/* Affectation des voisins */

	for (i=0; i<Q->NbRacine; i++) {
		for (j=0; j<3; j++) {
			Q->racines[i]->Voisins[j]=NULL;
		}
	}
	for (i=0; i<Q->NbRacine; i++) {
		for (j=0; j<Q->NbRacine; j++) {
			if (j!=i) {
				if (((Q->racines[i]->sommetCoin[0]==Q->racines[j]->sommetCoin[0])||
					(Q->racines[i]->sommetCoin[0]==Q->racines[j]->sommetCoin[1])||
					(Q->racines[i]->sommetCoin[0]==Q->racines[j]->sommetCoin[2]))&&
					((Q->racines[i]->sommetCoin[1]==Q->racines[j]->sommetCoin[0])||
					(Q->racines[i]->sommetCoin[1]==Q->racines[j]->sommetCoin[1])||
					(Q->racines[i]->sommetCoin[1]==Q->racines[j]->sommetCoin[2])))
					
					Q->racines[i]->Voisins[0]=Q->racines[j];

				if (((Q->racines[i]->sommetCoin[1]==Q->racines[j]->sommetCoin[0])||
					(Q->racines[i]->sommetCoin[1]==Q->racines[j]->sommetCoin[1])||
					(Q->racines[i]->sommetCoin[1]==Q->racines[j]->sommetCoin[2]))&&
					((Q->racines[i]->sommetCoin[2]==Q->racines[j]->sommetCoin[0])||
					(Q->racines[i]->sommetCoin[2]==Q->racines[j]->sommetCoin[1])||
					(Q->racines[i]->sommetCoin[2]==Q->racines[j]->sommetCoin[2])))
					
					Q->racines[i]->Voisins[1]=Q->racines[j];

				if (((Q->racines[i]->sommetCoin[2]==Q->racines[j]->sommetCoin[0])||
					(Q->racines[i]->sommetCoin[2]==Q->racines[j]->sommetCoin[1])||
					(Q->racines[i]->sommetCoin[2]==Q->racines[j]->sommetCoin[2]))&&
					((Q->racines[i]->sommetCoin[0]==Q->racines[j]->sommetCoin[0])||
					(Q->racines[i]->sommetCoin[0]==Q->racines[j]->sommetCoin[1])||
					(Q->racines[i]->sommetCoin[0]==Q->racines[j]->sommetCoin[2])))
					
					Q->racines[i]->Voisins[2]=Q->racines[j];
			}
		}
	}
	// Initialisation des listes de coefficients des facettes
	for (i=0; i<Q->NbRacine; i++)
		Q->racines[i]->Coeff_list=NULL;

	Q->Gap=NULL;
	Q->nouveaux=NULL;
}







void evaluateQueue(Qtree *Q, Mesh *mesh) {

	// Evaluation modifi pour le cas gnral



	int i, cl;
	QueueDeFace *qdf=(QueueDeFace *)malloc(sizeof(QueueDeFace));
	ListeDeFace *nouveau;
	Face_WSZT *cf;
	Sommet *v;


	// Creation de la queue de priorit
	nouveau=(ListeDeFace *)malloc(sizeof(ListeDeFace));
	nouveau->F=Q->racines[0];
	nouveau->next=NULL;
	qdf->debut=nouveau;
	qdf->fin=nouveau;
	for (i=1; i<Q->NbRacine; i++) { //(TIGER)
		nouveau=(ListeDeFace *)malloc(sizeof(ListeDeFace)); 
		nouveau->F=Q->racines[i];
		nouveau->next=NULL;
		qdf->fin->next=nouveau;
		qdf->fin=nouveau;
	}

	//mesh->NbFace=0;
	
	// UpDate
	while (qdf->debut!=NULL) {
		cf=qdf->debut->F;
		cl=cf->level;


		for (i=0; i<3; i++) {
				v=cf->sommetCoin[i];
				if (v->hGeom[cl][0]!=0 || v->hGeom[cl][1]!=0 || v->hGeom[cl][2]!=0) {
					v->fGeom[0]+=v->hGeom[cl][0];
					v->fGeom[1]+=v->hGeom[cl][1];
					v->fGeom[2]+=v->hGeom[cl][2];
					v->hGeom[cl][0]=v->hGeom[cl][1]=v->hGeom[cl][2]=0;
				}
			}

		if (cf->children[0]!=NULL) {			
			for (i=0; i<3; i++) {
				v=cf->sommetArete[i];
				if ((v->parentF[0]!=NULL && v->parentF[0]->children[0]!=NULL)
					&& (v->parentF[1]!=NULL && v->parentF[1]->children[0]!=NULL)) {
					v->fGeom[0]+=0.25*(v->parentV[0]->fGeom[0]+v->parentV[1]->fGeom[0]);
					v->fGeom[1]+=0.25*(v->parentV[0]->fGeom[1]+v->parentV[1]->fGeom[1]);
					v->fGeom[2]+=0.25*(v->parentV[0]->fGeom[2]+v->parentV[1]->fGeom[2]);
				} else {
					v->fGeom[0]+=0.5*(v->parentV[0]->fGeom[0]+v->parentV[1]->fGeom[0]);
					v->fGeom[1]+=0.5*(v->parentV[0]->fGeom[1]+v->parentV[1]->fGeom[1]);
					v->fGeom[2]+=0.5*(v->parentV[0]->fGeom[2]+v->parentV[1]->fGeom[2]);
				}
			}
			for (i=0; i<4; i++) {
				nouveau=(ListeDeFace *)(malloc(sizeof(ListeDeFace)));
				nouveau->F=cf->children[i];
				nouveau->next=NULL;
				qdf->fin->next=nouveau;
				qdf->fin=nouveau;
			}

		} else {// Feuille
			
			// Ajout a mesh
			if (cf->indice==-1) {
				if (mesh->FaceGap==NULL) {
					mesh->Face[mesh->NbFace][0]=cf->sommetCoin[0]->indice;
					mesh->Face[mesh->NbFace][1]=cf->sommetCoin[1]->indice;
					mesh->Face[mesh->NbFace][2]=cf->sommetCoin[2]->indice;
					mesh->FacePresente[mesh->NbFace]=1;
					cf->indice=mesh->NbFace;
					mesh->NbFace++;
				} else {
					PileDeFaces *lib=mesh->FaceGap;
					mesh->Face[mesh->FaceGap->face][0]=cf->sommetCoin[0]->indice;
					mesh->Face[mesh->FaceGap->face][1]=cf->sommetCoin[1]->indice;
					mesh->Face[mesh->FaceGap->face][2]=cf->sommetCoin[2]->indice;
					cf->indice=mesh->FaceGap->face;
					mesh->FacePresente[mesh->FaceGap->face]=1;
					mesh->FaceGap=mesh->FaceGap->next;
					free(lib);
				}
			}			
		}
		//Dpilement
		qdf->debut=qdf->debut->next;
	}

	// Dplacement gometrique
	for (i=0; i<Q->Top; i++) {

		if (Q->VertexTable[i]!=NULL && norm(Q->VertexTable[i]->fGeom)!=0) {

			Q->VertexTable[i]->g[0]+=Q->VertexTable[i]->fGeom[0];	
			Q->VertexTable[i]->g[1]+=Q->VertexTable[i]->fGeom[1];	
			Q->VertexTable[i]->g[2]+=Q->VertexTable[i]->fGeom[2];
			Q->VertexTable[i]->fGeom[0]=0.0;
			Q->VertexTable[i]->fGeom[1]=0.0;
			Q->VertexTable[i]->fGeom[2]=0.0;



			// Ici on fait une partie du boulot de render() 
			mesh->Vertex[i][0]=Q->VertexTable[i]->g[0];
			mesh->Vertex[i][1]=Q->VertexTable[i]->g[1];
			mesh->Vertex[i][2]=Q->VertexTable[i]->g[2];
		}
		
	}

	// Suite du boulot de render()
	PileDeSommets *tmp=Q->nouveaux, *lib=(PileDeSommets *)malloc(sizeof(PileDeSommets));;
	while (tmp!=NULL) {
		
			mesh->Vertex[tmp->sommet][0]=Q->VertexTable[tmp->sommet]->g[0];
			mesh->Vertex[tmp->sommet][1]=Q->VertexTable[tmp->sommet]->g[1];
			mesh->Vertex[tmp->sommet][2]=Q->VertexTable[tmp->sommet]->g[2];

		lib=tmp;
		tmp=tmp->next;
		free(lib);
	}
	Q->nouveaux=NULL;


}




void chCoord(int alpha, int beta, int gamma, int F0a[3], int F0b[3], int *alphares, int *betares, int *gammares) {
	
	// Changement de coordonnes affines entre faces partageant au moins un sommet
	// I
	// alpha, beta, gamma : coordonnes barycentriques entieres
	// F0a, F0b : tableaux[5] des faces de M0 en format DAT
	// O
	//alphares, betares, gammares :coordonnes changes
	
	int ind1, ind2;

	//Cas trivial
	if (F0a[0]==F0b[0] && F0a[1]==F0b[1] && F0a[2]==F0b[2]) {
		*alphares=alpha;
		*betares=beta;
		*gammares=gamma;
		return;
	}
		

	if (alpha+beta+gamma==1) { // Sommet de niveau 0
		ind1=2*(alpha==1)+3*(beta==1)+4*(gamma==1)-2;
		ind2=(F0a[ind1]==F0b[0])+2*(F0a[ind1]==F0b[1])+3*(F0a[ind1]==F0b[2]);
		switch(ind2) {
		case 1:
			*alphares=1;
			*betares=0;
			*gammares=0;
			return;
		case 2:
			*alphares=0;
			*betares=1;
			*gammares=0;
			return;
		case 3:
			*alphares=0;
			*betares=0;
			*gammares=1;
			return;
		}
		return;
	} else {
		if (F0a[0]==F0b[0] && F0a[1]==F0b[2]) {
			*alphares=alpha;
			*betares=gamma;
			*gammares=beta;
			return;
		}
		if (F0a[0]==F0b[1] && F0a[1]==F0b[0]) {
			*alphares=beta;
			*betares=alpha;
			*gammares=gamma;
			return;
		}
		if (F0a[0]==F0b[2] && F0a[1]==F0b[1]) {
			*alphares=gamma;
			*betares=beta;
			*gammares=alpha;
			return;
		}
		if (F0a[1]==F0b[0] && F0a[2]==F0b[2]) {
			*alphares=beta;
			*betares=alpha;
			*gammares=gamma;
			return;
		}
		if (F0a[1]==F0b[2] && F0a[2]==F0b[1]) {
			*alphares=alpha;
			*betares=gamma;
			*gammares=beta;
			return;
		}
		if (F0a[1]==F0b[1] && F0a[2]==F0b[0]) {
			*alphares=gamma;
			*betares=beta;
			*gammares=alpha;
			return;
		}
		if (F0a[0]==F0b[0] && F0a[2]==F0b[1]) {
			*alphares=alpha;
			*betares=gamma;
			*gammares=beta;
			return;
		}
		if (F0a[0]==F0b[2] && F0a[2]==F0b[0]) {
			*alphares=gamma;
			*betares=beta;
			*gammares=alpha;
			return;
		}
		if (F0a[0]==F0b[1] && F0a[2]==F0b[2]) {
			*alphares=beta;
			*betares=alpha;
			*gammares=gamma;
			return;
		}
		return;
	}
}

void getAncestors(Qtree *Q, WaveCo *wc, int *A1, int *A2) {

	//rcupre dans A1, A2 les fondements de la relation de parent entre sommets, en partant de p1

	(*A1)=(*A2)=-1;
	if (wc->alpha!=0) {
		(*A1)=Q->racines[wc->F0]->sommetCoin[0]->indice;
	}
	if (wc->beta!=0) {
		if ((*A1)==-1)
			(*A1)=Q->racines[wc->F0]->sommetCoin[1]->indice;
		else 
			(*A2)=Q->racines[wc->F0]->sommetCoin[1]->indice;
	}
	if (wc->gamma!=0) {
		if ((*A1)==-1)
			(*A1)=Q->racines[wc->F0]->sommetCoin[2]->indice;
		else 
			(*A2)=Q->racines[wc->F0]->sommetCoin[2]->indice;
	}
	
}

void getCommonFacet(Qtree *Q, int A1, int A2,int A3,int A4, int f3[3], unsigned int *F0) {
	//Renvoie la premire face f3 qui contient les quatre ancetres A1-A4.
	int i;

	for (i=0; i<Q->NbRacine; i++) {
		if ((A1==-1 || A1==Q->racines[i]->sommetCoin[0]->indice || A1==Q->racines[i]->sommetCoin[1]->indice || A1==Q->racines[i]->sommetCoin[2]->indice)&&
			(A2==-1 || A2==Q->racines[i]->sommetCoin[0]->indice || A2==Q->racines[i]->sommetCoin[1]->indice || A2==Q->racines[i]->sommetCoin[2]->indice)&&
			(A3==-1 || A3==Q->racines[i]->sommetCoin[0]->indice || A3==Q->racines[i]->sommetCoin[1]->indice || A3==Q->racines[i]->sommetCoin[2]->indice)&&
			(A4==-1 || A4==Q->racines[i]->sommetCoin[0]->indice || A4==Q->racines[i]->sommetCoin[1]->indice || A4==Q->racines[i]->sommetCoin[2]->indice)){
			f3[0]=Q->racines[i]->sommetCoin[0]->indice;
			f3[1]=Q->racines[i]->sommetCoin[1]->indice;
			f3[2]=Q->racines[i]->sommetCoin[2]->indice;
			*F0=i;
			return;
		}
	}
	return;

}

void getsetBaryFromParents(Qtree *Q, int i, WaveRep *wr) {
	Sommet *v, *p1, *p2;
	int level1, level2, alpha, beta, gamma, F0a, F0b, alphares1, betares1, gammares1, alphares2, betares2, gammares2, f1[3], f2[3], f3[3];
	int A1, A2, A3, A4, t1, t2, t3;


	//Clarity
	v=Q->VertexTable[i];
	p1=Q->VertexTable[i]->parentV[0];
	p2=Q->VertexTable[i]->parentV[1];
	level1=wr->tab[p1->indice]->alpha+wr->tab[p1->indice]->beta+wr->tab[p1->indice]->gamma;
	level2=wr->tab[p2->indice]->alpha+wr->tab[p2->indice]->beta+wr->tab[p2->indice]->gamma;
	F0a=wr->tab[p1->indice]->F0;
	F0b=wr->tab[p2->indice]->F0;

	//Si mme face (cas facile)
	if (F0a==F0b) {
		wr->tab[i]->F0=F0a;
		//Si mme niveau (cas facile)
		if (level1==level2) {
			alpha=wr->tab[p1->indice]->alpha+wr->tab[p2->indice]->alpha;
			beta=wr->tab[p1->indice]->beta+wr->tab[p2->indice]->beta;
			gamma=wr->tab[p1->indice]->gamma+wr->tab[p2->indice]->gamma;
		} else {
		//Si niveaux diffrents
			if (level1<level2) {
				t1=wr->tab[p1->indice]->alpha;
				t2=wr->tab[p1->indice]->beta;
				t3=wr->tab[p1->indice]->gamma;
				while (t1+t2+t3!=wr->tab[p2->indice]->alpha+wr->tab[p2->indice]->beta+wr->tab[p2->indice]->gamma) {
					t1*=2;
					t2*=2;
					t3*=2;
				}
				alpha=t1+wr->tab[p2->indice]->alpha;
				beta=t2+wr->tab[p2->indice]->beta;
				gamma=t3+wr->tab[p2->indice]->gamma;
			}
			if (level1>level2) {
				t1=wr->tab[p2->indice]->alpha;
				t2=wr->tab[p2->indice]->beta;
				t3=wr->tab[p2->indice]->gamma;
				while (t1+t2+t3!=wr->tab[p1->indice]->alpha+wr->tab[p1->indice]->beta+wr->tab[p1->indice]->gamma) {
					t1*=2;
					t2*=2;
					t3*=2;
				}
				alpha=t1+wr->tab[p1->indice]->alpha;
				beta=t2+wr->tab[p1->indice]->beta;
				gamma=t3+wr->tab[p1->indice]->gamma;
			}
		}
		
	}
	//Changement de face
	else {
		//Clarity
		f1[0]=Q->racines[F0a]->sommetCoin[0]->indice;
		f1[1]=Q->racines[F0a]->sommetCoin[1]->indice;
		f1[2]=Q->racines[F0a]->sommetCoin[2]->indice;
		f2[0]=Q->racines[F0b]->sommetCoin[0]->indice;
		f2[1]=Q->racines[F0b]->sommetCoin[1]->indice;
		f2[2]=Q->racines[F0b]->sommetCoin[2]->indice;

		// Basis change
		if (wr->tab[p1->indice]->alpha!=0 && wr->tab[p1->indice]->beta!=0 && wr->tab[p1->indice]->gamma!=0) {
			wr->tab[i]->F0=F0a;
			f3[0]=Q->racines[F0a]->sommetCoin[0]->indice;
			f3[1]=Q->racines[F0a]->sommetCoin[1]->indice;
			f3[2]=Q->racines[F0a]->sommetCoin[2]->indice;
			alphares1=wr->tab[p1->indice]->alpha;
			betares1=wr->tab[p1->indice]->beta;
			gammares1=wr->tab[p1->indice]->gamma;
			chCoord(wr->tab[p2->indice]->alpha, wr->tab[p2->indice]->beta, wr->tab[p2->indice]->gamma, f2, f3, &alphares2, &betares2, &gammares2);
		} else if (wr->tab[p2->indice]->alpha!=0 && wr->tab[p2->indice]->beta!=0 && wr->tab[p2->indice]->gamma!=0) {
			wr->tab[i]->F0=F0b;
			f3[0]=Q->racines[F0b]->sommetCoin[0]->indice;
			f3[1]=Q->racines[F0b]->sommetCoin[1]->indice;
			f3[2]=Q->racines[F0b]->sommetCoin[2]->indice;
			alphares2=wr->tab[p2->indice]->alpha;
			betares2=wr->tab[p2->indice]->beta;
			gammares2=wr->tab[p2->indice]->gamma;
			chCoord(wr->tab[p1->indice]->alpha, wr->tab[p1->indice]->beta, wr->tab[p1->indice]->gamma, f1, f3, &alphares1, &betares1, &gammares1);
		} else {
			getAncestors(Q, wr->tab[p1->indice], &A1, &A2);
			getAncestors(Q, wr->tab[p2->indice], &A3, &A4);
			getCommonFacet(Q, A1, A2, A3, A4, f3, &wr->tab[i]->F0);
			chCoord(wr->tab[p1->indice]->alpha, wr->tab[p1->indice]->beta, wr->tab[p1->indice]->gamma, f1, f3, &alphares1, &betares1, &gammares1);
			chCoord(wr->tab[p2->indice]->alpha, wr->tab[p2->indice]->beta, wr->tab[p2->indice]->gamma, f2, f3, &alphares2, &betares2, &gammares2);
		}

		//Nouvelles coordonnes
		level1=alphares1+betares1+gammares1;
		level2=alphares2+betares2+gammares2;
		//Si mme niveau
		if (level1==level2) {
			alpha=alphares1+alphares2;
			beta=betares1+betares2;
			gamma=gammares1+gammares2;
		} else {
		//Si niveaux diffrents
			if (level1<level2) {
				t1=alphares1;
				t2=betares1;
				t3=gammares1;
				while (t1+t2+t3!=alphares2+betares2+gammares2) {
					t1*=2;
					t2*=2;
					t3*=2;
				}
				alpha=t1+alphares2;
				beta=t2+betares2;
				gamma=t3+gammares2;
			}
			if (level1>level2) {
				t1=alphares2;
				t2=betares2;
				t3=gammares2;
				while (t1+t2+t3!=alphares1+betares1+gammares1) {
					t1*=2;
					t2*=2;
					t3*=2;
				}
				alpha=t1+alphares1;
				beta=t2+betares1;
				gamma=t3+gammares1;
			}
		}
	}

	//Rduction
	while (!(alpha%2) && !(beta%2) && !(gamma%2)) {
		alpha/=2;
		beta/=2;
		gamma/=2;
	}

	//Affectation
	wr->tab[i]->alpha=alpha;
	wr->tab[i]->beta=beta;
	wr->tab[i]->gamma=gamma;
	wr->tab[i]->x=Q->VertexTable[i]->g[0];
	wr->tab[i]->y=Q->VertexTable[i]->g[1];
	wr->tab[i]->z=Q->VertexTable[i]->g[2];



}

void copyQVerticesToWr(Qtree *Q, WaveRep *wr, Mesh *M0) {
	
	int vertexIndex;
	int niveau, niveaumax, racineIndex;

	wr->NbCoeff=Q->Top;

	//Rappel du niveau max
	niveaumax=0;
	Face_WSZT *f=Q->racines[0]->children[0];
	while (f) {
		f=f->children[0];
		niveaumax++;
	}


	// Niveau 0
	for (vertexIndex=0; vertexIndex<Q->Top; vertexIndex++) {
		if (Q->VertexTable[vertexIndex]->level==0) {
			//recherche de la facette
			for (racineIndex=0; racineIndex<Q->NbRacine; racineIndex++) {
				if (vertexIndex==Q->racines[racineIndex]->sommetCoin[0]->indice) {
					wr->tab[vertexIndex]->F0=racineIndex;
					wr->tab[vertexIndex]->alpha=1;
					wr->tab[vertexIndex]->beta=0;
					wr->tab[vertexIndex]->gamma=0;
					racineIndex=Q->NbRacine;
				} else 
				if (vertexIndex==Q->racines[racineIndex]->sommetCoin[1]->indice) {
					wr->tab[vertexIndex]->F0=racineIndex;
					wr->tab[vertexIndex]->alpha=0;
					wr->tab[vertexIndex]->beta=1;
					wr->tab[vertexIndex]->gamma=0;
					racineIndex=Q->NbRacine;
				} else
				if (vertexIndex==Q->racines[racineIndex]->sommetCoin[2]->indice) {
					wr->tab[vertexIndex]->F0=racineIndex;
					wr->tab[vertexIndex]->alpha=0;
					wr->tab[vertexIndex]->beta=0;
					wr->tab[vertexIndex]->gamma=1;
					racineIndex=Q->NbRacine;
				}
			}
		}
	}
	// Autres niveaux
	for (niveau=1; niveau<niveaumax+1; niveau++) {
		for (vertexIndex=0; vertexIndex<Q->Top; vertexIndex++) {
			if (Q->VertexTable[vertexIndex]->level==niveau) {
				getsetBaryFromParents(Q, vertexIndex, wr);
			}
		}
	}
	
}

void recSubdivide(Qtree* Q, Face_WSZT*f, int jmax, int j) {
	
	void divise21(Qtree*, Face_WSZT*);
	
	if (j==jmax)
		return;

	divise21(Q, f);

	recSubdivide(Q, f->children[0], jmax, j+1);
	recSubdivide(Q, f->children[1], jmax, j+1);
	recSubdivide(Q, f->children[2], jmax, j+1);
	recSubdivide(Q, f->children[3], jmax, j+1);
}

void subdivideAtLevel(Qtree *Q, int jmax) {
	int i;
	
	for (i=0; i<Q->NbRacine; i++) {
		recSubdivide(Q, Q->racines[i], jmax, 0);
	}
}

