#include "ZTEncDec.h"


ZTEncDec::ZTEncDec() {

	wmesh= new CWMesh;
	ZT=NULL;
	m_EC=NULL;
	processType=FALSE; 
	inputType=FALSE;  
	outputType=FALSE;
}

bool ZTEncDec::MoveQToDM() {

	wmesh->moveQToDM();

	return true;
}






bool ZTEncDec::ZTDecode() {

	return TRUE;
}

bool ZTEncDec::ZTDecode(char *inputfile, char *DSIfile) {

	if (ZT==NULL)
		ZT=new zerotree;
	ZT->decodemp4_conf(inputfile, DSIfile, wmesh->m_baseMesh);

	return true;
}

bool ZTEncDec::ZTDecode(unsigned char *inputstream, int streamlength) {

	//ZT must exist and have a DSI

	if (ZT->m_EC==NULL)
		return FALSE;
	ZT->decodemp4_conf(inputstream, streamlength, wmesh->m_baseMesh);

	return true;
}

bool ZTEncDec::ZTDecode_loc(unsigned char *inputstream, int streamlength, int NbCoeffs) {

	//ZT must exist and have a DSI

	if (ZT->m_EC==NULL)
		return FALSE;
	ZT->decodemp4_conf_loc(inputstream, streamlength, wmesh->m_baseMesh, NbCoeffs);

	return true;
}

int ZTEncDec::ZTDecode_generic(unsigned char *inputstream, int streamlength, int NbCoeffs) {

	//Local, for both partial and complette transmition
	//ZT must exist and have a DSI

	if (ZT->m_EC==NULL)
		return -2;
	return ZT->mp4decode(inputstream, streamlength, wmesh->m_baseMesh, NbCoeffs);

}

bool ZTEncDec::MoveZToMesh(CWMesh *wmesh) {

	//Allocation ventuelles
	if (wmesh==NULL)
		wmesh = new CWMesh;
	if (wmesh->DM==NULL)
		wmesh->DM=(DatMesh*)malloc(sizeof(DatMesh));
	if (wmesh->m_pWr==NULL)
		wmesh->m_pWr=(WaveRep*)malloc(sizeof(WaveRep));
	if (wmesh->m_Q==NULL)
		wmesh->m_Q=(Qtree*)malloc(sizeof(Qtree));
	wmesh->copyMesh(wmesh->m_baseMesh);



	wmesh->initQuadTree();
	wmesh->evaluate();

	ZT->dumpZ2Dat(wmesh->DM);

	
	Dat2Bary(wmesh->DM, ZT->m_nbvertex, ZT->m_nbtriangle, wmesh->m_pWr);

	//Temporaire
	wmesh->L2NormalizeCoeffs();

	return true;
}

bool ZTEncDec::LoadMesh(char *inputWRLfile) {

	return wmesh->getTheMesh(inputWRLfile);


}

bool ZTEncDec::SetDSI(char *filename) {
	if (ZT==NULL)
		return FALSE;
	if (ZT->m_EC!=NULL)
		delete ZT->m_EC;
	ZT->m_EC=new EncoderConfig(filename, 0);

	return true;
}

bool ZTEncDec::writeEncoded(char *filename_wo_ext, unsigned char *stream, int nbbytes) { 

	char m0[512], dsi[512], streamf[512];
	FILE *f;
	// A utiliser aprs une encodage en mmoire, pour sortir dans des fichiers

	//Ecriture du maillage de base
	
	strcpy(m0, filename_wo_ext);
	strcat(m0, ".wrl");
	wmesh->m_baseMesh=ZT->GetBaseMesh();
	wmesh->ecritBaseMesh(m0);

	//Ecriture du DSI

	strcpy(dsi, filename_wo_ext);
	ZT->writeDSI(dsi);

	//Ecriture du flux
	strcpy(streamf, filename_wo_ext);
	strcat(streamf, ".mp4");
	f=fopen(streamf, "wb");
	for (int i=0; i<nbbytes; i++) {
		fprintf(f, "%c", stream[i]);
	}
	fclose(f);


	return true;

}

bool ZTEncDec::writeEncoded(char *filename_wo_ext, Mesh *BM, unsigned char *stream, int nbbytes) { 

	char m0[512], dsi[512], streamf[512];
	FILE *f;
	// A utiliser aprs une encodage en mmoire, pour sortir dans des fichiers

	//Ecriture du maillage de base
	
	strcpy(m0, filename_wo_ext);
	strcat(m0, ".wrl");
	wmesh->m_baseMesh=BM;
	wmesh->ecritBaseMesh(m0);

	//Ecriture du DSI

	strcpy(dsi, filename_wo_ext);
	ZT->writeDSI(dsi);

	//Ecriture du flux
	strcpy(streamf, filename_wo_ext);
	strcat(streamf, ".mp4");
	f=fopen(streamf, "wb");
	for (int i=0; i<nbbytes; i++) {
		fprintf(f, "%c", stream[i]);
	}
	fclose(f);


	return true;

}



int ZTEncDec::MakeBitsreamFromBinaryAndBSD(unsigned char* inputbinary, BSD* BSDesc, unsigned char* outputstream, int& bufsize) {

	int nbbits;
	int FT, LT;
	mbitstream m_o(outputstream);
	mbitstream m_i(inputbinary);

	//Header
	m_o.writebit(m_EC->isBase);
	ZT->m_statout++;

	//isInLocalCoordinates
	m_o.writebit(m_EC->isInLocalCoordinates);
	ZT->m_statout++;

	//Scale Coeffs
	if (m_EC->isBase && m_EC->hasScaleCoeff)
		ZT->threeD_Wavelet_Mesh_Object_Scale_coeff();//See the spec

	
	//Class ReadZT (see the spec)

	//LengthNbBits
	m_EC->LengthNbBits=log2(BSDesc->BPlengthMax)+1;
	m_o.writenbit((unsigned short int)m_EC->LengthNbBits,5);
	ZT->m_statout+=5;

	//FBP
	m_o.writenbit((unsigned char)m_EC->FBP,5);

	//LBP
	m_o.writenbit((unsigned char)m_EC->LBP,5);

	//bit(1) X;
	m_o.writebit(m_EC->X);
	ZT->m_statout++;

	//bit(1) Y;
	m_o.writebit(m_EC->Y);
	ZT->m_statout++;

	//bit(1) Z;
	m_o.writebit(m_EC->Z);
	ZT->m_statout++;

	//isPartial
	m_o.writebit(m_EC->isPartial);
	ZT->m_statout++;

	//NbZT
	//m_o.writenbit((unsigned short int)m_nbsub_zerotree,16);

	if (m_EC->isPartial) {
		FT = 0;
		LT = 1;//temporaire
		m_o.writenbit((unsigned char)FT,16);
	} else { // Full transmission
		FT = 0;
		LT = BSDesc->nbroots;
	}


	for (int j=m_EC->LBP; j>=m_EC->FBP; j--) {
		for (int i=0; i<BSDesc->nbroots; i++) {

		
			if (m_EC->X && i>=FT && i<=LT) {
				
						

				//Encodage
				nbbits = BSDesc->roots[i]->BPD[m_EC->LBP-j]->lengthX;
				ZT->m_statin+=nbbits;

				//BPLength
				m_o.writenbit((unsigned short)nbbits,m_EC->LengthNbBits);
				ZT->m_statout+=m_EC->LengthNbBits;

				//Readplane
				if (nbbits!=0)
					m_i.dump(m_o, BSDesc->roots[i]->BPD[m_EC->LBP-j]->offsetX, nbbits);
								

			}
			

			if (m_EC->Y && i>=FT && i<=LT) {


				//Encodage
				nbbits = BSDesc->roots[i]->BPD[m_EC->LBP-j]->lengthY;
				ZT->m_statin+=nbbits;

				//BPLength
				m_o.writenbit((unsigned short)nbbits,m_EC->LengthNbBits);
				ZT->m_statout+=m_EC->LengthNbBits;

				//Readplane
				if (nbbits!=0)
					m_i.dump(m_o, BSDesc->roots[i]->BPD[m_EC->LBP-j]->offsetY, nbbits);
				
				

			}

		

			if (m_EC->Z && i>=FT && i<=LT) {
				


				//Encodage
				nbbits = BSDesc->roots[i]->BPD[m_EC->LBP-j]->lengthZ;
				ZT->m_statin+=nbbits;

				//BPLength
				m_o.writenbit((unsigned short)nbbits,m_EC->LengthNbBits);
				ZT->m_statout+=m_EC->LengthNbBits;

				//Readplane
				if (nbbits!=0)
					m_i.dump(m_o, BSDesc->roots[i]->BPD[m_EC->LBP-j]->offsetZ, nbbits);
				

				

			}
		}
	}
		
	m_o.close();
	
	outputstream=m_o.octets;
	bufsize=m_o.top;

	return true;
}

int ZTEncDec::MakeBitsreamFromBinaryAndBSDPartial(int ztnb, unsigned char* inputbinary, BSD* BSDesc, unsigned char* outputstream, int& bufsize) {

	int nbbits;
	int FT, LT;
	mbitstream m_o(outputstream);
	mbitstream m_i(inputbinary);

	//Header
	m_o.writebit(m_EC->isBase);
	ZT->m_statout++;

	//isInLocalCoordinates
	m_o.writebit(m_EC->isInLocalCoordinates);
	ZT->m_statout++;

	//Scale Coeffs
	if (m_EC->isBase && m_EC->hasScaleCoeff)
		ZT->threeD_Wavelet_Mesh_Object_Scale_coeff();//See the spec

	
	//Class ReadZT (see the spec)

	//LengthNbBits
	m_EC->LengthNbBits=log2(BSDesc->BPlengthMax)+1;
	m_o.writenbit((unsigned short int)m_EC->LengthNbBits,5);
	ZT->m_statout+=5;

	//FBP
	m_o.writenbit((unsigned char)m_EC->FBP,5);

	//LBP
	m_o.writenbit((unsigned char)m_EC->LBP,5);

	//bit(1) X;
	m_o.writebit(m_EC->X);
	ZT->m_statout++;

	//bit(1) Y;
	m_o.writebit(m_EC->Y);
	ZT->m_statout++;

	//bit(1) Z;
	m_o.writebit(m_EC->Z);
	ZT->m_statout++;

	//isPartial
	m_o.writebit(m_EC->isPartial);
	ZT->m_statout++;

	//NbZT
	//m_o.writenbit((unsigned short int)m_nbsub_zerotree,16);

	if (m_EC->isPartial) {
		FT = ztnb;
		LT = ztnb;//temporaire
		m_o.writenbit((unsigned char)FT,16);
	} else { // Full transmission
		FT = 0;
		LT = BSDesc->nbroots;
	}


	for (int j=m_EC->LBP; j>=m_EC->FBP; j--) {
		for (int i=FT; i<=LT; i++) {

		
			if (m_EC->X && i>=FT && i<=LT) {
				
						

				//Encodage
				nbbits = BSDesc->roots[i]->BPD[m_EC->LBP-j]->lengthX;
				ZT->m_statin+=nbbits;

				//BPLength
				m_o.writenbit((unsigned short)nbbits,m_EC->LengthNbBits);
				ZT->m_statout+=m_EC->LengthNbBits;

				//Readplane
				if (nbbits!=0)
					m_i.dump(m_o, BSDesc->roots[i]->BPD[m_EC->LBP-j]->offsetX, nbbits);
								

			}
			

			if (m_EC->Y && i>=FT && i<=LT) {


				//Encodage
				nbbits = BSDesc->roots[i]->BPD[m_EC->LBP-j]->lengthY;
				ZT->m_statin+=nbbits;

				//BPLength
				m_o.writenbit((unsigned short)nbbits,m_EC->LengthNbBits);
				ZT->m_statout+=m_EC->LengthNbBits;

				//Readplane
				if (nbbits!=0)
					m_i.dump(m_o, BSDesc->roots[i]->BPD[m_EC->LBP-j]->offsetY, nbbits);
				
				

			}

		

			if (m_EC->Z && i>=FT && i<=LT) {
				


				//Encodage
				nbbits = BSDesc->roots[i]->BPD[m_EC->LBP-j]->lengthZ;
				ZT->m_statin+=nbbits;

				//BPLength
				m_o.writenbit((unsigned short)nbbits,m_EC->LengthNbBits);
				ZT->m_statout+=m_EC->LengthNbBits;

				//Readplane
				if (nbbits!=0)
					m_i.dump(m_o, BSDesc->roots[i]->BPD[m_EC->LBP-j]->offsetZ, nbbits);
				

				

			}
		}
	}
		
	m_o.close();
	
	outputstream=m_o.octets;
	bufsize=m_o.top;

	return true;
}

int ZTEncDec::MoveLocZToWV(CWMesh* wmesh) {

	//Allocation ventuelles
	if (wmesh==NULL)
		wmesh = new CWMesh;
	if (wmesh->m_pWr==NULL)
		wmesh->m_pWr=(WaveRep*)malloc(sizeof(WaveRep));
	if (wmesh->m_Q==NULL)
		wmesh->m_Q=(Qtree*)malloc(sizeof(Qtree));

	wmesh->copyMesh(wmesh->m_baseMesh);

	

	wmesh->initQuadTree();
	wmesh->evaluate();

	ZT->dumpZ2WR(wmesh->m_pWr, wmesh->m_baseMesh);

	//Temporaire
	//wmesh->L2NormalizeCoeffs();

	return 0;

}

int ZTEncDec::getComponent(unsigned short ztid, unsigned short composante, unsigned int& nbCoeff, unsigned char& bitplane, int *baryCoord[4], float* Z) {

int i, k;
	noeudcoeff_loc* ncroot;

	//Initialisation de la file
	ncroot=ZT->getTreeCoeffLoc();
	for (i=0; i<=ztid; i++) {
		ncroot=ncroot->m_frere->m_frere;
	}

	//On rcurse sur chaque root
	ZT->recMoveCoeffs(ncroot, composante, baryCoord, Z, nbCoeff);

	return 0;
}
