

#include <stdio.h>
#include "proto.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


void lowPassRecButterfly(Qtree *Q, Face_WSZT*face) {
	//Anciennement divise21()

	// Low pass reconstruction filter for Loop scheme

	// (Va avec accomodate2 (sommets etiquets avec les coefficients))
	// Place les nouveaux sommets entre leurs parents

	Face_WSZT*fille1, *fille2, *fille3, *fille4;
	Sommet *fils1, *fils2, *fils3;
	int ticket, arete, critere, i;
	void harvest(Sommet *);
	void spread(Sommet *);

	/* Allocation familliale */

	if ((fille1=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");
	if ((fille2=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");
	if ((fille3=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");
	if ((fille4=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");

	//liste vides
	fille1->Coeff_list=fille2->Coeff_list=fille3->Coeff_list=fille4->Coeff_list=NULL;

	/* Allocation eventuelle des nouveaux sommets, suivant qu'il ont deja ete crees */
	/* dans une autre facette ou pas */

	/* Premier sommet */

	ticket=0;
	
	if (face->Voisins[0]==NULL) ticket=1; /* On va creer le sommet */
	else {
		if (face->Voisins[0]->children[0]==NULL) ticket=1;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[0])+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[1])*2+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On affecte le soi disant nouveau point a sa vraie valeur */

			fils1=face->Voisins[0]->sommetArete[arete];

			// Et on oublie pas de mettre  jour parentF !!!
			fils1->parentF[0]=face;
			fils1->parentF[1]=face->Voisins[0];
		}
	}

	if (ticket==1) {
		if ((fils1=(Sommet*)malloc(sizeof(Sommet)))==NULL) fprintf(stderr, " divise : can't allocate memory");

		if (Q->Gap==NULL) {
			Q->VertexTable[Q->Top]=fils1;
			fils1->indice=Q->Top;
			Q->Top++;
		} else {
			Q->VertexTable[Q->Gap->sommet]=fils1;
			fils1->indice=Q->Gap->sommet;
			// On depile Gap
			PileDeSommets *tmp=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			tmp=Q->Gap;
			Q->Gap=Q->Gap->next;
			free(tmp);
		}

		// Affectation dans Q->nouveaux
		PileDeSommets *PDS=(PileDeSommets *)malloc(sizeof(PileDeSommets));
		PDS->sommet=fils1->indice;
		PDS->next=Q->nouveaux;
		Q->nouveaux=PDS;

		fils1->parentV[0]=face->sommetCoin[0];
		fils1->parentV[1]=face->sommetCoin[1];

		fils1->parentF[0]=face;	
		fils1->parentF[1]=face->Voisins[0];

		fils1->u=0.5*(fils1->parentV[0]->u+fils1->parentV[1]->u);
		fils1->v=0.5*(fils1->parentV[0]->v+fils1->parentV[1]->v);
		
		fils1->g[0]=0.5*(fils1->parentV[0]->g[0]+fils1->parentV[1]->g[0]);
		fils1->g[1]=0.5*(fils1->parentV[0]->g[1]+fils1->parentV[1]->g[1]);
		fils1->g[2]=0.5*(fils1->parentV[0]->g[2]+fils1->parentV[1]->g[2]);

		fils1->fGeom[0]=0;
		fils1->fGeom[1]=0;
		fils1->fGeom[2]=0;

		fils1->level=face->level+1;


		for (i=0; i<NbNiveauMax; i++) {
			fils1->hGeom[i][0]=0; 
			fils1->hGeom[i][1]=0; 
			fils1->hGeom[i][2]=0; 
		}
	}

	/* Deuxieme sommet */

	ticket=0;
	
	if (face->Voisins[1]==NULL) ticket=1; /* On va creer le sommet */
	else {
		if (face->Voisins[1]->children[0]==NULL) ticket=1;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[0])+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[1])*2+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On affecte le soi disant nouveau point a sa vraie valeur */

			fils2=face->Voisins[1]->sommetArete[arete];

			// Et on oublie pas de mettre  jour parentF !!!
			fils2->parentF[0]=face;
			fils2->parentF[1]=face->Voisins[1];

		}
	}

	if (ticket==1) {
		
		if ((fils2=(Sommet*)malloc(sizeof(Sommet)))==NULL) fprintf(stderr, " divise : can't allocate memory");

		if (Q->Gap==NULL) {
			Q->VertexTable[Q->Top]=fils2;
			fils2->indice=Q->Top;
			Q->Top++;
		} else {
			Q->VertexTable[Q->Gap->sommet]=fils2;
			fils2->indice=Q->Gap->sommet;
			// On depile Gap
			PileDeSommets *tmp=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			tmp=Q->Gap;
			Q->Gap=Q->Gap->next;
			free(tmp);
		}

		// Affectation dans Q->nouveaux
		PileDeSommets *PDS=(PileDeSommets *)malloc(sizeof(PileDeSommets));
		PDS->sommet=fils2->indice;
		PDS->next=Q->nouveaux;
		Q->nouveaux=PDS;

		fils2->parentV[0]=face->sommetCoin[1];
		fils2->parentV[1]=face->sommetCoin[2];

		fils2->parentF[0]=face;
		fils2->parentF[1]=face->Voisins[1];

		fils2->u=0.5*(fils2->parentV[0]->u+fils2->parentV[1]->u);
		fils2->v=0.5*(fils2->parentV[0]->v+fils2->parentV[1]->v);

		fils2->g[0]=0.5*(fils2->parentV[0]->g[0]+fils2->parentV[1]->g[0]);
		fils2->g[1]=0.5*(fils2->parentV[0]->g[1]+fils2->parentV[1]->g[1]);
		fils2->g[2]=0.5*(fils2->parentV[0]->g[2]+fils2->parentV[1]->g[2]);

		fils2->fGeom[0]=0;
		fils2->fGeom[1]=0;
		fils2->fGeom[2]=0;

		fils2->level=face->level+1;

		for (i=0; i<NbNiveauMax; i++) {
			fils2->hGeom[i][0]=0; 
			fils2->hGeom[i][1]=0; 
			fils2->hGeom[i][2]=0; 
		}
	}
	

	/* Troisieme sommet */

	ticket=0;
	
	if (face->Voisins[2]==NULL) ticket=1; /* On va creer le sommet */
	else {
		if (face->Voisins[2]->children[0]==NULL) ticket=1;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[0])+
					(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[1])*2+
					(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On affecte le soi disant nouveau point a sa vraie valeur */

			fils3=face->Voisins[2]->sommetArete[arete];

			// Et on oublie pas de mettre  jour parentF !!!
			fils3->parentF[0]=face;
			fils3->parentF[1]=face->Voisins[2];
		}
	}

	if (ticket==1) {

		if ((fils3=(Sommet*)malloc(sizeof(Sommet)))==NULL) fprintf(stderr, " divise : can't allocate memory");

		if (Q->Gap==NULL) {
			Q->VertexTable[Q->Top]=fils3;
			fils3->indice=Q->Top;
			Q->Top++;
		} else {
			Q->VertexTable[Q->Gap->sommet]=fils3;
			fils3->indice=Q->Gap->sommet;
			// On depile Gap
			PileDeSommets *tmp=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			tmp=Q->Gap;
			Q->Gap=Q->Gap->next;
			free(tmp);
		}

		// Affectation dans Q->nouveaux
		PileDeSommets *PDS=(PileDeSommets *)malloc(sizeof(PileDeSommets));
		PDS->sommet=fils3->indice;
		PDS->next=Q->nouveaux;
		Q->nouveaux=PDS;

		fils3->parentV[0]=face->sommetCoin[2];
		fils3->parentV[1]=face->sommetCoin[0];

		fils3->parentF[0]=face;
		fils3->parentF[1]=face->Voisins[2];

		fils3->u=0.5*(fils3->parentV[0]->u+fils3->parentV[1]->u);
		fils3->v=0.5*(fils3->parentV[0]->v+fils3->parentV[1]->v);

		fils3->g[0]=0.5*(fils3->parentV[0]->g[0]+fils3->parentV[1]->g[0]);
		fils3->g[1]=0.5*(fils3->parentV[0]->g[1]+fils3->parentV[1]->g[1]);
		fils3->g[2]=0.5*(fils3->parentV[0]->g[2]+fils3->parentV[1]->g[2]);

		fils3->fGeom[0]=0;
		fils3->fGeom[1]=0;
		fils3->fGeom[2]=0;

		fils3->level=face->level+1;

		for (i=0; i<NbNiveauMax; i++) {
			fils3->hGeom[i][0]=0; 
			fils3->hGeom[i][1]=0; 
			fils3->hGeom[i][2]=0; 
		}
	}

	/* Mise a jour des champs des filles */

	/* Premiere fille */

	fille1->level=(face->level)+1;

	fille1->children[0]=NULL;
	fille1->children[1]=NULL;
	fille1->children[2]=NULL;
	fille1->children[3]=NULL;

	fille1->sommetCoin[0]=face->sommetCoin[0];
	fille1->sommetCoin[1]=fils1;
	fille1->sommetCoin[2]=fils3;

	fille1->sommetArete[0]=NULL;
	fille1->sommetArete[1]=NULL;
	fille1->sommetArete[2]=NULL;

	fille1->indice=-1;

		/* Voisins */

	fille1->Voisins[1]=fille4;

		/* Pour les autres, on regarde les orientations des voisins */

	if (face->Voisins[0]==NULL) fille1->Voisins[0]=NULL;
	else {
		if (face->Voisins[0]->children[0]==NULL) fille1->Voisins[0]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[0])+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[1])*2+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=0;
				break;
			case 2:
				arete=1;
				break;
			case 4:
				arete=2;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille1->Voisins[0]=face->Voisins[0]->children[arete];
			switch(arete) {
			case 0:
				fille1->Voisins[0]->Voisins[2]=fille1;
				break;
			case 1:
				fille1->Voisins[0]->Voisins[0]=fille1;
				break;
			case 2:
				fille1->Voisins[0]->Voisins[1]=fille1;
				break;
			}
		}
	}

		/* Pour l'autre face */

	if (face->Voisins[2]==NULL) fille1->Voisins[2]=NULL;
	else {
		if (face->Voisins[2]->children[0]==NULL) fille1->Voisins[2]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[0]==face->Voisins[2]->sommetCoin[0])+
					(face->sommetCoin[0]==face->Voisins[2]->sommetCoin[1])*2+
					(face->sommetCoin[0]==face->Voisins[2]->sommetCoin[2])*4;
			switch(critere) { 
			case 1:
				arete=0;
				break;
			case 2:
				arete=1;
				break;
			case 4:
				arete=2;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille1->Voisins[2]=face->Voisins[2]->children[arete];
			switch(arete) {
			case 0:
				fille1->Voisins[2]->Voisins[0]=fille1;
				break;
			case 1:
				fille1->Voisins[2]->Voisins[1]=fille1;
				break;
			case 2:
				fille1->Voisins[2]->Voisins[2]=fille1;
				break;
			}
		}
	}


	fille2->level=(face->level)+1;

	fille2->children[0]=NULL;
	fille2->children[1]=NULL;
	fille2->children[2]=NULL;
	fille2->children[3]=NULL;

	fille2->sommetCoin[0]=fils1;
	fille2->sommetCoin[1]=face->sommetCoin[1];
	fille2->sommetCoin[2]=fils2;

	fille2->sommetArete[0]=NULL;
	fille2->sommetArete[1]=NULL;
	fille2->sommetArete[2]=NULL;

	fille2->indice=-1;

		/* Voisins */

	fille2->Voisins[2]=fille4;

		/* Pour les autres, on regarde les orientations des voisins */

	if (face->Voisins[0]==NULL) fille2->Voisins[0]=NULL;
	else {
		if (face->Voisins[0]->children[0]==NULL) fille2->Voisins[0]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[0])+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[1])*2+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille2->Voisins[0]=face->Voisins[0]->children[arete];
			switch(arete) {
			case 0:
				fille2->Voisins[0]->Voisins[0]=fille2;
				break;
			case 1:
				fille2->Voisins[0]->Voisins[1]=fille2;
				break;
			case 2:
				fille2->Voisins[0]->Voisins[2]=fille2;
				break;
			}
		}
	}

		/* Pour l'autre face */

	if (face->Voisins[1]==NULL) fille2->Voisins[1]=NULL;
	else {
		if (face->Voisins[1]->children[0]==NULL) fille2->Voisins[1]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[0])+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[1])*2+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[2])*4;
			switch(critere) { 
			case 1:
				arete=0;
				break;
			case 2:
				arete=1;
				break;
			case 4:
				arete=2;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille2->Voisins[1]=face->Voisins[1]->children[arete];
			switch(arete) {
			case 0:
				fille2->Voisins[1]->Voisins[2]=fille2;
				break;
			case 1:
				fille2->Voisins[1]->Voisins[0]=fille2;
				break;
			case 2:
				fille2->Voisins[1]->Voisins[1]=fille2;
				break;
			}
		}
	}


	fille3->level=(face->level)+1;

	fille3->children[0]=NULL;
	fille3->children[1]=NULL;
	fille3->children[2]=NULL;
	fille3->children[3]=NULL;

	fille3->sommetCoin[0]=fils3;
	fille3->sommetCoin[1]=fils2;
	fille3->sommetCoin[2]=face->sommetCoin[2];

	fille3->sommetArete[0]=NULL;
	fille3->sommetArete[1]=NULL;
	fille3->sommetArete[2]=NULL;

	fille3->indice=-1;

	/* Voisins */

	fille3->Voisins[0]=fille4;

		/* Pour les autres, on regarde les orientations des voisins */

	if (face->Voisins[1]==NULL) fille3->Voisins[1]=NULL;
	else {
		if (face->Voisins[1]->children[0]==NULL) fille3->Voisins[1]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[0])+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[1])*2+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille3->Voisins[1]=face->Voisins[1]->children[arete];
			switch(arete) {
			case 0:
				fille3->Voisins[1]->Voisins[0]=fille3;
				break;
			case 1:
				fille3->Voisins[1]->Voisins[1]=fille3;
				break;
			case 2:
				fille3->Voisins[1]->Voisins[2]=fille3;
				break;
			}
		}
	}

		/* Pour l'autre face */

	if (face->Voisins[2]==NULL) fille3->Voisins[2]=NULL;
	else {
		if (face->Voisins[2]->children[0]==NULL) fille3->Voisins[2]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[0])+
					(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[1])*2+
					(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[2])*4;
			switch(critere) { 
			case 1:
				arete=0;
				break;
			case 2:
				arete=1;
				break;
			case 4:
				arete=2;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille3->Voisins[2]=face->Voisins[2]->children[arete];
			switch(arete) {
			case 0:
				fille3->Voisins[2]->Voisins[2]=fille3;
				break;
			case 1:
				fille3->Voisins[2]->Voisins[0]=fille3;
				break;
			case 2:
				fille3->Voisins[2]->Voisins[1]=fille3;
				break;
			}
		}
	}

	fille4->indice=-1;

	/* Quatrieme fille, la plus facile avec les voisins */

	fille4->level=(face->level)+1;
		
	fille4->children[0]=NULL;
	fille4->children[1]=NULL;
	fille4->children[2]=NULL;
	fille4->children[3]=NULL;

	fille4->sommetCoin[0]=fils1;
	fille4->sommetCoin[1]=fils2;
	fille4->sommetCoin[2]=fils3;

    fille4->sommetArete[0]=NULL;
	fille4->sommetArete[1]=NULL;
	fille4->sommetArete[2]=NULL;

	fille4->Voisins[0]=fille2;
	fille4->Voisins[1]=fille3;
	fille4->Voisins[2]=fille1;

	/* Puis on met a jour la face mere */

	face->sommetArete[0]=fils1;
	face->sommetArete[1]=fils2;
	face->sommetArete[2]=fils3;

	face->children[0]=fille1;
	face->children[1]=fille2;
	face->children[2]=fille3;
	face->children[3]=fille4;

	//Spread & Harvest

	//Harvest des sommets complets
	if (fils1->parentF[0]!=NULL && fils1->parentF[0]->children[0]!=NULL && fils1->parentF[1]!=NULL && fils1->parentF[1]->children[0]!=NULL)
		harvest(fils1);
	if (fils2->parentF[0]!=NULL && fils2->parentF[0]->children[0]!=NULL && fils2->parentF[1]!=NULL && fils2->parentF[1]->children[0]!=NULL)
		harvest(fils2);
	if (fils3->parentF[0]!=NULL && fils3->parentF[0]->children[0]!=NULL && fils3->parentF[1]!=NULL && fils3->parentF[1]->children[0]!=NULL)
		harvest(fils3);

//	spread(fils1);
//	spread(fils2);
//	spread(fils3);
	
}

void accomodateButterfly(Qtree *Q, Face_WSZT*face, int level, int alpha, int beta, int gamma, int coeff, Mesh *mesh) {

	// Pareil que accomodate2 mais avec les tricoefffs

	int i, a, b, c;
	unsigned int estDansLaListe=0;

	if ((alpha>=0)&&(beta>=0)&&(gamma>=0)&&(face->level<level)) {

		if (face->children[0]==NULL) {
			PileDeFaces *tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
			lowPassRecButterfly(Q, face);
			if (mesh->FacePresente[face->indice]) {
				mesh->FacePresente[face->indice]=0;
				tmp->face=face->indice;
				tmp->next=mesh->FaceGap;
				mesh->FaceGap=tmp;
			}
		}
			/* On remplit Remember pour l'affectation ulterieure des coefficients d'ondelettes */

			if ((alpha==beta)&&(gamma==0)/*&&(Q->Remember!=
				face->children[3]->sommetCoin[0]->indice)*/) { 
					Q->Remember=face->children[3]->sommetCoin[0]->indice;
			/*		if (Q->VertexTable[Q->Remember]->parentF[0]==NULL)
						Q->VertexTable[Q->Remember]->parentF[0]=face;
					else
						Q->VertexTable[Q->Remember]->parentF[1]=face;
			*/}	
			if ((beta==gamma)&&(alpha==0)/*&&(Q->Remember!=
				face->children[3]->sommetCoin[1]->indice)*/) { 
					Q->Remember=face->children[3]->sommetCoin[1]->indice;
			/*		if (Q->VertexTable[Q->Remember]->parentF[0]==NULL)
						Q->VertexTable[Q->Remember]->parentF[0]=face;
					else
						Q->VertexTable[Q->Remember]->parentF[1]=face;
			*/}
			if ((gamma==alpha)&&(beta==0)/*&&(Q->Remember!=
				face->children[3]->sommetCoin[2]->indice)*/) { 
					Q->Remember=face->children[3]->sommetCoin[2]->indice;
			/*		if (Q->VertexTable[Q->Remember]->parentF[0]==NULL)
						Q->VertexTable[Q->Remember]->parentF[0]=face;
					else
						Q->VertexTable[Q->Remember]->parentF[1]=face;
			*/}
		

		for (i=0; i<4; i++) {
			ChCoord(alpha, beta, gamma, i, &a, &b, &c);
			accomodateButterfly(Q, face->children[i], level, a, b, c, coeff, mesh);
		}
	}

	// ATTENTION : (pas de subdivision) => (Q->Remember==-1) 
}

void globalAccomodateButterfly(Qtree *Q, int face, int level, int alpha, int beta, int gamma, int coeff, Mesh *mesh) {
	
	/* Accomodation de M0 */
	// Pour aller avec receptionCoeff61()

	int i, critere, j; 
	int aa, bb, cc;

	//Premire tape : dtermination de tous les sommets  accomoder (le centre et ses parentV)

	for (j=1; j<=3; j++) {

		//Sparation des cas
		switch(j) {
		case 1: // Premier parent
			if ((alpha%2) && (beta%2)) {//alpha et beta impairs
				aa=alpha-1;
				bb=beta+1;
				cc=gamma;
			} else 
			if ((alpha%2) && (gamma%2)) {
				aa=alpha-1;
				bb=beta;
				cc=gamma+1;
			} else
			if ((beta%2) && (gamma%2)) {
				aa=alpha;
				bb=beta-1;
				cc=gamma+1;
			} else /*Beep(440, 1000)*/;
			
		
			//Rduction -> 1 pair et deux impairs 
			while ((!(alpha%2)) && (!(beta%2)) && (!(gamma%2))) {
				alpha/=2;
				beta/=2;
				gamma/=2;
			}
			break;
		case 2: // Deuxime parent
			if ((alpha%2) && (beta%2)) {//alpha et beta impairs
				aa=alpha+1;
				bb=beta-1;
				cc=gamma;
			} else 
			if ((alpha%2) && (gamma%2)) {
				aa=alpha+1;
				bb=beta;
				cc=gamma-1;
			} else
			if ((beta%2) && (gamma%2)) {
				aa=alpha;
				bb=beta+1;
				cc=gamma-1;
			} else /*Beep(440, 1000)*/;
			
		
			//Rduction -> 1 pair et deux impairs 
			while ((!(alpha%2)) && (!(beta%2)) && (!(gamma%2))) {
				alpha/=2;
				beta/=2;
				gamma/=2;
			}
			break;
		case 3: // sommet central
			aa=alpha;
			bb=beta;
			cc=gamma;
		}
		

	

		//Deuxime tape : on les accomode un par un, le dernier est le centre, pour pouvoir garder *Remember*

		if (aa*bb*cc!=0) accomodateButterfly(Q, Q->racines[face], level, aa, bb, cc, coeff, mesh);
		else { /* Effet de bord (ou pire, de coin) */
			critere=(aa!=0)+2*(bb!=0)+4*(cc!=0);
			switch(critere) {
			case 1 :
				for (i=0; i<Q->NbRacine; i++) {
					if (i!=face) { 
						if (Q->racines[i]->sommetCoin[0]==Q->racines[face]->sommetCoin[0]) accomodateButterfly(Q, Q->racines[i], level, 1, 0, 0, coeff, mesh);
						if (Q->racines[i]->sommetCoin[1]==Q->racines[face]->sommetCoin[0]) accomodateButterfly(Q, Q->racines[i], level, 0, 1, 0, coeff, mesh);
						if (Q->racines[i]->sommetCoin[2]==Q->racines[face]->sommetCoin[0]) accomodateButterfly(Q, Q->racines[i], level, 0, 0, 1, coeff, mesh);					
					}
				}
				accomodateButterfly(Q, Q->racines[face], level, 1, 0, 0, coeff, mesh);
				break;
			case 2 :
				for (i=0; i<Q->NbRacine; i++) {
					if (i!=face) { 
						if (Q->racines[i]->sommetCoin[0]==Q->racines[face]->sommetCoin[1]) accomodateButterfly(Q, Q->racines[i], level, 1, 0, 0, coeff, mesh);
						if (Q->racines[i]->sommetCoin[1]==Q->racines[face]->sommetCoin[1]) accomodateButterfly(Q, Q->racines[i], level, 0, 1, 0, coeff, mesh);
						if (Q->racines[i]->sommetCoin[2]==Q->racines[face]->sommetCoin[1]) accomodateButterfly(Q, Q->racines[i], level, 0, 0, 1, coeff, mesh);					
					}
				}
				accomodateButterfly(Q, Q->racines[face], level, 0, 1, 0, coeff, mesh);
				break;
			case 4 :
				for (i=0; i<Q->NbRacine; i++) {
					if (i!=face) { 
						if (Q->racines[i]->sommetCoin[0]==Q->racines[face]->sommetCoin[2]) accomodateButterfly(Q, Q->racines[i], level, 1, 0, 0, coeff, mesh);
						if (Q->racines[i]->sommetCoin[1]==Q->racines[face]->sommetCoin[2]) accomodateButterfly(Q, Q->racines[i], level, 0, 1, 0, coeff, mesh);
						if (Q->racines[i]->sommetCoin[2]==Q->racines[face]->sommetCoin[2]) accomodateButterfly(Q, Q->racines[i], level, 0, 0, 1, coeff, mesh);					
					}
				}
				accomodateButterfly(Q, Q->racines[face], level, 0, 0, 1, coeff, mesh);	
				break;
			case 3 :
				if (Q->racines[face]->Voisins[0]!=NULL) {
					if ((Q->racines[face]->Voisins[0]->sommetCoin[0]!=Q->racines[face]->sommetCoin[0])&&
						(Q->racines[face]->Voisins[0]->sommetCoin[0]!=Q->racines[face]->sommetCoin[1]))

					accomodateButterfly(Q, Q->racines[face]->Voisins[0], level, 0, bb, aa, coeff, mesh);

					if ((Q->racines[face]->Voisins[0]->sommetCoin[1]!=Q->racines[face]->sommetCoin[0])&&
						(Q->racines[face]->Voisins[0]->sommetCoin[1]!=Q->racines[face]->sommetCoin[1]))

					accomodateButterfly(Q, Q->racines[face]->Voisins[0], level, aa, 0, bb, coeff, mesh);

					if ((Q->racines[face]->Voisins[0]->sommetCoin[2]!=Q->racines[face]->sommetCoin[0])&&
						(Q->racines[face]->Voisins[0]->sommetCoin[2]!=Q->racines[face]->sommetCoin[1]))

					accomodateButterfly(Q, Q->racines[face]->Voisins[0], level, bb, aa, 0, coeff, mesh);
				}

				accomodateButterfly(Q, Q->racines[face], level, aa, bb, cc, coeff, mesh);	
				break;
			case 6 :
				if (Q->racines[face]->Voisins[1]!=NULL) {
					if ((Q->racines[face]->Voisins[1]->sommetCoin[0]!=Q->racines[face]->sommetCoin[1])&&
						(Q->racines[face]->Voisins[1]->sommetCoin[0]!=Q->racines[face]->sommetCoin[2]))

					accomodateButterfly(Q, Q->racines[face]->Voisins[1], level, 0, cc, bb, coeff, mesh);

					if ((Q->racines[face]->Voisins[1]->sommetCoin[1]!=Q->racines[face]->sommetCoin[1])&&
						(Q->racines[face]->Voisins[1]->sommetCoin[1]!=Q->racines[face]->sommetCoin[2]))

					accomodateButterfly(Q, Q->racines[face]->Voisins[1], level, bb, 0, cc, coeff, mesh);

					if ((Q->racines[face]->Voisins[1]->sommetCoin[2]!=Q->racines[face]->sommetCoin[1])&&
						(Q->racines[face]->Voisins[1]->sommetCoin[2]!=Q->racines[face]->sommetCoin[2]))

					accomodateButterfly(Q, Q->racines[face]->Voisins[1], level, cc, bb, 0, coeff, mesh);
				
				}
				
				accomodateButterfly(Q, Q->racines[face], level, aa, bb, cc, coeff, mesh);	
				
				break;
			case 5 :
				if (Q->racines[face]->Voisins[2]!=NULL) {
					if ((Q->racines[face]->Voisins[2]->sommetCoin[0]!=Q->racines[face]->sommetCoin[2])&&
						(Q->racines[face]->Voisins[2]->sommetCoin[0]!=Q->racines[face]->sommetCoin[0]))

					accomodateButterfly(Q, Q->racines[face]->Voisins[2], level, 0, aa, cc, coeff, mesh);

					if ((Q->racines[face]->Voisins[2]->sommetCoin[1]!=Q->racines[face]->sommetCoin[2])&&
						(Q->racines[face]->Voisins[2]->sommetCoin[1]!=Q->racines[face]->sommetCoin[0]))

					accomodateButterfly(Q, Q->racines[face]->Voisins[2], level, cc, 0, aa, coeff, mesh);

					if ((Q->racines[face]->Voisins[2]->sommetCoin[2]!=Q->racines[face]->sommetCoin[2])&&
						(Q->racines[face]->Voisins[2]->sommetCoin[2]!=Q->racines[face]->sommetCoin[0]))

					accomodateButterfly(Q, Q->racines[face]->Voisins[2], level, aa, cc, 0, coeff, mesh);
				}
				
				accomodateButterfly(Q, Q->racines[face], level, aa, bb, cc, coeff, mesh);	
				break;
			}
		}
		if (i==1 || i==2) {
			if (aa*bb*cc!=0) accomodateButterfly(Q, Q->racines[face], level-1, aa, bb, cc, coeff, mesh);
			else { /* Effet de bord (ou pire, de coin) */
				critere=(aa!=0)+2*(bb!=0)+4*(cc!=0);
				switch(critere) {
				case 1 :
					for (i=0; i<Q->NbRacine; i++) {
						if (i!=face) { 
							if (Q->racines[i]->sommetCoin[0]==Q->racines[face]->sommetCoin[0]) accomodateButterfly(Q, Q->racines[i], level-1, 1, 0, 0, coeff, mesh);
							if (Q->racines[i]->sommetCoin[1]==Q->racines[face]->sommetCoin[0]) accomodateButterfly(Q, Q->racines[i], level-1, 0, 1, 0, coeff, mesh);
							if (Q->racines[i]->sommetCoin[2]==Q->racines[face]->sommetCoin[0]) accomodateButterfly(Q, Q->racines[i], level-1, 0, 0, 1, coeff, mesh);					
						}
					}
					accomodateButterfly(Q, Q->racines[face], level-1, 1, 0, 0, coeff, mesh);
					break;
				case 2 :
					for (i=0; i<Q->NbRacine; i++) {
						if (i!=face) { 
							if (Q->racines[i]->sommetCoin[0]==Q->racines[face]->sommetCoin[1]) accomodateButterfly(Q, Q->racines[i], level-1, 1, 0, 0, coeff, mesh);
							if (Q->racines[i]->sommetCoin[1]==Q->racines[face]->sommetCoin[1]) accomodateButterfly(Q, Q->racines[i], level-1, 0, 1, 0, coeff, mesh);
							if (Q->racines[i]->sommetCoin[2]==Q->racines[face]->sommetCoin[1]) accomodateButterfly(Q, Q->racines[i], level-1, 0, 0, 1, coeff, mesh);					
						}
					}
					accomodateButterfly(Q, Q->racines[face], level-1, 0, 1, 0, coeff, mesh);
					break;
				case 4 :
					for (i=0; i<Q->NbRacine; i++) {
						if (i!=face) { 
							if (Q->racines[i]->sommetCoin[0]==Q->racines[face]->sommetCoin[2]) accomodateButterfly(Q, Q->racines[i], level-1, 1, 0, 0, coeff, mesh);
							if (Q->racines[i]->sommetCoin[1]==Q->racines[face]->sommetCoin[2]) accomodateButterfly(Q, Q->racines[i], level-1, 0, 1, 0, coeff, mesh);
							if (Q->racines[i]->sommetCoin[2]==Q->racines[face]->sommetCoin[2]) accomodateButterfly(Q, Q->racines[i], level-1, 0, 0, 1, coeff, mesh);					
						}
					}
					accomodateButterfly(Q, Q->racines[face], level-1, 0, 0, 1, coeff, mesh);	
					break;
				case 3 :
					if (Q->racines[face]->Voisins[0]!=NULL) {
						if ((Q->racines[face]->Voisins[0]->sommetCoin[0]!=Q->racines[face]->sommetCoin[0])&&
							(Q->racines[face]->Voisins[0]->sommetCoin[0]!=Q->racines[face]->sommetCoin[1]))

						accomodateButterfly(Q, Q->racines[face]->Voisins[0], level-1, 0, bb, aa, coeff, mesh);

						if ((Q->racines[face]->Voisins[0]->sommetCoin[1]!=Q->racines[face]->sommetCoin[0])&&
							(Q->racines[face]->Voisins[0]->sommetCoin[1]!=Q->racines[face]->sommetCoin[1]))

						accomodateButterfly(Q, Q->racines[face]->Voisins[0], level-1, aa, 0, bb, coeff, mesh);

						if ((Q->racines[face]->Voisins[0]->sommetCoin[2]!=Q->racines[face]->sommetCoin[0])&&
							(Q->racines[face]->Voisins[0]->sommetCoin[2]!=Q->racines[face]->sommetCoin[1]))

						accomodateButterfly(Q, Q->racines[face]->Voisins[0], level-1, bb, aa, 0, coeff, mesh);
					}

					accomodateButterfly(Q, Q->racines[face], level-1, aa, bb, cc, coeff, mesh);	
					break;
				case 6 :
					if (Q->racines[face]->Voisins[1]!=NULL) {
						if ((Q->racines[face]->Voisins[1]->sommetCoin[0]!=Q->racines[face]->sommetCoin[1])&&
							(Q->racines[face]->Voisins[1]->sommetCoin[0]!=Q->racines[face]->sommetCoin[2]))

						accomodateButterfly(Q, Q->racines[face]->Voisins[1], level-1, 0, cc, bb, coeff, mesh);

						if ((Q->racines[face]->Voisins[1]->sommetCoin[1]!=Q->racines[face]->sommetCoin[1])&&
							(Q->racines[face]->Voisins[1]->sommetCoin[1]!=Q->racines[face]->sommetCoin[2]))

						accomodateButterfly(Q, Q->racines[face]->Voisins[1], level-1, bb, 0, cc, coeff, mesh);

						if ((Q->racines[face]->Voisins[1]->sommetCoin[2]!=Q->racines[face]->sommetCoin[1])&&
							(Q->racines[face]->Voisins[1]->sommetCoin[2]!=Q->racines[face]->sommetCoin[2]))

						accomodateButterfly(Q, Q->racines[face]->Voisins[1], level-1, cc, bb, 0, coeff, mesh);
					
					}
					
					accomodateButterfly(Q, Q->racines[face], level-1, aa, bb, cc, coeff, mesh);	
					
					break;
				case 5 :
					if (Q->racines[face]->Voisins[2]!=NULL) {
						if ((Q->racines[face]->Voisins[2]->sommetCoin[0]!=Q->racines[face]->sommetCoin[2])&&
							(Q->racines[face]->Voisins[2]->sommetCoin[0]!=Q->racines[face]->sommetCoin[0]))

						accomodateButterfly(Q, Q->racines[face]->Voisins[2], level-1, 0, aa, cc, coeff, mesh);

						if ((Q->racines[face]->Voisins[2]->sommetCoin[1]!=Q->racines[face]->sommetCoin[2])&&
							(Q->racines[face]->Voisins[2]->sommetCoin[1]!=Q->racines[face]->sommetCoin[0]))

						accomodateButterfly(Q, Q->racines[face]->Voisins[2], level-1, cc, 0, aa, coeff, mesh);

						if ((Q->racines[face]->Voisins[2]->sommetCoin[2]!=Q->racines[face]->sommetCoin[2])&&
							(Q->racines[face]->Voisins[2]->sommetCoin[2]!=Q->racines[face]->sommetCoin[0]))

						accomodateButterfly(Q, Q->racines[face]->Voisins[2], level-1, aa, cc, 0, coeff, mesh);
					}
					
					accomodateButterfly(Q, Q->racines[face], level-1, aa, bb, cc, coeff, mesh);	
					break;
				}

			
			}
		}
	}
}

void moveVertexButterfly(Qtree* Q) {
	
	// Odd vertices are moved according to the LPF mask

	float NewPos[3];
	void *tmpv1, *tmpv2, *tmpv3;

	if (Q->VertexTable[Q->Remember]->level==0) return;

	// 8
	if ((tmpv1=Q->VertexTable[Q->Remember]->parentV[0])==NULL) /*Beep(440, 100)*/;
	NewPos[0]=8*((Sommet*)tmpv1)->g[0];
	NewPos[1]=8*((Sommet*)tmpv1)->g[1];
	NewPos[2]=8*((Sommet*)tmpv1)->g[2];



	// 8
	tmpv2=Q->VertexTable[Q->Remember]->parentV[1];
	NewPos[0]+=8*((Sommet*)tmpv2)->g[0];
	NewPos[1]+=8*((Sommet*)tmpv2)->g[1];
	NewPos[2]+=8*((Sommet*)tmpv2)->g[2];

	//2 
/*	f=Q->VertexTable[Q->Remember]->parentF[0];
	if (f->sommetCoin[0]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[0]->indice!=((Sommet*)tmpv2)->indice)
		tmpv3=f->sommetCoin[0];
	else if (f->sommetCoin[1]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[1]->indice!=((Sommet*)tmpv2)->indice)
		tmpv3=f->sommetCoin[1];
	else if (f->sommetCoin[2]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[2]->indice!=((Sommet*)tmpv2)->indice)
		tmpv3=f->sommetCoin[1];
	else Beep(440, 1000);
	NewPos[0]-=2*((Sommet*)tmpv3)->g[0];
	NewPos[1]-=2*((Sommet*)tmpv3)->g[1];
	NewPos[2]-=2*((Sommet*)tmpv3)->g[2];

	//2
	f=Q->VertexTable[Q->Remember]->parentF[1];
	if (f->sommetCoin[0]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[0]->indice!=((Sommet*)tmpv2)->indice)
		tmpv3=f->sommetCoin[0];
	else if (f->sommetCoin[1]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[1]->indice!=((Sommet*)tmpv2)->indice)
		tmpv3=f->sommetCoin[1];
	else if (f->sommetCoin[2]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[2]->indice!=((Sommet*)tmpv2)->indice)
		tmpv3=f->sommetCoin[1];
	else Beep(440, 1000);
	NewPos[0]-=2*((Sommet*)tmpv3)->g[0];
	NewPos[1]-=2*((Sommet*)tmpv3)->g[1];
	NewPos[2]-=2*((Sommet*)tmpv3)->g[2];	
*/



	//Normalisation

	NewPos[0]/=16;
	NewPos[1]/=16;
	NewPos[2]/=16;

	Q->VertexTable[Q->Remember]->g[0]=NewPos[0];
	Q->VertexTable[Q->Remember]->g[1]=NewPos[1];
	Q->VertexTable[Q->Remember]->g[2]=NewPos[2];
}

void moveVertexButterflyS(Sommet *s) {
	
	// Odd vertices are moved according to the LPF mask
	// Prvoir le cas avec bord

	float NewPos[3];
	Face_WSZT*f, *f1;
	Sommet *tmps;
	void *tmpv1, *tmpv2, *tmpv3, *tmpv4;
	int N=0;
	bool ticket=TRUE;


	if (s->level==0) return;

	// 8
	if ((tmpv1=s->parentV[0])!=NULL) {
		NewPos[0]=8*((Sommet*)tmpv1)->g[0];
		NewPos[1]=8*((Sommet*)tmpv1)->g[1];
		NewPos[2]=8*((Sommet*)tmpv1)->g[2];
		N+=8;
	}



	// 8
	if ((tmpv2=s->parentV[1])!=NULL) {
		NewPos[0]+=8*((Sommet*)tmpv2)->g[0];
		NewPos[1]+=8*((Sommet*)tmpv2)->g[1];
		NewPos[2]+=8*((Sommet*)tmpv2)->g[2];
		N+=8;
	}

	//2 
	if (s->parentF[0]!=NULL) {
		if ((f=s->parentF[0])!=NULL) {
			if (f->sommetCoin[0]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[0]->indice!=((Sommet*)tmpv2)->indice)
				tmpv3=f->sommetCoin[0];
			else if (f->sommetCoin[1]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[1]->indice!=((Sommet*)tmpv2)->indice)
				tmpv3=f->sommetCoin[1];
			else if (f->sommetCoin[2]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[2]->indice!=((Sommet*)tmpv2)->indice)
				tmpv3=f->sommetCoin[2];
			else 
				/*Beep(440, 000)*/;
			NewPos[0]+=2*((Sommet*)tmpv3)->g[0];
			NewPos[1]+=2*((Sommet*)tmpv3)->g[1];
			NewPos[2]+=2*((Sommet*)tmpv3)->g[2];
			N+=2;
		}
	}

	//2
	if (s->parentF[1]!=NULL) {
		if ((f=s->parentF[1])!=NULL) {
			if (f->sommetCoin[0]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[0]->indice!=((Sommet*)tmpv2)->indice)
				tmpv4=f->sommetCoin[0];
			else if (f->sommetCoin[1]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[1]->indice!=((Sommet*)tmpv2)->indice)
				tmpv4=f->sommetCoin[1];
			else if (f->sommetCoin[2]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[2]->indice!=((Sommet*)tmpv2)->indice)
				tmpv4=f->sommetCoin[2];
			else 
				/*Beep(440, 000)*/;
			NewPos[0]+=2*((Sommet*)tmpv4)->g[0];
			NewPos[1]+=2*((Sommet*)tmpv4)->g[1];
			NewPos[2]+=2*((Sommet*)tmpv4)->g[2];	
			N+=2;
		}
	}


	//-1
	if (s->parentF[0]!=NULL) {
		if (s->parentF[0]->Voisins[0]!=s->parentF[1] && s->parentF[0]->Voisins[0]!=NULL)
			f=s->parentF[0]->Voisins[0];
		else if (s->parentF[0]->Voisins[1]!=s->parentF[1] && s->parentF[0]->Voisins[1]!=NULL)
			f=s->parentF[0]->Voisins[1];
		else if (s->parentF[0]->Voisins[2]!=s->parentF[1] && s->parentF[0]->Voisins[2]!=NULL)
			f=s->parentF[0]->Voisins[2];
		else { 
			ticket=FALSE;
		}
		if (ticket) {
			if (f->sommetCoin[0]!=tmpv1 && f->sommetCoin[0]!=tmpv2 && 
				f->sommetCoin[0]!=tmpv3 && f->sommetCoin[0]!=tmpv4)
				tmps=f->sommetCoin[0];
			else if (f->sommetCoin[1]!=tmpv1 && f->sommetCoin[1]!=tmpv2 && 
				f->sommetCoin[1]!=tmpv3 && f->sommetCoin[1]!=tmpv4)
				tmps=f->sommetCoin[1];
			else if (f->sommetCoin[2]!=tmpv1 && f->sommetCoin[2]!=tmpv2 && 
				f->sommetCoin[2]!=tmpv3 && f->sommetCoin[2]!=tmpv4)
				tmps=f->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->g[0];
				NewPos[1]-=tmps->g[1];
				NewPos[2]-=tmps->g[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}
	
	//-1
	if (s->parentF[0]!=NULL) {
		if (s->parentF[0]->Voisins[0]!=s->parentF[1] && s->parentF[0]->Voisins[0]!=f && s->parentF[0]->Voisins[0]!=NULL)
			f1=s->parentF[0]->Voisins[0];
		else if (s->parentF[0]->Voisins[1]!=s->parentF[1] && s->parentF[0]->Voisins[1]!=f && s->parentF[0]->Voisins[1]!=NULL)
			f1=s->parentF[0]->Voisins[1];
		else if (s->parentF[0]->Voisins[2]!=s->parentF[1] && s->parentF[0]->Voisins[2]!=f && s->parentF[0]->Voisins[2]!=NULL)
			f1=s->parentF[0]->Voisins[2];
		else {
			ticket=FALSE;
		}
		if (ticket) {
			if (f1->sommetCoin[0]!=tmpv1 && f1->sommetCoin[0]!=tmpv2 && 
				f1->sommetCoin[0]!=tmpv3 && f1->sommetCoin[0]!=tmpv4)
				tmps=f1->sommetCoin[0];
			else if (f1->sommetCoin[1]!=tmpv1 && f1->sommetCoin[1]!=tmpv2 && 
				f1->sommetCoin[1]!=tmpv3 && f1->sommetCoin[1]!=tmpv4)
				tmps=f1->sommetCoin[1];
			else if (f1->sommetCoin[2]!=tmpv1 && f1->sommetCoin[2]!=tmpv2 && 
				f1->sommetCoin[2]!=tmpv3 && f1->sommetCoin[2]!=tmpv4)
				tmps=f1->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->g[0];
				NewPos[1]-=tmps->g[1];
				NewPos[2]-=tmps->g[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}

	//-1
	if (s->parentF[1]!=NULL) {
		if (s->parentF[1]->Voisins[0]!=s->parentF[0] && s->parentF[1]->Voisins[0]!=NULL)
			f=s->parentF[1]->Voisins[0];
		else if (s->parentF[1]->Voisins[1]!=s->parentF[0] && s->parentF[1]->Voisins[1]!=NULL)
			f=s->parentF[1]->Voisins[1];
		else if (s->parentF[1]->Voisins[2]!=s->parentF[0] && s->parentF[1]->Voisins[2]!=NULL)
			f=s->parentF[1]->Voisins[2];
		else {
			ticket=FALSE;
		}
		if (ticket) {
			if (f->sommetCoin[0]!=tmpv1 && f->sommetCoin[0]!=tmpv2 && 
				f->sommetCoin[0]!=tmpv3 && f->sommetCoin[0]!=tmpv4)
				tmps=f->sommetCoin[0];
			else if (f->sommetCoin[1]!=tmpv1 && f->sommetCoin[1]!=tmpv2 && 
				f->sommetCoin[1]!=tmpv3 && f->sommetCoin[1]!=tmpv4)
				tmps=f->sommetCoin[1];
			else if (f->sommetCoin[2]!=tmpv1 && f->sommetCoin[2]!=tmpv2 && 
				f->sommetCoin[2]!=tmpv3 && f->sommetCoin[2]!=tmpv4)
				tmps=f->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->g[0];
				NewPos[1]-=tmps->g[1];
				NewPos[2]-=tmps->g[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}
	
	//-1
	if (s->parentF[1]!=NULL) {
		if (s->parentF[1]->Voisins[0]!=s->parentF[0] && s->parentF[1]->Voisins[0]!=f && s->parentF[1]->Voisins[0]!=NULL)
			f1=s->parentF[1]->Voisins[0];
		else if (s->parentF[1]->Voisins[1]!=s->parentF[0] && s->parentF[1]->Voisins[1]!=f && s->parentF[1]->Voisins[1]!=NULL)
			f1=s->parentF[1]->Voisins[1];
		else if (s->parentF[1]->Voisins[2]!=s->parentF[0] && s->parentF[1]->Voisins[2]!=f && s->parentF[1]->Voisins[2]!=NULL)
			f1=s->parentF[1]->Voisins[2];
		else {
			ticket=FALSE;
		}
		if (ticket) {
			if (f1->sommetCoin[0]!=tmpv1 && f1->sommetCoin[0]!=tmpv2 && 
				f1->sommetCoin[0]!=tmpv3 && f1->sommetCoin[0]!=tmpv4)
				tmps=f1->sommetCoin[0];
			else if (f1->sommetCoin[1]!=tmpv1 && f1->sommetCoin[1]!=tmpv2 && 
				f1->sommetCoin[1]!=tmpv3 && f1->sommetCoin[1]!=tmpv4)
				tmps=f1->sommetCoin[1];
			else if (f1->sommetCoin[2]!=tmpv1 && f1->sommetCoin[2]!=tmpv2 && 
				f1->sommetCoin[2]!=tmpv3 && f1->sommetCoin[2]!=tmpv4)
				tmps=f1->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->g[0];
				NewPos[1]-=tmps->g[1];
				NewPos[2]-=tmps->g[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}

	//Normalisation

	NewPos[0]/=N;
	NewPos[1]/=N;
	NewPos[2]/=N;

	//Affectation finale
	s->g[0]=NewPos[0];
	s->g[1]=NewPos[1];
	s->g[2]=NewPos[2];
	//s->fGeom[0]=NewPos[0]-s->g[0];
	//s->fGeom[1]=NewPos[1]-s->g[1];
	//s->fGeom[2]=NewPos[2]-s->g[2];
}

void moveVertexButterflySOffset(Sommet *s, Qtree *Q, int level) {
	
	//Appel par evaluateQueueButterfly
	// Odd vertices are moved according to the LPF mask
	// Prvoir le cas avec bord

	float NewPos[3];
	Face_WSZT*f, *f1;
	Sommet *tmps;
	void *tmpv1, *tmpv2, *tmpv3, *tmpv4;
	int N=0;
	bool ticket=TRUE;

	if (s->level==0) return;

	// 8
	if ((tmpv1=s->parentV[0])!=NULL) {
		NewPos[0]=8*((Sommet*)tmpv1)->fGeom[0];
		NewPos[1]=8*((Sommet*)tmpv1)->fGeom[1];
		NewPos[2]=8*((Sommet*)tmpv1)->fGeom[2];
		N+=8;
	}



	// 8
	if ((tmpv2=s->parentV[1])!=NULL) {
		NewPos[0]+=8*((Sommet*)tmpv2)->fGeom[0];
		NewPos[1]+=8*((Sommet*)tmpv2)->fGeom[1];
		NewPos[2]+=8*((Sommet*)tmpv2)->fGeom[2];
		N+=8;
	}

	//2 
	if (s->parentF[0]!=NULL) {
		if ((f=s->parentF[0])!=NULL) {
			if (f->sommetCoin[0]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[0]->indice!=((Sommet*)tmpv2)->indice)
				tmpv3=f->sommetCoin[0];
			else if (f->sommetCoin[1]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[1]->indice!=((Sommet*)tmpv2)->indice)
				tmpv3=f->sommetCoin[1];
			else if (f->sommetCoin[2]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[2]->indice!=((Sommet*)tmpv2)->indice)
				tmpv3=f->sommetCoin[2];
			else 
				/*Beep(440, 000)*/;
			NewPos[0]+=2*((Sommet*)tmpv3)->fGeom[0];
			NewPos[1]+=2*((Sommet*)tmpv3)->fGeom[1];
			NewPos[2]+=2*((Sommet*)tmpv3)->fGeom[2];
			N+=2;
		}
	}

	//2
	if (s->parentF[1]!=NULL) {
		if ((f=s->parentF[1])!=NULL) {
			if (f->sommetCoin[0]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[0]->indice!=((Sommet*)tmpv2)->indice)
				tmpv4=f->sommetCoin[0];
			else if (f->sommetCoin[1]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[1]->indice!=((Sommet*)tmpv2)->indice)
				tmpv4=f->sommetCoin[1];
			else if (f->sommetCoin[2]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[2]->indice!=((Sommet*)tmpv2)->indice)
				tmpv4=f->sommetCoin[2];
			else 
				/*Beep(440, 000)*/;
			NewPos[0]+=2*((Sommet*)tmpv4)->fGeom[0];
			NewPos[1]+=2*((Sommet*)tmpv4)->fGeom[1];
			NewPos[2]+=2*((Sommet*)tmpv4)->fGeom[2];	
			N+=2;
		}
	}


	//-1
	if (s->parentF[0]!=NULL) {
		if (s->parentF[0]->Voisins[0]!=s->parentF[1] && s->parentF[0]->Voisins[0]!=NULL)
			f=s->parentF[0]->Voisins[0];
		else if (s->parentF[0]->Voisins[1]!=s->parentF[1] && s->parentF[0]->Voisins[1]!=NULL)
			f=s->parentF[0]->Voisins[1];
		else if (s->parentF[0]->Voisins[2]!=s->parentF[1] && s->parentF[0]->Voisins[2]!=NULL)
			f=s->parentF[0]->Voisins[2];
		else { 
			ticket=FALSE;
		}
		if (ticket) {
			if (f->sommetCoin[0]!=tmpv1 && f->sommetCoin[0]!=tmpv2 && 
				f->sommetCoin[0]!=tmpv3 && f->sommetCoin[0]!=tmpv4)
				tmps=f->sommetCoin[0];
			else if (f->sommetCoin[1]!=tmpv1 && f->sommetCoin[1]!=tmpv2 && 
				f->sommetCoin[1]!=tmpv3 && f->sommetCoin[1]!=tmpv4)
				tmps=f->sommetCoin[1];
			else if (f->sommetCoin[2]!=tmpv1 && f->sommetCoin[2]!=tmpv2 && 
				f->sommetCoin[2]!=tmpv3 && f->sommetCoin[2]!=tmpv4)
				tmps=f->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->fGeom[0];
				NewPos[1]-=tmps->fGeom[1];
				NewPos[2]-=tmps->fGeom[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}
	
	//-1
	if (s->parentF[0]!=NULL) {
		if (s->parentF[0]->Voisins[0]!=s->parentF[1] && s->parentF[0]->Voisins[0]!=f && s->parentF[0]->Voisins[0]!=NULL)
			f1=s->parentF[0]->Voisins[0];
		else if (s->parentF[0]->Voisins[1]!=s->parentF[1] && s->parentF[0]->Voisins[1]!=f && s->parentF[0]->Voisins[1]!=NULL)
			f1=s->parentF[0]->Voisins[1];
		else if (s->parentF[0]->Voisins[2]!=s->parentF[1] && s->parentF[0]->Voisins[2]!=f && s->parentF[0]->Voisins[2]!=NULL)
			f1=s->parentF[0]->Voisins[2];
		else {
			ticket=FALSE;
		}
		if (ticket) {
			if (f1->sommetCoin[0]!=tmpv1 && f1->sommetCoin[0]!=tmpv2 && 
				f1->sommetCoin[0]!=tmpv3 && f1->sommetCoin[0]!=tmpv4)
				tmps=f1->sommetCoin[0];
			else if (f1->sommetCoin[1]!=tmpv1 && f1->sommetCoin[1]!=tmpv2 && 
				f1->sommetCoin[1]!=tmpv3 && f1->sommetCoin[1]!=tmpv4)
				tmps=f1->sommetCoin[1];
			else if (f1->sommetCoin[2]!=tmpv1 && f1->sommetCoin[2]!=tmpv2 && 
				f1->sommetCoin[2]!=tmpv3 && f1->sommetCoin[2]!=tmpv4)
				tmps=f1->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->fGeom[0];
				NewPos[1]-=tmps->fGeom[1];
				NewPos[2]-=tmps->fGeom[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}

	//-1
	if (s->parentF[1]!=NULL) {
		if (s->parentF[1]->Voisins[0]!=s->parentF[0] && s->parentF[1]->Voisins[0]!=NULL)
			f=s->parentF[1]->Voisins[0];
		else if (s->parentF[1]->Voisins[1]!=s->parentF[0] && s->parentF[1]->Voisins[1]!=NULL)
			f=s->parentF[1]->Voisins[1];
		else if (s->parentF[1]->Voisins[2]!=s->parentF[0] && s->parentF[1]->Voisins[2]!=NULL)
			f=s->parentF[1]->Voisins[2];
		else {
			ticket=FALSE;
		}
		if (ticket) {
			if (f->sommetCoin[0]!=tmpv1 && f->sommetCoin[0]!=tmpv2 && 
				f->sommetCoin[0]!=tmpv3 && f->sommetCoin[0]!=tmpv4)
				tmps=f->sommetCoin[0];
			else if (f->sommetCoin[1]!=tmpv1 && f->sommetCoin[1]!=tmpv2 && 
				f->sommetCoin[1]!=tmpv3 && f->sommetCoin[1]!=tmpv4)
				tmps=f->sommetCoin[1];
			else if (f->sommetCoin[2]!=tmpv1 && f->sommetCoin[2]!=tmpv2 && 
				f->sommetCoin[2]!=tmpv3 && f->sommetCoin[2]!=tmpv4)
				tmps=f->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->fGeom[0];
				NewPos[1]-=tmps->fGeom[1];
				NewPos[2]-=tmps->fGeom[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}
	
	//-1
	if (s->parentF[1]!=NULL) {
		if (s->parentF[1]->Voisins[0]!=s->parentF[0] && s->parentF[1]->Voisins[0]!=f && s->parentF[1]->Voisins[0]!=NULL)
			f1=s->parentF[1]->Voisins[0];
		else if (s->parentF[1]->Voisins[1]!=s->parentF[0] && s->parentF[1]->Voisins[1]!=f && s->parentF[1]->Voisins[1]!=NULL)
			f1=s->parentF[1]->Voisins[1];
		else if (s->parentF[1]->Voisins[2]!=s->parentF[0] && s->parentF[1]->Voisins[2]!=f && s->parentF[1]->Voisins[2]!=NULL)
			f1=s->parentF[1]->Voisins[2];
		else {
			ticket=FALSE;
		}
		if (ticket) {
			if (f1->sommetCoin[0]!=tmpv1 && f1->sommetCoin[0]!=tmpv2 && 
				f1->sommetCoin[0]!=tmpv3 && f1->sommetCoin[0]!=tmpv4)
				tmps=f1->sommetCoin[0];
			else if (f1->sommetCoin[1]!=tmpv1 && f1->sommetCoin[1]!=tmpv2 && 
				f1->sommetCoin[1]!=tmpv3 && f1->sommetCoin[1]!=tmpv4)
				tmps=f1->sommetCoin[1];
			else if (f1->sommetCoin[2]!=tmpv1 && f1->sommetCoin[2]!=tmpv2 && 
				f1->sommetCoin[2]!=tmpv3 && f1->sommetCoin[2]!=tmpv4)
				tmps=f1->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->fGeom[0];
				NewPos[1]-=tmps->fGeom[1];
				NewPos[2]-=tmps->fGeom[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}

	//Normalisation

	NewPos[0]/=N;
	NewPos[1]/=N;
	NewPos[2]/=N;

	//Affectation finale
	//s->g[0]=NewPos[0];
	//s->g[1]=NewPos[1];
	//s->g[2]=NewPos[2];
	s->fGeom[0]+=NewPos[0];
	s->fGeom[1]+=NewPos[1];
	s->fGeom[2]+=NewPos[2];
}

void moveVertexButterflySDual(Sommet *s) {
	// En ligne au lieu de colonne
	// Le sommet s donne sa contribution  tous les sommets actifs dans sa zone d'influence

	float NewPos[3];
	Face_WSZT*f, *f1;
	void *tmpv1;
	int N=0;

	// face parente
	f=s->parentF[0];
	if (f->children[0]!=NULL) {
		// premire fille
		f1=f->children[0];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
		}
		// 2e fille
		f1=f->children[1];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
		}
		// 3e fille
		f1=f->children[2];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
		}
		// 4e fille
		f1=f->children[3];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
		}
	}

	// 2e face parente
	f=s->parentF[1];
	if (f->children[0]!=NULL) {
		// premire fille
		f1=f->children[0];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
		}
		// 2e fille
		f1=f->children[1];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
		}
		// 3e fille
		f1=f->children[2];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
		}
		// 4e fille
		f1=f->children[3];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->g[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=4*s->g[1];
					((Sommet*)tmpv1)->g[2]+=4*s->g[2];
				} else { // 3 
					((Sommet*)tmpv1)->g[0]+=1.5*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->g[1]+=1.5*s->g[1];
					((Sommet*)tmpv1)->g[2]+=1.5*s->g[2];
				}
			}
		}
	}

	//faces non-parentes
	//Chantier
	




}

void moveVertexButterflySDualOffset(Sommet *s, Qtree *Q, int level) {
	// Appel par EvaluateQueueButterfly
	// En ligne au lieu de colonne
	// Le sommet s donne sa contribution  tous les sommets actifs dans sa zone d'influence

	float NewPos[3], tmp[3];
	Face_WSZT*f, *f1;
	Sommet *tmps;
	void *tmpv1, *tmpv2, *tmpv3, *tmpv4;
	int N=0;

	// face parente
	f=s->parentF[0];
	if (f->children[0]!=NULL) {
		// premire fille
		f1=f->children[0];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->g[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
		}
		// 2e fille
		f1=f->children[1];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
		}
		// 3e fille
		f1=f->children[2];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
		}
		// 4e fille
		f1=f->children[3];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
		}
	}

	// 2e face parente
	f=s->parentF[1];
	if (f->children[0]!=NULL) {
		// premire fille
		f1=f->children[0];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
		}
		// 2e fille
		f1=f->children[1];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
		}
		// 3e fille
		f1=f->children[2];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
		}
		// 4e fille
		f1=f->children[3];
		if (f1->children[0]!=NULL) {
			//1e fille
			tmpv1=f1->sommetArete[0];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[1];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
			tmpv1=f1->sommetArete[2];
			if (((Sommet*)tmpv1)->parentF[0]!=NULL && ((Sommet*)tmpv1)->parentF[1]!=NULL) { // Sommet actif
				if (((Sommet*)tmpv1)->parentV[0]==s ||((Sommet*)tmpv1)->parentV[1]==s) { //8
					((Sommet*)tmpv1)->fGeom[0]+=4*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=4*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=4*s->fGeom[2];
				} else { // 3 
					((Sommet*)tmpv1)->fGeom[0]+=1.5*s->fGeom[0];//8/2 (deux passages)
					((Sommet*)tmpv1)->fGeom[1]+=1.5*s->fGeom[1];
					((Sommet*)tmpv1)->fGeom[2]+=1.5*s->fGeom[2];
				}
			}
		}
	}

	//faces non-parentes
	//Chantier


}


/////////////////////////////////////////////////////
void uniformDivideButterfly(Qtree *Q, Face_WSZT*face, Mesh *mesh, int tension) {
/////////////////////////////////////////////////////

	if (face->children[0]!=NULL) {
		uniformDivideButterfly(Q, face->children[0], mesh, tension);
		uniformDivideButterfly(Q, face->children[1], mesh, tension);
		uniformDivideButterfly(Q, face->children[2], mesh, tension);
		uniformDivideButterfly(Q, face->children[3], mesh, tension);
	} else {
		Face_WSZT*fille1, *fille2, *fille3, *fille4;
		Sommet *fils1, *fils2, *fils3;
		int ticket, arete, critere, i;

		/* Allocation familliale */

		if ((fille1=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");
		if ((fille2=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");
		if ((fille3=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");
		if ((fille4=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");

		//liste vides
		fille1->Coeff_list=fille2->Coeff_list=fille3->Coeff_list=fille4->Coeff_list=NULL;

		/* Allocation eventuelle des nouveaux sommets, suivant qu'il ont deja ete crees */
		/* dans une autre facette ou pas */

		/* Premier sommet */

		ticket=0;
		
		if (face->Voisins[0]==NULL) ticket=1; /* On va creer le sommet */
		else {
			if (face->Voisins[0]->children[0]==NULL) ticket=1;
			else {
				/* On regarde l'orientation du voisin de face */
				critere=(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[0])+
						(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[1])*2+
						(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[2])*4;
				switch(critere) {
				case 1:
					arete=2;
					break;
				case 2:
					arete=0;
					break;
				case 4:
					arete=1;
					break;
				}
				/* On affecte le soi disant nouveau point a sa vraie valeur */

				fils1=face->Voisins[0]->sommetArete[arete];

				// Et on oublie pas de mettre  jour parentF !!!
				fils1->parentF[0]=face;
				fils1->parentF[1]=face->Voisins[0];
			}
		}

		if (ticket==1) {
			if ((fils1=(Sommet*)malloc(sizeof(Sommet)))==NULL) fprintf(stderr, " divise : can't allocate memory");

			if (Q->Gap==NULL) {
				Q->VertexTable[Q->Top]=fils1;
				fils1->indice=Q->Top;
				Q->Top++;
			} else {
				Q->VertexTable[Q->Gap->sommet]=fils1;
				fils1->indice=Q->Gap->sommet;
				// On depile Gap
				PileDeSommets *tmp=(PileDeSommets *)malloc(sizeof(PileDeSommets));
				tmp=Q->Gap;
				Q->Gap=Q->Gap->next;
				free(tmp);
			}

			// Affectation dans Q->nouveaux
			PileDeSommets *PDS=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			PDS->sommet=fils1->indice;
			PDS->next=Q->nouveaux;
			Q->nouveaux=PDS;

			fils1->parentV[0]=face->sommetCoin[0];
			fils1->parentV[1]=face->sommetCoin[1];

			fils1->parentF[0]=face;	
			fils1->parentF[1]=face->Voisins[0];

			fils1->u=0.5*(fils1->parentV[0]->u+fils1->parentV[1]->u);
			fils1->v=0.5*(fils1->parentV[0]->v+fils1->parentV[1]->v);
			
			fils1->g[0]=0.5*(fils1->parentV[0]->g[0]+fils1->parentV[1]->g[0]);
			fils1->g[1]=0.5*(fils1->parentV[0]->g[1]+fils1->parentV[1]->g[1]);
			fils1->g[2]=0.5*(fils1->parentV[0]->g[2]+fils1->parentV[1]->g[2]);

			fils1->fGeom[0]=0;
			fils1->fGeom[1]=0;
			fils1->fGeom[2]=0;

			fils1->level=face->level+1;


			for (i=0; i<NbNiveauMax; i++) {
				fils1->hGeom[i][0]=0; 
				fils1->hGeom[i][1]=0; 
				fils1->hGeom[i][2]=0; 
			}

			if (!tension)
				moveVertexButterflyS(fils1);
		}


		/* Deuxieme sommet */

		ticket=0;
		
		if (face->Voisins[1]==NULL) ticket=1; /* On va creer le sommet */
		else {
			if (face->Voisins[1]->children[0]==NULL) ticket=1;
			else {
				/* On regarde l'orientation du voisin de face */
				critere=(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[0])+
						(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[1])*2+
						(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[2])*4;
				switch(critere) {
				case 1:
					arete=2;
					break;
				case 2:
					arete=0;
					break;
				case 4:
					arete=1;
					break;
				}
				/* On affecte le soi disant nouveau point a sa vraie valeur */

				fils2=face->Voisins[1]->sommetArete[arete];

				// Et on oublie pas de mettre  jour parentF !!!
				fils2->parentF[0]=face;
				fils2->parentF[1]=face->Voisins[1];

			}
		}

		if (ticket==1) {
			
			if ((fils2=(Sommet*)malloc(sizeof(Sommet)))==NULL) fprintf(stderr, " divise : can't allocate memory");

			if (Q->Gap==NULL) {
				Q->VertexTable[Q->Top]=fils2;
				fils2->indice=Q->Top;
				Q->Top++;
			} else {
				Q->VertexTable[Q->Gap->sommet]=fils2;
				fils2->indice=Q->Gap->sommet;
				// On depile Gap
				PileDeSommets *tmp=(PileDeSommets *)malloc(sizeof(PileDeSommets));
				tmp=Q->Gap;
				Q->Gap=Q->Gap->next;
				free(tmp);
			}

			// Affectation dans Q->nouveaux
			PileDeSommets *PDS=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			PDS->sommet=fils2->indice;
			PDS->next=Q->nouveaux;
			Q->nouveaux=PDS;

			fils2->parentV[0]=face->sommetCoin[1];
			fils2->parentV[1]=face->sommetCoin[2];

			fils2->parentF[0]=face;
			fils2->parentF[1]=face->Voisins[1];

			fils2->u=0.5*(fils2->parentV[0]->u+fils2->parentV[1]->u);
			fils2->v=0.5*(fils2->parentV[0]->v+fils2->parentV[1]->v);

			fils2->g[0]=0.5*(fils2->parentV[0]->g[0]+fils2->parentV[1]->g[0]);
			fils2->g[1]=0.5*(fils2->parentV[0]->g[1]+fils2->parentV[1]->g[1]);
			fils2->g[2]=0.5*(fils2->parentV[0]->g[2]+fils2->parentV[1]->g[2]);

			fils2->fGeom[0]=0;
			fils2->fGeom[1]=0;
			fils2->fGeom[2]=0;

			fils2->level=face->level+1;

			for (i=0; i<NbNiveauMax; i++) {
				fils2->hGeom[i][0]=0; 
				fils2->hGeom[i][1]=0; 
				fils2->hGeom[i][2]=0; 
			}
			if (!tension)
				moveVertexButterflyS(fils2);
		}
		
		

		/* Troisieme sommet */

		ticket=0;
		
		if (face->Voisins[2]==NULL) ticket=1; /* On va creer le sommet */
		else {
			if (face->Voisins[2]->children[0]==NULL) ticket=1;
			else {
				/* On regarde l'orientation du voisin de face */
				critere=(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[0])+
						(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[1])*2+
						(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[2])*4;
				switch(critere) {
				case 1:
					arete=2;
					break;
				case 2:
					arete=0;
					break;
				case 4:
					arete=1;
					break;
				}
				/* On affecte le soi disant nouveau point a sa vraie valeur */

				fils3=face->Voisins[2]->sommetArete[arete];

				// Et on oublie pas de mettre  jour parentF !!!
				fils3->parentF[0]=face;
				fils3->parentF[1]=face->Voisins[2];
			}
		}

		if (ticket==1) {

			if ((fils3=(Sommet*)malloc(sizeof(Sommet)))==NULL) fprintf(stderr, " divise : can't allocate memory");

			if (Q->Gap==NULL) {
				Q->VertexTable[Q->Top]=fils3;
				fils3->indice=Q->Top;
				Q->Top++;
			} else {
				Q->VertexTable[Q->Gap->sommet]=fils3;
				fils3->indice=Q->Gap->sommet;
				// On depile Gap
				PileDeSommets *tmp=(PileDeSommets *)malloc(sizeof(PileDeSommets));
				tmp=Q->Gap;
				Q->Gap=Q->Gap->next;
				free(tmp);
			}

			// Affectation dans Q->nouveaux
			PileDeSommets *PDS=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			PDS->sommet=fils3->indice;
			PDS->next=Q->nouveaux;
			Q->nouveaux=PDS;

			fils3->parentV[0]=face->sommetCoin[2];
			fils3->parentV[1]=face->sommetCoin[0];

			fils3->parentF[0]=face;
			fils3->parentF[1]=face->Voisins[2];

			fils3->u=0.5*(fils3->parentV[0]->u+fils3->parentV[1]->u);
			fils3->v=0.5*(fils3->parentV[0]->v+fils3->parentV[1]->v);

			fils3->g[0]=0.5*(fils3->parentV[0]->g[0]+fils3->parentV[1]->g[0]);
			fils3->g[1]=0.5*(fils3->parentV[0]->g[1]+fils3->parentV[1]->g[1]);
			fils3->g[2]=0.5*(fils3->parentV[0]->g[2]+fils3->parentV[1]->g[2]);

			fils3->fGeom[0]=0;
			fils3->fGeom[1]=0;
			fils3->fGeom[2]=0;

			fils3->level=face->level+1;

			for (i=0; i<NbNiveauMax; i++) {
				fils3->hGeom[i][0]=0; 
				fils3->hGeom[i][1]=0; 
				fils3->hGeom[i][2]=0; 
			}
			if (!tension)
				moveVertexButterflyS(fils3);
		}

		

		/* Mise a jour des champs des filles */

		/* Premiere fille */

		fille1->level=(face->level)+1;

		fille1->children[0]=NULL;
		fille1->children[1]=NULL;
		fille1->children[2]=NULL;
		fille1->children[3]=NULL;

		fille1->sommetCoin[0]=face->sommetCoin[0];
		fille1->sommetCoin[1]=fils1;
		fille1->sommetCoin[2]=fils3;

		fille1->sommetArete[0]=NULL;
		fille1->sommetArete[1]=NULL;
		fille1->sommetArete[2]=NULL;

		fille1->indice=-1;

			/* Voisins */

		fille1->Voisins[1]=fille4;

			/* Pour les autres, on regarde les orientations des voisins */

		if (face->Voisins[0]==NULL) fille1->Voisins[0]=NULL;
		else {
			if (face->Voisins[0]->children[0]==NULL) fille1->Voisins[0]=NULL;
			else {
				/* On regarde l'orientation du voisin de face */
				critere=(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[0])+
						(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[1])*2+
						(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[2])*4;
				switch(critere) {
				case 1:
					arete=0;
					break;
				case 2:
					arete=1;
					break;
				case 4:
					arete=2;
					break;
				}
				/* On met en relation les soeurs retrouves */

				fille1->Voisins[0]=face->Voisins[0]->children[arete];
				switch(arete) {
				case 0:
					fille1->Voisins[0]->Voisins[2]=fille1;
					break;
				case 1:
					fille1->Voisins[0]->Voisins[0]=fille1;
					break;
				case 2:
					fille1->Voisins[0]->Voisins[1]=fille1;
					break;
				}
			}
		}

			/* Pour l'autre face */

		if (face->Voisins[2]==NULL) fille1->Voisins[2]=NULL;
		else {
			if (face->Voisins[2]->children[0]==NULL) fille1->Voisins[2]=NULL;
			else {
				/* On regarde l'orientation du voisin de face */
				critere=(face->sommetCoin[0]==face->Voisins[2]->sommetCoin[0])+
						(face->sommetCoin[0]==face->Voisins[2]->sommetCoin[1])*2+
						(face->sommetCoin[0]==face->Voisins[2]->sommetCoin[2])*4;
				switch(critere) { 
				case 1:
					arete=0;
					break;
				case 2:
					arete=1;
					break;
				case 4:
					arete=2;
					break;
				}
				/* On met en relation les soeurs retrouves */

				fille1->Voisins[2]=face->Voisins[2]->children[arete];
				switch(arete) {
				case 0:
					fille1->Voisins[2]->Voisins[0]=fille1;
					break;
				case 1:
					fille1->Voisins[2]->Voisins[1]=fille1;
					break;
				case 2:
					fille1->Voisins[2]->Voisins[2]=fille1;
					break;
				}
			}
		}


		fille2->level=(face->level)+1;

		fille2->children[0]=NULL;
		fille2->children[1]=NULL;
		fille2->children[2]=NULL;
		fille2->children[3]=NULL;

		fille2->sommetCoin[0]=fils1;
		fille2->sommetCoin[1]=face->sommetCoin[1];
		fille2->sommetCoin[2]=fils2;

		fille2->sommetArete[0]=NULL;
		fille2->sommetArete[1]=NULL;
		fille2->sommetArete[2]=NULL;

		fille2->indice=-1;

			/* Voisins */

		fille2->Voisins[2]=fille4;

			/* Pour les autres, on regarde les orientations des voisins */

		if (face->Voisins[0]==NULL) fille2->Voisins[0]=NULL;
		else {
			if (face->Voisins[0]->children[0]==NULL) fille2->Voisins[0]=NULL;
			else {
				/* On regarde l'orientation du voisin de face */
				critere=(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[0])+
						(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[1])*2+
						(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[2])*4;
				switch(critere) {
				case 1:
					arete=2;
					break;
				case 2:
					arete=0;
					break;
				case 4:
					arete=1;
					break;
				}
				/* On met en relation les soeurs retrouves */

				fille2->Voisins[0]=face->Voisins[0]->children[arete];
				switch(arete) {
				case 0:
					fille2->Voisins[0]->Voisins[0]=fille2;
					break;
				case 1:
					fille2->Voisins[0]->Voisins[1]=fille2;
					break;
				case 2:
					fille2->Voisins[0]->Voisins[2]=fille2;
					break;
				}
			}
		}

			/* Pour l'autre face */

		if (face->Voisins[1]==NULL) fille2->Voisins[1]=NULL;
		else {
			if (face->Voisins[1]->children[0]==NULL) fille2->Voisins[1]=NULL;
			else {
				/* On regarde l'orientation du voisin de face */
				critere=(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[0])+
						(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[1])*2+
						(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[2])*4;
				switch(critere) { 
				case 1:
					arete=0;
					break;
				case 2:
					arete=1;
					break;
				case 4:
					arete=2;
					break;
				}
				/* On met en relation les soeurs retrouves */

				fille2->Voisins[1]=face->Voisins[1]->children[arete];
				switch(arete) {
				case 0:
					fille2->Voisins[1]->Voisins[2]=fille2;
					break;
				case 1:
					fille2->Voisins[1]->Voisins[0]=fille2;
					break;
				case 2:
					fille2->Voisins[1]->Voisins[1]=fille2;
					break;
				}
			}
		}


		fille3->level=(face->level)+1;

		fille3->children[0]=NULL;
		fille3->children[1]=NULL;
		fille3->children[2]=NULL;
		fille3->children[3]=NULL;

		fille3->sommetCoin[0]=fils3;
		fille3->sommetCoin[1]=fils2;
		fille3->sommetCoin[2]=face->sommetCoin[2];

		fille3->sommetArete[0]=NULL;
		fille3->sommetArete[1]=NULL;
		fille3->sommetArete[2]=NULL;

		fille3->indice=-1;

		/* Voisins */

		fille3->Voisins[0]=fille4;

			/* Pour les autres, on regarde les orientations des voisins */

		if (face->Voisins[1]==NULL) fille3->Voisins[1]=NULL;
		else {
			if (face->Voisins[1]->children[0]==NULL) fille3->Voisins[1]=NULL;
			else {
				/* On regarde l'orientation du voisin de face */
				critere=(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[0])+
						(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[1])*2+
						(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[2])*4;
				switch(critere) {
				case 1:
					arete=2;
					break;
				case 2:
					arete=0;
					break;
				case 4:
					arete=1;
					break;
				}
				/* On met en relation les soeurs retrouves */

				fille3->Voisins[1]=face->Voisins[1]->children[arete];
				switch(arete) {
				case 0:
					fille3->Voisins[1]->Voisins[0]=fille3;
					break;
				case 1:
					fille3->Voisins[1]->Voisins[1]=fille3;
					break;
				case 2:
					fille3->Voisins[1]->Voisins[2]=fille3;
					break;
				}
			}
		}

			/* Pour l'autre face */

		if (face->Voisins[2]==NULL) fille3->Voisins[2]=NULL;
		else {
			if (face->Voisins[2]->children[0]==NULL) fille3->Voisins[2]=NULL;
			else {
				/* On regarde l'orientation du voisin de face */
				critere=(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[0])+
						(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[1])*2+
						(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[2])*4;
				switch(critere) { 
				case 1:
					arete=0;
					break;
				case 2:
					arete=1;
					break;
				case 4:
					arete=2;
					break;
				}
				/* On met en relation les soeurs retrouves */

				fille3->Voisins[2]=face->Voisins[2]->children[arete];
				switch(arete) {
				case 0:
					fille3->Voisins[2]->Voisins[2]=fille3;
					break;
				case 1:
					fille3->Voisins[2]->Voisins[0]=fille3;
					break;
				case 2:
					fille3->Voisins[2]->Voisins[1]=fille3;
					break;
				}
			}
		}

		fille4->indice=-1;

		/* Quatrieme fille, la plus facile avec les voisins */

		fille4->level=(face->level)+1;
			
		fille4->children[0]=NULL;
		fille4->children[1]=NULL;
		fille4->children[2]=NULL;
		fille4->children[3]=NULL;

		fille4->sommetCoin[0]=fils1;
		fille4->sommetCoin[1]=fils2;
		fille4->sommetCoin[2]=fils3;

		fille4->sommetArete[0]=NULL;
		fille4->sommetArete[1]=NULL;
		fille4->sommetArete[2]=NULL;

		fille4->Voisins[0]=fille2;
		fille4->Voisins[1]=fille3;
		fille4->Voisins[2]=fille1;

		/* Puis on met a jour la face mere */

		face->sommetArete[0]=fils1;
		face->sommetArete[1]=fils2;
		face->sommetArete[2]=fils3;

		face->children[0]=fille1;
		face->children[1]=fille2;
		face->children[2]=fille3;
		face->children[3]=fille4;

		//Mise  jour de FaceGap
		if (mesh->FacePresente[face->indice]) {
			PileDeFaces *tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
			mesh->FacePresente[face->indice]=0;
			tmp->face=face->indice;
			tmp->next=mesh->FaceGap;
			mesh->FaceGap=tmp;
		}
		
	}
	
}



void uniformLowPassButterfly(Qtree *Q, Mesh *mesh, int tension) {

	// Subdivision uniforme (on divise une fois chaque triangle)

	int i;

	for (i=0; i<Q->NbRacine; i++) {
		uniformDivideButterfly(Q, Q->racines[i], mesh, tension);
	}

}


void uniformHighPassNLButterfly(Qtree *Q, Mesh *mesh, WaveRep *wr, int j, VertexPerCoeff *VPC) {


	int i;

	for (i=0; i<wr->NbCoeff; i++) {
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==j)
			absoluteLocalHighPassNLB(wr->tab[i], i, mesh, Q, VPC);
	}

}

void uniformPruneButterfly(Qtree *Q, Face_WSZT*f, Mesh *mesh) {

	if (f->children[0]!=NULL) {
		if (f->children[0]->children[0]!=NULL) {
			uniformPruneButterfly(Q, f->children[0], mesh);
			uniformPruneButterfly(Q, f->children[1], mesh);
			uniformPruneButterfly(Q, f->children[2], mesh);
			uniformPruneButterfly(Q, f->children[3], mesh);
		} else {

			// Mise  jour de FaceGap
			if (mesh->FacePresente[f->children[0]->indice]) {
				PileDeFaces *tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
				mesh->FacePresente[f->children[0]->indice]=0;
				tmp->face=f->children[0]->indice;
				tmp->next=mesh->FaceGap;
				mesh->FaceGap=tmp;
			}
			if (mesh->FacePresente[f->children[1]->indice]) {
				PileDeFaces *tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
				mesh->FacePresente[f->children[1]->indice]=0;
				tmp->face=f->children[1]->indice;
				tmp->next=mesh->FaceGap;
				mesh->FaceGap=tmp;
			}
			if (mesh->FacePresente[f->children[2]->indice]) {
				PileDeFaces *tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
				mesh->FacePresente[f->children[2]->indice]=0;
				tmp->face=f->children[2]->indice;
				tmp->next=mesh->FaceGap;
				mesh->FaceGap=tmp;
			}
			if (mesh->FacePresente[f->children[3]->indice]) {
				PileDeFaces *tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
				mesh->FacePresente[f->children[3]->indice]=0;
				tmp->face=f->children[3]->indice;
				tmp->next=mesh->FaceGap;
				mesh->FaceGap=tmp;
			}
			

			//Libration
			free(f->children[0]);
			free(f->children[1]);
			free(f->children[2]);
			free(f->children[3]);
			f->children[0]=NULL;
			f->children[1]=NULL;
			f->children[2]=NULL;
			f->children[3]=NULL;
		
		}
	}

}

void uniformLowPassPruneButterfly(Qtree *Q, Mesh *mesh) {
	
	int i;

	for (i=0; i<Q->NbRacine; i++) {
		uniformPruneButterfly(Q, Q->racines[i], mesh);
	}
}

void harvest(Sommet *s) {
	// Dual spread
	moveVertexButterflyS(s);
}

void harvestOffset(Sommet *s, Qtree *Q, int level) {
	// Dual spread
	moveVertexButterflySOffset(s, Q, level);
}

void spread(Sommet *s) {
	// Dual harvest
	moveVertexButterflySDual(s);
}

void spreadOffset(Sommet *s, Qtree *Q, int level) {
	// Dual harvest
	moveVertexButterflySDualOffset(s, Q, level);
}

void naiveRebuildNLB(Qtree *Q, WaveRep *wr, int [NbFaceMax], int bk, int temps2, double distanceAlObs, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0, int tension) {

	// Naive reconstruction with non-lifted Butterfly wavelets
	// do {low-pass + high-pass} foreach level
	// Very slow, not to be used in view-dependent vis.
	

	int i, j=1;

	for (i=Q->NbVertex; i<wr->NbCoeff; i++) {
		if ((wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma)>j) {		
			uniformLowPassButterfly(Q, mesh, tension);
			evaluateQueue(Q, mesh);
			renderLight(Q, mesh);
			j=wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma;
			uniformHighPassNLButterfly(Q, mesh, wr, j, VPC);
			evaluateQueue(Q, mesh);
			renderLight(Q, mesh);
		}
	}
	//Lissage optionnel
	/*for (i=2*j; i<32; i*=2) {
		uniformLowPassButterfly(Q, mesh);
		evaluateQueue(Q, mesh);
		renderLight(Q, mesh);
	}
*/}

void adaptRebuildNLB(Qtree *Q, WaveRep *wr, int [NbFaceMax], int bk, int temps2, double distanceAlObs, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {
	

	int i, j=1;

	for (i=Q->NbVertex; i<wr->NbCoeff; i++) {
		if ((wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma)>j) {		
			uniformLowPassButterfly(Q, mesh, 0);
			evaluateQueue(Q, mesh);
			renderLight(Q, mesh);
			j=wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma;
			uniformHighPassNLButterfly(Q, mesh, wr, j, VPC);
			evaluateQueue(Q, mesh);
			renderLight(Q, mesh);
		}
	}
	//Lissage optionnel
	/*for (i=2*j; i<32; i*=2) {
		uniformLowPassButterfly(Q, mesh);
		evaluateQueue(Q, mesh);
		renderLight(Q, mesh);
	}
*/}

//---------------------------------------------------------------------

// Analysis

//---------------------------------------------------------------------

void ButterflyPredict(Sommet *s, double prediction[3]) {
	
	// Odd vertices are moved according to the LPF mask
	// Prvoir le cas avec bord

	float NewPos[3], tmp[3];
	Face_WSZT*f, *f1;
	Sommet *tmps;
	void *tmpv1, *tmpv2, *tmpv3, *tmpv4;
	int N=0;
	bool ticket=TRUE;


	if (s->level==0) return;

	// 8
	if ((tmpv1=s->parentV[0])!=NULL) {
		NewPos[0]=8*((Sommet*)tmpv1)->g[0];
		NewPos[1]=8*((Sommet*)tmpv1)->g[1];
		NewPos[2]=8*((Sommet*)tmpv1)->g[2];
		N+=8;
	}



	// 8
	if ((tmpv2=s->parentV[1])!=NULL) {
		NewPos[0]+=8*((Sommet*)tmpv2)->g[0];
		NewPos[1]+=8*((Sommet*)tmpv2)->g[1];
		NewPos[2]+=8*((Sommet*)tmpv2)->g[2];
		N+=8;
	}

	//2 
	if (s->parentF[0]!=NULL) {
		if ((f=s->parentF[0])!=NULL) {
			if (f->sommetCoin[0]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[0]->indice!=((Sommet*)tmpv2)->indice)
				tmpv3=f->sommetCoin[0];
			else if (f->sommetCoin[1]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[1]->indice!=((Sommet*)tmpv2)->indice)
				tmpv3=f->sommetCoin[1];
			else if (f->sommetCoin[2]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[2]->indice!=((Sommet*)tmpv2)->indice)
				tmpv3=f->sommetCoin[2];
			else 
				/*Beep(440, 000)*/;
			NewPos[0]+=2*((Sommet*)tmpv3)->g[0];
			NewPos[1]+=2*((Sommet*)tmpv3)->g[1];
			NewPos[2]+=2*((Sommet*)tmpv3)->g[2];
			N+=2;
		}
	}

	//2
	if (s->parentF[1]!=NULL) {
		if ((f=s->parentF[1])!=NULL) {
			if (f->sommetCoin[0]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[0]->indice!=((Sommet*)tmpv2)->indice)
				tmpv4=f->sommetCoin[0];
			else if (f->sommetCoin[1]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[1]->indice!=((Sommet*)tmpv2)->indice)
				tmpv4=f->sommetCoin[1];
			else if (f->sommetCoin[2]->indice!=((Sommet*)tmpv1)->indice && f->sommetCoin[2]->indice!=((Sommet*)tmpv2)->indice)
				tmpv4=f->sommetCoin[2];
			else 
				/*Beep(440, 000)*/;
			NewPos[0]+=2*((Sommet*)tmpv4)->g[0];
			NewPos[1]+=2*((Sommet*)tmpv4)->g[1];
			NewPos[2]+=2*((Sommet*)tmpv4)->g[2];	
			N+=2;
		}
	}


	//-1
	if (s->parentF[0]!=NULL) {
		if (s->parentF[0]->Voisins[0]!=s->parentF[1] && s->parentF[0]->Voisins[0]!=NULL)
			f=s->parentF[0]->Voisins[0];
		else if (s->parentF[0]->Voisins[1]!=s->parentF[1] && s->parentF[0]->Voisins[1]!=NULL)
			f=s->parentF[0]->Voisins[1];
		else if (s->parentF[0]->Voisins[2]!=s->parentF[1] && s->parentF[0]->Voisins[2]!=NULL)
			f=s->parentF[0]->Voisins[2];
		else { 
			ticket=FALSE;
		}
		if (ticket) {
			if (f->sommetCoin[0]!=tmpv1 && f->sommetCoin[0]!=tmpv2 && 
				f->sommetCoin[0]!=tmpv3 && f->sommetCoin[0]!=tmpv4)
				tmps=f->sommetCoin[0];
			else if (f->sommetCoin[1]!=tmpv1 && f->sommetCoin[1]!=tmpv2 && 
				f->sommetCoin[1]!=tmpv3 && f->sommetCoin[1]!=tmpv4)
				tmps=f->sommetCoin[1];
			else if (f->sommetCoin[2]!=tmpv1 && f->sommetCoin[2]!=tmpv2 && 
				f->sommetCoin[2]!=tmpv3 && f->sommetCoin[2]!=tmpv4)
				tmps=f->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->g[0];
				NewPos[1]-=tmps->g[1];
				NewPos[2]-=tmps->g[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}
	
	//-1
	if (s->parentF[0]!=NULL) {
		if (s->parentF[0]->Voisins[0]!=s->parentF[1] && s->parentF[0]->Voisins[0]!=f && s->parentF[0]->Voisins[0]!=NULL)
			f1=s->parentF[0]->Voisins[0];
		else if (s->parentF[0]->Voisins[1]!=s->parentF[1] && s->parentF[0]->Voisins[1]!=f && s->parentF[0]->Voisins[1]!=NULL)
			f1=s->parentF[0]->Voisins[1];
		else if (s->parentF[0]->Voisins[2]!=s->parentF[1] && s->parentF[0]->Voisins[2]!=f && s->parentF[0]->Voisins[2]!=NULL)
			f1=s->parentF[0]->Voisins[2];
		else {
			ticket=FALSE;
		}
		if (ticket) {
			if (f1->sommetCoin[0]!=tmpv1 && f1->sommetCoin[0]!=tmpv2 && 
				f1->sommetCoin[0]!=tmpv3 && f1->sommetCoin[0]!=tmpv4)
				tmps=f1->sommetCoin[0];
			else if (f1->sommetCoin[1]!=tmpv1 && f1->sommetCoin[1]!=tmpv2 && 
				f1->sommetCoin[1]!=tmpv3 && f1->sommetCoin[1]!=tmpv4)
				tmps=f1->sommetCoin[1];
			else if (f1->sommetCoin[2]!=tmpv1 && f1->sommetCoin[2]!=tmpv2 && 
				f1->sommetCoin[2]!=tmpv3 && f1->sommetCoin[2]!=tmpv4)
				tmps=f1->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->g[0];
				NewPos[1]-=tmps->g[1];
				NewPos[2]-=tmps->g[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}

	//-1
	if (s->parentF[1]!=NULL) {
		if (s->parentF[1]->Voisins[0]!=s->parentF[0] && s->parentF[1]->Voisins[0]!=NULL)
			f=s->parentF[1]->Voisins[0];
		else if (s->parentF[1]->Voisins[1]!=s->parentF[0] && s->parentF[1]->Voisins[1]!=NULL)
			f=s->parentF[1]->Voisins[1];
		else if (s->parentF[1]->Voisins[2]!=s->parentF[0] && s->parentF[1]->Voisins[2]!=NULL)
			f=s->parentF[1]->Voisins[2];
		else {
			ticket=FALSE;
		}
		if (ticket) {
			if (f->sommetCoin[0]!=tmpv1 && f->sommetCoin[0]!=tmpv2 && 
				f->sommetCoin[0]!=tmpv3 && f->sommetCoin[0]!=tmpv4)
				tmps=f->sommetCoin[0];
			else if (f->sommetCoin[1]!=tmpv1 && f->sommetCoin[1]!=tmpv2 && 
				f->sommetCoin[1]!=tmpv3 && f->sommetCoin[1]!=tmpv4)
				tmps=f->sommetCoin[1];
			else if (f->sommetCoin[2]!=tmpv1 && f->sommetCoin[2]!=tmpv2 && 
				f->sommetCoin[2]!=tmpv3 && f->sommetCoin[2]!=tmpv4)
				tmps=f->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->g[0];
				NewPos[1]-=tmps->g[1];
				NewPos[2]-=tmps->g[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}
	
	//-1
	if (s->parentF[1]!=NULL) {
		if (s->parentF[1]->Voisins[0]!=s->parentF[0] && s->parentF[1]->Voisins[0]!=f && s->parentF[1]->Voisins[0]!=NULL)
			f1=s->parentF[1]->Voisins[0];
		else if (s->parentF[1]->Voisins[1]!=s->parentF[0] && s->parentF[1]->Voisins[1]!=f && s->parentF[1]->Voisins[1]!=NULL)
			f1=s->parentF[1]->Voisins[1];
		else if (s->parentF[1]->Voisins[2]!=s->parentF[0] && s->parentF[1]->Voisins[2]!=f && s->parentF[1]->Voisins[2]!=NULL)
			f1=s->parentF[1]->Voisins[2];
		else {
			ticket=FALSE;
		}
		if (ticket) {
			if (f1->sommetCoin[0]!=tmpv1 && f1->sommetCoin[0]!=tmpv2 && 
				f1->sommetCoin[0]!=tmpv3 && f1->sommetCoin[0]!=tmpv4)
				tmps=f1->sommetCoin[0];
			else if (f1->sommetCoin[1]!=tmpv1 && f1->sommetCoin[1]!=tmpv2 && 
				f1->sommetCoin[1]!=tmpv3 && f1->sommetCoin[1]!=tmpv4)
				tmps=f1->sommetCoin[1];
			else if (f1->sommetCoin[2]!=tmpv1 && f1->sommetCoin[2]!=tmpv2 && 
				f1->sommetCoin[2]!=tmpv3 && f1->sommetCoin[2]!=tmpv4)
				tmps=f1->sommetCoin[2];
			else {
				ticket=FALSE;
			}
			if (ticket) {
				NewPos[0]-=tmps->g[0];
				NewPos[1]-=tmps->g[1];
				NewPos[2]-=tmps->g[2];
				N-=1;
			}
		}
		ticket=TRUE;
	}

	//Normalisation

	NewPos[0]/=N;
	NewPos[1]/=N;
	NewPos[2]/=N;

	prediction[0]=NewPos[0];
	prediction[1]=NewPos[1];
	prediction[2]=NewPos[2];

}

void ButterflyPredict(Qtree *Q, int flag, int vertexind, double prediction[3], double detail[3]) {
	
	switch(flag) {
	case 0: //Non-Lifted-Midpoint
		
		prediction[0]=0.5*(Q->VertexTable[vertexind]->parentV[0]->g[0]+Q->VertexTable[vertexind]->parentV[1]->g[0]);
		prediction[1]=0.5*(Q->VertexTable[vertexind]->parentV[0]->g[1]+Q->VertexTable[vertexind]->parentV[1]->g[1]);
		prediction[2]=0.5*(Q->VertexTable[vertexind]->parentV[0]->g[2]+Q->VertexTable[vertexind]->parentV[1]->g[2]);
		moins(Q->VertexTable[vertexind]->g, prediction, detail);
		break;
	case 1: //Lifted-Midpoint
		
		prediction[0]=0.5*(Q->VertexTable[vertexind]->parentV[0]->g[0]+Q->VertexTable[vertexind]->parentV[1]->g[0]);
		prediction[1]=0.5*(Q->VertexTable[vertexind]->parentV[0]->g[1]+Q->VertexTable[vertexind]->parentV[1]->g[1]);
		prediction[2]=0.5*(Q->VertexTable[vertexind]->parentV[0]->g[2]+Q->VertexTable[vertexind]->parentV[1]->g[2]);
		moins(Q->VertexTable[vertexind]->g, prediction, detail);
		break;
	case 2: //Non-lifted Butterfly
		
		ButterflyPredict(Q->VertexTable[vertexind], prediction);
		moins(Q->VertexTable[vertexind]->g, prediction, detail);
		break;
	case 3: //Lifted Butterfly
		
		ButterflyPredict(Q->VertexTable[vertexind], prediction);
		moins(Q->VertexTable[vertexind]->g, prediction, detail);
		break;
	}
}

void OneLevelAnalysis(Qtree *Q, Mesh *M, int flag, int j) {
	
	// Remplace le champ des positions des sommets de niveau j par les coefficients d'ondelettes
	// Et procde au filtrage passe bas 
	
	int vertexind;
	double prediction[3];
	double detail[3];

	for (vertexind=0; vertexind<Q->Top; vertexind++) {
		if (Q->VertexTable[vertexind]->level==j) {
			//Predition
			ButterflyPredict(Q, flag, vertexind, prediction, detail);
			egale(Q->VertexTable[vertexind]->g, detail);
			
			//Mise  jour
			if (flag==1 || flag==3) {
				Q->VertexTable[vertexind]->parentV[0]->g[0]+=0.125*detail[0];
				Q->VertexTable[vertexind]->parentV[0]->g[1]+=0.125*detail[1];
				Q->VertexTable[vertexind]->parentV[0]->g[2]+=0.125*detail[2];
			}
		}
	}

}

void fillCoeffsButterfly(Qtree *Q, Mesh *M, int flag) {

	// flag value (changed) : 0 for non-lifted midpoint (Butterfly with infinite tension)
	//						  1 for lifted midpoint (Butterfly with infinite tension)
	//						  2 for non-lifted Butterfly
	//						  3 for lifted Butterfly
	
	int niveau;
	Face_WSZT*f;

	// Rappel du niveau
	niveau=0;
	f=Q->racines[0];
	while (f!=NULL) {
		f=f->children[0];
		niveau++;
	}

	// Analyse sur chaque niveau
	while (niveau!=0) {
		OneLevelAnalysis(Q, M, flag, niveau);
		niveau--;
	}

	
}
/*
void naiveRebuildNLB2(Qtree *Q, WaveRep *wr, Mesh *mesh, Mesh *M0, int tension) {

	// Naive reconstruction with non-lifted Butterfly wavelets
	// do {low-pass + high-pass} foreach level
	// Very slow, not to be used in view-dependent vis.
	

	int i, j=1;

	for (i=Q->NbVertex; i<wr->NbCoeff; i++) {
		if ((wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma)>j) {		
			uniformLowPassButterfly(Q, mesh, tension);
			evaluateQueue(Q, mesh);
			renderLight(Q, mesh);
			j=wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma;
			uniformHighPassNLButterfly(Q, mesh, wr, j, tension);
			evaluateQueue(Q, mesh);
			renderLight(Q, mesh);
		}
	}
	//Lissage optionnel
	for (i=2*j; i<32; i*=2) {
		uniformLowPassButterfly(Q, mesh, tension);
		evaluateQueue(Q, mesh);
		renderLight(Q, mesh);
	}

}*/