#include "stdafx.h"
#include "test.h"

#include <stdio.h>
#include "proto.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

void lowPassRecButterfly(Qtree *Q, Face_WSZT*face) {

	// Low pass reconstruction filter for Butterfly scheme

	// (Va avec accomodate2 (sommets etiquets avec les coefficients))
	// Place les nouveaux sommets entre leurs parents

	Face_WSZT *fille1, *fille2, *fille3, *fille4;
	Sommet *fils1, *fils2, *fils3;
	int ticket, arete, critere, i;

	/* Allocation familliale */

	if ((fille1=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");
	if ((fille2=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");
	if ((fille3=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");
	if ((fille4=(Face_WSZT*)malloc(sizeof(Face_WSZT)))==NULL) fprintf(stderr, " divise : can't allocate memory");

	//liste vides
	fille1->Coeff_list=fille2->Coeff_list=fille3->Coeff_list=fille4->Coeff_list=NULL;

	/* Allocation eventuelle des nouveaux sommets, suivant qu'il ont deja ete crees */
	/* dans une autre facette ou pas */

	/* Premier sommet */

	ticket=0;
	
	if (face->Voisins[0]==NULL) ticket=1; /* On va creer le sommet */
	else {
		if (face->Voisins[0]->children[0]==NULL) ticket=1;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[0])+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[1])*2+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On affecte le soi disant nouveau point a sa vraie valeur */

			fils1=face->Voisins[0]->sommetArete[arete];

			// Et on oublie pas de mettre  jour parentF !!!
			fils1->parentF[0]=face;
			fils1->parentF[1]=face->Voisins[0];
		}
	}

	if (ticket==1) {
		if ((fils1=(Sommet*)malloc(sizeof(Sommet)))==NULL) fprintf(stderr, " divise : can't allocate memory");

		if (Q->Gap==NULL) {
			Q->VertexTable[Q->Top]=fils1;
			fils1->indice=Q->Top;
			Q->Top++;
		} else {
			Q->VertexTable[Q->Gap->sommet]=fils1;
			fils1->indice=Q->Gap->sommet;
			// On depile Gap
			PileDeSommets *tmp=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			tmp=Q->Gap;
			Q->Gap=Q->Gap->next;
			free(tmp);
		}

		// Affectation dans Q->nouveaux
		PileDeSommets *PDS=(PileDeSommets *)malloc(sizeof(PileDeSommets));
		PDS->sommet=fils1->indice;
		PDS->next=Q->nouveaux;
		Q->nouveaux=PDS;

		fils1->parentV[0]=face->sommetCoin[0];
		fils1->parentV[1]=face->sommetCoin[1];

		fils1->parentF[0]=face;	
		fils1->parentF[1]=face->Voisins[0];

		fils1->u=0.5*(fils1->parentV[0]->u+fils1->parentV[1]->u);
		fils1->v=0.5*(fils1->parentV[0]->v+fils1->parentV[1]->v);
		
		fils1->g[0]=0.5*(fils1->parentV[0]->g[0]+fils1->parentV[1]->g[0]);
		fils1->g[1]=0.5*(fils1->parentV[0]->g[1]+fils1->parentV[1]->g[1]);
		fils1->g[2]=0.5*(fils1->parentV[0]->g[2]+fils1->parentV[1]->g[2]);

		fils1->fGeom[0]=0;
		fils1->fGeom[1]=0;
		fils1->fGeom[2]=0;

		fils1->level=face->level+1;


		for (i=0; i<NbNiveauMax; i++) {
			fils1->hGeom[i][0]=0; 
			fils1->hGeom[i][1]=0; 
			fils1->hGeom[i][2]=0; 
		}
	}

	/* Deuxieme sommet */

	ticket=0;
	
	if (face->Voisins[1]==NULL) ticket=1; /* On va creer le sommet */
	else {
		if (face->Voisins[1]->children[0]==NULL) ticket=1;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[0])+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[1])*2+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On affecte le soi disant nouveau point a sa vraie valeur */

			fils2=face->Voisins[1]->sommetArete[arete];

			// Et on oublie pas de mettre  jour parentF !!!
			fils2->parentF[0]=face;
			fils2->parentF[1]=face->Voisins[1];

		}
	}

	if (ticket==1) {
		
		if ((fils2=(Sommet*)malloc(sizeof(Sommet)))==NULL) fprintf(stderr, " divise : can't allocate memory");

		if (Q->Gap==NULL) {
			Q->VertexTable[Q->Top]=fils2;
			fils2->indice=Q->Top;
			Q->Top++;
		} else {
			Q->VertexTable[Q->Gap->sommet]=fils2;
			fils2->indice=Q->Gap->sommet;
			// On depile Gap
			PileDeSommets *tmp=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			tmp=Q->Gap;
			Q->Gap=Q->Gap->next;
			free(tmp);
		}

		// Affectation dans Q->nouveaux
		PileDeSommets *PDS=(PileDeSommets *)malloc(sizeof(PileDeSommets));
		PDS->sommet=fils2->indice;
		PDS->next=Q->nouveaux;
		Q->nouveaux=PDS;

		fils2->parentV[0]=face->sommetCoin[1];
		fils2->parentV[1]=face->sommetCoin[2];

		fils2->parentF[0]=face;
		fils2->parentF[1]=face->Voisins[1];

		fils2->u=0.5*(fils2->parentV[0]->u+fils2->parentV[1]->u);
		fils2->v=0.5*(fils2->parentV[0]->v+fils2->parentV[1]->v);

		fils2->g[0]=0.5*(fils2->parentV[0]->g[0]+fils2->parentV[1]->g[0]);
		fils2->g[1]=0.5*(fils2->parentV[0]->g[1]+fils2->parentV[1]->g[1]);
		fils2->g[2]=0.5*(fils2->parentV[0]->g[2]+fils2->parentV[1]->g[2]);

		fils2->fGeom[0]=0;
		fils2->fGeom[1]=0;
		fils2->fGeom[2]=0;

		fils2->level=face->level+1;

		for (i=0; i<NbNiveauMax; i++) {
			fils2->hGeom[i][0]=0; 
			fils2->hGeom[i][1]=0; 
			fils2->hGeom[i][2]=0; 
		}
	}
	

	/* Troisieme sommet */

	ticket=0;
	
	if (face->Voisins[2]==NULL) ticket=1; /* On va creer le sommet */
	else {
		if (face->Voisins[2]->children[0]==NULL) ticket=1;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[0])+
					(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[1])*2+
					(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On affecte le soi disant nouveau point a sa vraie valeur */

			fils3=face->Voisins[2]->sommetArete[arete];

			// Et on oublie pas de mettre  jour parentF !!!
			fils3->parentF[0]=face;
			fils3->parentF[1]=face->Voisins[2];
		}
	}

	if (ticket==1) {

		if ((fils3=(Sommet*)malloc(sizeof(Sommet)))==NULL) fprintf(stderr, " divise : can't allocate memory");

		if (Q->Gap==NULL) {
			Q->VertexTable[Q->Top]=fils3;
			fils3->indice=Q->Top;
			Q->Top++;
		} else {
			Q->VertexTable[Q->Gap->sommet]=fils3;
			fils3->indice=Q->Gap->sommet;
			// On depile Gap
			PileDeSommets *tmp=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			tmp=Q->Gap;
			Q->Gap=Q->Gap->next;
			free(tmp);
		}

		// Affectation dans Q->nouveaux
		PileDeSommets *PDS=(PileDeSommets *)malloc(sizeof(PileDeSommets));
		PDS->sommet=fils3->indice;
		PDS->next=Q->nouveaux;
		Q->nouveaux=PDS;

		fils3->parentV[0]=face->sommetCoin[2];
		fils3->parentV[1]=face->sommetCoin[0];

		fils3->parentF[0]=face;
		fils3->parentF[1]=face->Voisins[2];

		fils3->u=0.5*(fils3->parentV[0]->u+fils3->parentV[1]->u);
		fils3->v=0.5*(fils3->parentV[0]->v+fils3->parentV[1]->v);

		fils3->g[0]=0.5*(fils3->parentV[0]->g[0]+fils3->parentV[1]->g[0]);
		fils3->g[1]=0.5*(fils3->parentV[0]->g[1]+fils3->parentV[1]->g[1]);
		fils3->g[2]=0.5*(fils3->parentV[0]->g[2]+fils3->parentV[1]->g[2]);

		fils3->fGeom[0]=0;
		fils3->fGeom[1]=0;
		fils3->fGeom[2]=0;

		fils3->level=face->level+1;

		for (i=0; i<NbNiveauMax; i++) {
			fils3->hGeom[i][0]=0; 
			fils3->hGeom[i][1]=0; 
			fils3->hGeom[i][2]=0; 
		}
	}

	/* Mise a jour des champs des filles */

	/* Premiere fille */

	fille1->level=(face->level)+1;

	fille1->children[0]=NULL;
	fille1->children[1]=NULL;
	fille1->children[2]=NULL;
	fille1->children[3]=NULL;

	fille1->sommetCoin[0]=face->sommetCoin[0];
	fille1->sommetCoin[1]=fils1;
	fille1->sommetCoin[2]=fils3;

	fille1->sommetArete[0]=NULL;
	fille1->sommetArete[1]=NULL;
	fille1->sommetArete[2]=NULL;

	fille1->indice=-1;

		/* Voisins */

	fille1->Voisins[1]=fille4;

		/* Pour les autres, on regarde les orientations des voisins */

	if (face->Voisins[0]==NULL) fille1->Voisins[0]=NULL;
	else {
		if (face->Voisins[0]->children[0]==NULL) fille1->Voisins[0]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[0])+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[1])*2+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=0;
				break;
			case 2:
				arete=1;
				break;
			case 4:
				arete=2;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille1->Voisins[0]=face->Voisins[0]->children[arete];
			switch(arete) {
			case 0:
				fille1->Voisins[0]->Voisins[2]=fille1;
				break;
			case 1:
				fille1->Voisins[0]->Voisins[0]=fille1;
				break;
			case 2:
				fille1->Voisins[0]->Voisins[1]=fille1;
				break;
			}
		}
	}

		/* Pour l'autre face */

	if (face->Voisins[2]==NULL) fille1->Voisins[2]=NULL;
	else {
		if (face->Voisins[2]->children[0]==NULL) fille1->Voisins[2]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[0]==face->Voisins[2]->sommetCoin[0])+
					(face->sommetCoin[0]==face->Voisins[2]->sommetCoin[1])*2+
					(face->sommetCoin[0]==face->Voisins[2]->sommetCoin[2])*4;
			switch(critere) { 
			case 1:
				arete=0;
				break;
			case 2:
				arete=1;
				break;
			case 4:
				arete=2;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille1->Voisins[2]=face->Voisins[2]->children[arete];
			switch(arete) {
			case 0:
				fille1->Voisins[2]->Voisins[0]=fille1;
				break;
			case 1:
				fille1->Voisins[2]->Voisins[1]=fille1;
				break;
			case 2:
				fille1->Voisins[2]->Voisins[2]=fille1;
				break;
			}
		}
	}


	fille2->level=(face->level)+1;

	fille2->children[0]=NULL;
	fille2->children[1]=NULL;
	fille2->children[2]=NULL;
	fille2->children[3]=NULL;

	fille2->sommetCoin[0]=fils1;
	fille2->sommetCoin[1]=face->sommetCoin[1];
	fille2->sommetCoin[2]=fils2;

	fille2->sommetArete[0]=NULL;
	fille2->sommetArete[1]=NULL;
	fille2->sommetArete[2]=NULL;

	fille2->indice=-1;

		/* Voisins */

	fille2->Voisins[2]=fille4;

		/* Pour les autres, on regarde les orientations des voisins */

	if (face->Voisins[0]==NULL) fille2->Voisins[0]=NULL;
	else {
		if (face->Voisins[0]->children[0]==NULL) fille2->Voisins[0]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[0])+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[1])*2+
					(face->sommetCoin[0]==face->Voisins[0]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille2->Voisins[0]=face->Voisins[0]->children[arete];
			switch(arete) {
			case 0:
				fille2->Voisins[0]->Voisins[0]=fille2;
				break;
			case 1:
				fille2->Voisins[0]->Voisins[1]=fille2;
				break;
			case 2:
				fille2->Voisins[0]->Voisins[2]=fille2;
				break;
			}
		}
	}

		/* Pour l'autre face */

	if (face->Voisins[1]==NULL) fille2->Voisins[1]=NULL;
	else {
		if (face->Voisins[1]->children[0]==NULL) fille2->Voisins[1]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[0])+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[1])*2+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[2])*4;
			switch(critere) { 
			case 1:
				arete=0;
				break;
			case 2:
				arete=1;
				break;
			case 4:
				arete=2;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille2->Voisins[1]=face->Voisins[1]->children[arete];
			switch(arete) {
			case 0:
				fille2->Voisins[1]->Voisins[2]=fille2;
				break;
			case 1:
				fille2->Voisins[1]->Voisins[0]=fille2;
				break;
			case 2:
				fille2->Voisins[1]->Voisins[1]=fille2;
				break;
			}
		}
	}


	fille3->level=(face->level)+1;

	fille3->children[0]=NULL;
	fille3->children[1]=NULL;
	fille3->children[2]=NULL;
	fille3->children[3]=NULL;

	fille3->sommetCoin[0]=fils3;
	fille3->sommetCoin[1]=fils2;
	fille3->sommetCoin[2]=face->sommetCoin[2];

	fille3->sommetArete[0]=NULL;
	fille3->sommetArete[1]=NULL;
	fille3->sommetArete[2]=NULL;

	fille3->indice=-1;

	/* Voisins */

	fille3->Voisins[0]=fille4;

		/* Pour les autres, on regarde les orientations des voisins */

	if (face->Voisins[1]==NULL) fille3->Voisins[1]=NULL;
	else {
		if (face->Voisins[1]->children[0]==NULL) fille3->Voisins[1]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[0])+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[1])*2+
					(face->sommetCoin[1]==face->Voisins[1]->sommetCoin[2])*4;
			switch(critere) {
			case 1:
				arete=2;
				break;
			case 2:
				arete=0;
				break;
			case 4:
				arete=1;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille3->Voisins[1]=face->Voisins[1]->children[arete];
			switch(arete) {
			case 0:
				fille3->Voisins[1]->Voisins[0]=fille3;
				break;
			case 1:
				fille3->Voisins[1]->Voisins[1]=fille3;
				break;
			case 2:
				fille3->Voisins[1]->Voisins[2]=fille3;
				break;
			}
		}
	}

		/* Pour l'autre face */

	if (face->Voisins[2]==NULL) fille3->Voisins[2]=NULL;
	else {
		if (face->Voisins[2]->children[0]==NULL) fille3->Voisins[2]=NULL;
		else {
			/* On regarde l'orientation du voisin de face */
			critere=(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[0])+
					(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[1])*2+
					(face->sommetCoin[2]==face->Voisins[2]->sommetCoin[2])*4;
			switch(critere) { 
			case 1:
				arete=0;
				break;
			case 2:
				arete=1;
				break;
			case 4:
				arete=2;
				break;
			}
			/* On met en relation les soeurs retrouves */

			fille3->Voisins[2]=face->Voisins[2]->children[arete];
			switch(arete) {
			case 0:
				fille3->Voisins[2]->Voisins[2]=fille3;
				break;
			case 1:
				fille3->Voisins[2]->Voisins[0]=fille3;
				break;
			case 2:
				fille3->Voisins[2]->Voisins[1]=fille3;
				break;
			}
		}
	}

	fille4->indice=-1;

	/* Quatrieme fille, la plus facile avec les voisins */

	fille4->level=(face->level)+1;
		
	fille4->children[0]=NULL;
	fille4->children[1]=NULL;
	fille4->children[2]=NULL;
	fille4->children[3]=NULL;

	fille4->sommetCoin[0]=fils1;
	fille4->sommetCoin[1]=fils2;
	fille4->sommetCoin[2]=fils3;

    fille4->sommetArete[0]=NULL;
	fille4->sommetArete[1]=NULL;
	fille4->sommetArete[2]=NULL;

	fille4->Voisins[0]=fille2;
	fille4->Voisins[1]=fille3;
	fille4->Voisins[2]=fille1;

	/* Puis on met a jour la face mere */

	face->sommetArete[0]=fils1;
	face->sommetArete[1]=fils2;
	face->sommetArete[2]=fils3;

	face->children[0]=fille1;
	face->children[1]=fille2;
	face->children[2]=fille3;
	face->children[3]=fille4;