#include <stdlib.h>

#include <stdio.h>
#include "proto.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

void receptionCoeff(Qtree *Q, FILE *f) {

	/* Lis le coefficient d'ondelettes suivant dans le fichier f et */
	/* modifie l'arbre Q en consequence */

	/* Cas des ondelettes pics ( Les ondelettes a la resolution j sont les */
	/* fonctions d'echelle a la resolution j+1 centrees aux nouveaux points) */

	/* Bien sur, le fichier doit deja etre ouvert */

	/* !!!! Les coordonnees barycentriques doivent etre minimales (indivisibles par deux) */

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2;
	double coeff[3], ALPHA1, ALPHA2;

	fscanf(f, "%d", &face);

	while(face!=-1) {
		fscanf(f, "%d", &alpha);
		fscanf(f, "%d", &beta);
		fscanf(f, "%d", &gamma);
		fscanf(f, "%lf", &coeff[0]);
		fscanf(f, "%lf", &coeff[1]);
		fscanf(f, "%lf", &coeff[2]);
		Q->Remember=-1;
		level=log2(alpha+beta+gamma);

		/* Pic central */

		if (level>0) globalAccomodate(Q, face, level,  alpha, beta, gamma);
		else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
						 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
						 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
		Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
		Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
		Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
		
		/* Perturbations */
		
		if (level>0) {

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
				((gamma/2)*2==gamma)) {

				a=(alpha+1)/2;
				b=(beta-1)/2;
				c=gamma/2;

				aa=(alpha-1)/2;
				bb=(beta+1)/2;
				cc=gamma/2;
			}

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=(alpha+1)/2;
				b=beta/2;
				c=(gamma-1)/2;

				aa=(alpha-1)/2;
				bb=beta/2;
				cc=(gamma+1)/2;
			}

			if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=alpha/2;
				b=(beta+1)/2;
				c=(gamma-1)/2;

				aa=alpha/2;
				bb=(beta-1)/2;
				cc=(gamma+1)/2;
			}
if (aa+bb+cc!=level) {
	fprintf(stderr, "");
}
			rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
			if (Q->VertexTable[rem1]->level>0) n1=6;
			else n1=Q->Valance[rem1];		
			rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
			if (Q->VertexTable[rem2]->level>0) n2=6;
			else n2=Q->Valance[rem2];
			ALPHA(n1, n2, &ALPHA1, &ALPHA2);

			globalAccomodate(Q, face, level-1,  a, b, c);
			globalAccomodate(Q, face, level-1,  aa, bb, cc);

			Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
			
			Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
		}

		fscanf(f, "%d", &face);
	}
}

void receptionCoeff2(Qtree *Q, WaveRep *wr, int n) {

	/* Lis le coefficient d'ondelettes suivant dans le fichier f et */
	/* modifie l'arbre Q en consequence */

	/* Cas des ondelettes pics ( Les ondelettes a la resolution j sont les */
	/* fonctions d'echelle a la resolution j+1 centrees aux nouveaux points) */

	/* Bien sur, le fichier doit deja etre ouvert */

	/* !!!! Les coordonnees barycentriques doivent etre minimales (indivisibles par deux) */

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0;
	double coeff[3], ALPHA1, ALPHA2;

	while(i<n) {
		face=wr->tab[i]->F0;
		alpha=wr->tab[i]->alpha;
		beta=wr->tab[i]->beta;
		gamma=wr->tab[i]->gamma;
		coeff[0]=wr->tab[i]->x;
		coeff[1]=wr->tab[i]->y;
		coeff[2]=wr->tab[i]->z;	
		Q->Remember=-1;
		level=log2(alpha+beta+gamma);

		/* Pic central */

		if (level>0) globalAccomodate(Q, face, level,  alpha, beta, gamma);
		else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
						 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
						 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
		Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
		Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
		Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
		
		/* Perturbations */
		
		if (level>0) {

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
				((gamma/2)*2==gamma)) {

				a=(alpha+1)/2;
				b=(beta-1)/2;
				c=gamma/2;

				aa=(alpha-1)/2;
				bb=(beta+1)/2;
				cc=gamma/2;
			}

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=(alpha+1)/2;
				b=beta/2;
				c=(gamma-1)/2;

				aa=(alpha-1)/2;
				bb=beta/2;
				cc=(gamma+1)/2;
			}

			if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=alpha/2;
				b=(beta+1)/2;
				c=(gamma-1)/2;

				aa=alpha/2;
				bb=(beta-1)/2;
				cc=(gamma+1)/2;
			}

			rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
			if (Q->VertexTable[rem1]->level>0) n1=6;
			else n1=Q->Valance[rem1];		
			rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
			if (Q->VertexTable[rem2]->level>0) n2=6;
			else n2=Q->Valance[rem2];
			ALPHA(n1, n2, &ALPHA1, &ALPHA2);

			globalAccomodate(Q, face, level-1,  a, b, c);
			globalAccomodate(Q, face, level-1,  aa, bb, cc);

			Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
			
			Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
		}
		i++;
	}
}

void receptionCoeff3(Qtree *Q, WaveRep *wr, int deb, int n) {

	/* Lis le coefficient d'ondelettes suivant dans le fichier f et */
	/* modifie l'arbre Q en consequence */

	/* Cas des ondelettes pics ( Les ondelettes a la resolution j sont les */
	/* fonctions d'echelle a la resolution j+1 centrees aux nouveaux points) */

	/* Bien sur, le fichier doit deja etre ouvert */

	/* !!!! Les coordonnees barycentriques doivent etre minimales (indivisibles par deux) */

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=deb;
	double coeff[3], ALPHA1, ALPHA2;

	while(i<deb+n) {
		face=wr->tab[i]->F0;
		alpha=wr->tab[i]->alpha;
		beta=wr->tab[i]->beta;
		gamma=wr->tab[i]->gamma;
		coeff[0]=wr->tab[i]->x;
		coeff[1]=wr->tab[i]->y;
		coeff[2]=wr->tab[i]->z;	
		Q->Remember=-1;
		level=log2(alpha+beta+gamma);

		/* Pic central */

		if (level>0) globalAccomodate(Q, face, level,  alpha, beta, gamma);
		else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
						 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
						 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
		Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
		Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
		Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
		
		/* Perturbations */
		
		if (level>0) {

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
				((gamma/2)*2==gamma)) {

				a=(alpha+1)/2;
				b=(beta-1)/2;
				c=gamma/2;

				aa=(alpha-1)/2;
				bb=(beta+1)/2;
				cc=gamma/2;
			}

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=(alpha+1)/2;
				b=beta/2;
				c=(gamma-1)/2;

				aa=(alpha-1)/2;
				bb=beta/2;
				cc=(gamma+1)/2;
			}

			if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=alpha/2;
				b=(beta+1)/2;
				c=(gamma-1)/2;

				aa=alpha/2;
				bb=(beta-1)/2;
				cc=(gamma+1)/2;
			}

			rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
			if (Q->VertexTable[rem1]->level>0) n1=6;
			else n1=Q->Valance[rem1];		
			rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
			if (Q->VertexTable[rem2]->level>0) n2=6;
			else n2=Q->Valance[rem2];
			ALPHA(n1, n2, &ALPHA1, &ALPHA2);

			globalAccomodate(Q, face, level-1,  a, b, c);
			globalAccomodate(Q, face, level-1,  aa, bb, cc);

			Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
			
			Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
		}
		i++;
	}
}

void receptionCoeff21(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax]) {

	/* Lis le coefficient d'ondelettes suivant dans le fichier f et */
	/* modifie l'arbre Q en consequence */

	/* Cas des ondelettes pics ( Les ondelettes a la resolution j sont les */
	/* fonctions d'echelle a la resolution j+1 centrees aux nouveaux points) */

	/* Bien sur, le fichier doit deja etre ouvert */

	/* !!!! Les coordonnees barycentriques doivent etre minimales (indivisibles par deux) */

	//N'integre que les coefficients dont l'action est visible

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1;
	double coeff[3], ALPHA1, ALPHA2;

	while((unsigned)i<wr->NbCoeff) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		if (!ok) {
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) globalAccomodate(Q, face, level,  alpha, beta, gamma);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
			Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
			Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
		
			/* Perturbations */
		
			if (level>0) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				globalAccomodate(Q, face, level-1,  a, b, c);
				globalAccomodate(Q, face, level-1,  aa, bb, cc);
	
				Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
				Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
				Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
			
				Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
				Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
				Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
			}
		}
		i++;
	}
}

void receptionCoeff22(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int nbc) {

	/* Lis le coefficient d'ondelettes suivant dans le fichier f et */
	/* modifie l'arbre Q en consequence */

	/* Cas des ondelettes pics ( Les ondelettes a la resolution j sont les */
	/* fonctions d'echelle a la resolution j+1 centrees aux nouveaux points) */

	/* Bien sur, le fichier doit deja etre ouvert */

	/* !!!! Les coordonnees barycentriques doivent etre minimales (indivisibles par deux) */

	//N'integre que les coefficients dont l'action est visible

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;

	while((unsigned)i<wr->NbCoeff && cmpt<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		if (!ok) {
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) globalAccomodate(Q, face, level,  alpha, beta, gamma);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
			Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
			Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
		
			/* Perturbations */
		
			if (level>0) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				globalAccomodate(Q, face, level-1,  a, b, c);
				globalAccomodate(Q, face, level-1,  aa, bb, cc);
	
				Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
				Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
				Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
			
				Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
				Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
				Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
			}
		}
		i++;
	}
}

void receptionCoeff23(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int nbc, double dist) {

	/* Lis le coefficient d'ondelettes suivant dans le fichier f et */
	/* modifie l'arbre Q en consequence */

	/* Cas des ondelettes pics ( Les ondelettes a la resolution j sont les */
	/* fonctions d'echelle a la resolution j+1 centrees aux nouveaux points) */

	/* Bien sur, le fichier doit deja etre ouvert */

	/* !!!! Les coordonnees barycentriques doivent etre minimales (indivisibles par deux) */

	//N'integre que les coefficients dont l'action est visible

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;

	while((unsigned)i<wr->NbCoeff && cmpt<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		//ok=ok || (wr->tab[i]->x*wr->tab[i]->x
		//	+wr->tab[i]->y*wr->tab[i]->y
		//	+wr->tab[i]->z*wr->tab[i]->z<dist/700/700*dist);
		if (!ok) {
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) globalAccomodate(Q, face, level,  alpha, beta, gamma);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
			Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
			Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
		
			/* Perturbations */
		
			if (level>0) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				globalAccomodate(Q, face, level-1,  a, b, c);
				globalAccomodate(Q, face, level-1,  aa, bb, cc);
	
				Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
				Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
				Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
			
				Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
				Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
				Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
			}
		}
		i++;
	}
}

void receptionCoeff4(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int nbc, double dist) {

	// Adapt  globalAccomodate2
	// Mais pas incrmental

	//ATTENTION : utilise fgeom et g de faon diffrente !!!

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;

	while((unsigned)i<wr->NbCoeff && cmpt<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		ok=ok || (wr->tab[i]->x*wr->tab[i]->x
			+wr->tab[i]->y*wr->tab[i]->y
			+wr->tab[i]->z*wr->tab[i]->z>dist/700/700*dist);
		if (!ok) {
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate2(Q, face, level,  alpha, beta, gamma, i);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0 && Q->Remember!=-1)) {
				Q->VertexTable[Q->Remember]->fGeom[0]+=coeff[0];
				Q->VertexTable[Q->Remember]->fGeom[1]+=coeff[1];
				Q->VertexTable[Q->Remember]->fGeom[2]+=coeff[2];
			}

			/* Perturbations */
		
			if (level>0 && Q->Remember!=-1) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				globalAccomodate2(Q, face, level-1,  a, b, c, i);
				globalAccomodate2(Q, face, level-1,  aa, bb, cc, i);
	
				Q->VertexTable[rem1]->fGeom[0]-=coeff[0]*ALPHA1;
				Q->VertexTable[rem1]->fGeom[1]-=coeff[1]*ALPHA1;
				Q->VertexTable[rem1]->fGeom[2]-=coeff[2]*ALPHA1;
			
				Q->VertexTable[rem2]->fGeom[0]-=coeff[0]*ALPHA2;
				Q->VertexTable[rem2]->fGeom[1]-=coeff[1]*ALPHA2;
				Q->VertexTable[rem2]->fGeom[2]-=coeff[2]*ALPHA2;
			}
		}
		i++;
	}
}

void receptionCoeff41(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int nbc, double dist) {

	// Adapt  globalAccomodate2
	// Comme receptionCoeff4 mais incrmental

	//Pas bon du tout -----------> poubelle (confusion entre faces et coeffs !!!)

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2,
		i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;

	j=0;
	while(Invite[j]!=-1 && cmpt<nbc) {
	
		i=Invite[j];
		face=wr->tab[i]->F0;

		ok=(wr->tab[i]->x*wr->tab[i]->x
			+wr->tab[i]->y*wr->tab[i]->y
			+wr->tab[i]->z*wr->tab[i]->z>dist/700/700*dist)
			|| (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1);
		if (ok) {

			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate2(Q, face, level,  alpha, beta, gamma, i);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			if (level==0 && norm(Q->VertexTable[Q->Remember]->g)==0) {
				Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
				Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
				Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
			}	

			/* Perturbations */
		
			if (level>0) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				globalAccomodate2(Q, face, level-1,  a, b, c, i);
				globalAccomodate2(Q, face, level-1,  aa, bb, cc, i);
	
				Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
				Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
				Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
			
				Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
				Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
				Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
			}
		}
		j++;
	}
}

void receptionCoeff42(Qtree *Q, WaveRep *wr, int n) {

	// Remplace receptionCoeff2 avec globalAccomodate22

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0;
	double coeff[3], ALPHA1, ALPHA2;

	while(i<n) {
		face=wr->tab[i]->F0;
		alpha=wr->tab[i]->alpha;
		beta=wr->tab[i]->beta;
		gamma=wr->tab[i]->gamma;
		coeff[0]=wr->tab[i]->x;
		coeff[1]=wr->tab[i]->y;
		coeff[2]=wr->tab[i]->z;	
		Q->Remember=-1;
		level=log2(alpha+beta+gamma);

		/* Pic central */

		if (level>0) globalAccomodate2(Q, face, level,  alpha, beta, gamma, i);
		else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
						 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
						 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
		Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
		Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
		Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
		
		/* Perturbations */
		
		if (level>0) {

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
				((gamma/2)*2==gamma)) {

				a=(alpha+1)/2;
				b=(beta-1)/2;
				c=gamma/2;

				aa=(alpha-1)/2;
				bb=(beta+1)/2;
				cc=gamma/2;
			}

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=(alpha+1)/2;
				b=beta/2;
				c=(gamma-1)/2;

				aa=(alpha-1)/2;
				bb=beta/2;
				cc=(gamma+1)/2;
			}

			if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=alpha/2;
				b=(beta+1)/2;
				c=(gamma-1)/2;

				aa=alpha/2;
				bb=(beta-1)/2;
				cc=(gamma+1)/2;
			}

			rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
			if (Q->VertexTable[rem1]->level>0) n1=6;
			else n1=Q->Valance[rem1];		
			rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
			if (Q->VertexTable[rem2]->level>0) n2=6;
			else n2=Q->Valance[rem2];
			ALPHA(n1, n2, &ALPHA1, &ALPHA2);

			globalAccomodate2(Q, face, level-1,  a, b, c, i);
			globalAccomodate2(Q, face, level-1,  aa, bb, cc, i);

			Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
			
			Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
		}
		i++;
	}
}

void receptionCoeff43(Qtree *Q, WaveRep *wr, int premier, int n) {

	// (Remplace receptionCoeff2 avec globalAccomodate22)
	// Comme 42 mais incrmental

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0;
	double coeff[3], ALPHA1, ALPHA2;

	i=premier;
	while(i<n) {
		face=wr->tab[i]->F0;
		alpha=wr->tab[i]->alpha;
		beta=wr->tab[i]->beta;
		gamma=wr->tab[i]->gamma;
		coeff[0]=wr->tab[i]->x;
		coeff[1]=wr->tab[i]->y;
		coeff[2]=wr->tab[i]->z;	
		Q->Remember=-1;
		level=log2(alpha+beta+gamma);

		/* Pic central */

		if (level>0) globalAccomodate2(Q, face, level,  alpha, beta, gamma, i);
		else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
						 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
						 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
		Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
		Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
		Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
		
		/* Perturbations */
		
		if (level>0) {

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
				((gamma/2)*2==gamma)) {

				a=(alpha+1)/2;
				b=(beta-1)/2;
				c=gamma/2;

				aa=(alpha-1)/2;
				bb=(beta+1)/2;
				cc=gamma/2;
			}

			if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=(alpha+1)/2;
				b=beta/2;
				c=(gamma-1)/2;

				aa=(alpha-1)/2;
				bb=beta/2;
				cc=(gamma+1)/2;
			}

			if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
				(((gamma-1)/2)*2==gamma-1)) {

				a=alpha/2;
				b=(beta+1)/2;
				c=(gamma-1)/2;

				aa=alpha/2;
				bb=(beta-1)/2;
				cc=(gamma+1)/2;
			}

			rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
			if (Q->VertexTable[rem1]->level>0) n1=6;
			else n1=Q->Valance[rem1];		
			rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
			if (Q->VertexTable[rem2]->level>0) n2=6;
			else n2=Q->Valance[rem2];
			ALPHA(n1, n2, &ALPHA1, &ALPHA2);

			globalAccomodate2(Q, face, level-1,  a, b, c, i);
			globalAccomodate2(Q, face, level-1,  aa, bb, cc, i);

			Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
			Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
			
			Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
			Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
		}
		i++;
	}
}

void receptionCoeff44(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist) {

	// (Remplace receptionCoeff2 avec globalAccomodate22)
	// Comme rc4 mais incrmental 

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;

	i=premier;
	while((unsigned)i<wr->NbCoeff && cmpt+premier<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		ok=ok || (wr->tab[i]->x*wr->tab[i]->x
			+wr->tab[i]->y*wr->tab[i]->y
			+wr->tab[i]->z*wr->tab[i]->z<dist/700/700);
		if (!ok) {
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate2(Q, face, level,  alpha, beta, gamma, i);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0 && Q->Remember!=-1)) {
				Q->VertexTable[Q->Remember]->fGeom[0]+=coeff[0];
				Q->VertexTable[Q->Remember]->fGeom[1]+=coeff[1];
				Q->VertexTable[Q->Remember]->fGeom[2]+=coeff[2];
			}

			/* Perturbations */
		
			if (level>0 && Q->Remember!=-1) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				globalAccomodate2(Q, face, level-1,  a, b, c, i);
				globalAccomodate2(Q, face, level-1,  aa, bb, cc, i);
	
				Q->VertexTable[rem1]->fGeom[0]-=coeff[0]*ALPHA1;
				Q->VertexTable[rem1]->fGeom[1]-=coeff[1]*ALPHA1;
				Q->VertexTable[rem1]->fGeom[2]-=coeff[2]*ALPHA1;
			
				Q->VertexTable[rem2]->fGeom[0]-=coeff[0]*ALPHA2;
				Q->VertexTable[rem2]->fGeom[1]-=coeff[1]*ALPHA2;
				Q->VertexTable[rem2]->fGeom[2]-=coeff[2]*ALPHA2;
			}
		}
		i++;
	}
}

void receptionCoeff44miroir(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist) {

	// Retire les coeffs (ajoute leurs opposs).

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;

	i=nbc;
	while((unsigned)i<wr->NbCoeff && cmpt+nbc<premier) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		ok=ok || (wr->tab[i]->x*wr->tab[i]->x
			+wr->tab[i]->y*wr->tab[i]->y
			+wr->tab[i]->z*wr->tab[i]->z<dist/700/700*dist);
		if (!ok) {
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=-wr->tab[i]->x;
			coeff[1]=-wr->tab[i]->y;
			coeff[2]=-wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate2miroir(Q, face, level,  alpha, beta, gamma, i);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0 && Q->Remember!=-1)) {
				Q->VertexTable[Q->Remember]->fGeom[0]+=coeff[0];
				Q->VertexTable[Q->Remember]->fGeom[1]+=coeff[1];
				Q->VertexTable[Q->Remember]->fGeom[2]+=coeff[2];
			}

			/* Perturbations */
		
			if (level>0 && Q->Remember!=-1) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				globalAccomodate2miroir(Q, face, level-1,  a, b, c, i);
				globalAccomodate2miroir(Q, face, level-1,  aa, bb, cc, i);
	
				Q->VertexTable[rem1]->fGeom[0]-=coeff[0]*ALPHA1;
				Q->VertexTable[rem1]->fGeom[1]-=coeff[1]*ALPHA1;
				Q->VertexTable[rem1]->fGeom[2]-=coeff[2]*ALPHA1;
			
				Q->VertexTable[rem2]->fGeom[0]-=coeff[0]*ALPHA2;
				Q->VertexTable[rem2]->fGeom[1]-=coeff[1]*ALPHA2;
				Q->VertexTable[rem2]->fGeom[2]-=coeff[2]*ALPHA2;
			}
		}
		i++;
	}
}

void coupe(Face_WSZT *face, int premier, int nbc, int prems) {

	// Recursif

	CL *clist;
	static unsigned int autorise;
	unsigned int inclus, trouve;
	int i;

	if (prems)
		autorise=1;
	prems=0;

	if (face->children[0]!=NULL) {
	////////////////////////////////////////////////////////////////
		coupe(face->children[0], premier, nbc, 0);
		coupe(face->children[1], premier, nbc, 0);
		coupe(face->children[2], premier, nbc, 0);
		coupe(face->children[3], premier, nbc, 0);
	////////////////////////////////////////////////////////////////
	}

	if (autorise) {
		//Parcours de la liste
		clist=face->Coeff_list;
		inclus=1;
		while (clist!=NULL) {
			trouve=0;
			for (i=nbc; i<premier; i++) { //parcours de la liste des coefficients recherchs
				if (clist->coeff==i)
					trouve=1;
			}
			if (!trouve) {
				inclus=0;
				break;
			}
			clist=clist->next;
		}
		if (inclus && autorise) {//retrait immdiat
			face->children[0]=NULL;
			face->children[1]=NULL;
			face->children[2]=NULL;
			face->children[3]=NULL;
		}
		autorise=inclus;
	}
	//Retrait des coeffs de la liste
	for (i=nbc; i<premier; i++) {
		clist=face->Coeff_list;
		if (clist!=NULL) {
			if (i==clist->coeff) 
				face->Coeff_list=clist->next;
			clist=face->Coeff_list;
			if (clist!=NULL) {
				while (clist->next!=NULL) {
					if (i==clist->next->coeff)
						clist->next=clist->next->next;
					if (clist->next!=NULL)
						clist=clist->next;
				}
			}
		}
	}
}

void elague(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist) {

	// Version naive : parcoure tout l'arbre de facettes et coupe ce qui ne 
	// contient que les coeffs incrimins

	int i;

	//Retrait des facettes
	for (i=0; i<Q->NbRacine; i++) {//Pour chaque face de M0
		coupe(Q->racines[i], premier, nbc, 1);
	}
	
	//Retrait des sommets

}

void receptionCoeff5(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist) {

// receptionCoeff5():(si ajout)  |------------->receptionCoeff44();
//                  :(si retrait)|------------->elague()

	if (premier<nbc) 
		receptionCoeff44(Q, wr, Invite, premier, nbc, dist);
	else {
		receptionCoeff44miroir(Q, wr, Invite, premier, nbc, dist);
		elague(Q, wr, Invite, premier, nbc, dist);
	}
}

int compareFace( const void *arg1, const void *arg2 ) {

	return (((Face_WSZT *)arg1)->level>((Face_WSZT *)arg2)->level);
}

void elagueVPC(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, ListeDeFace *liste) {


// Utilis par receptionCoeff6()
// Destine  servir de render incrmental...Ne pas oublier :-) 
// Dans la version finale, traiter une liste doublement chaine directement sans appel a qsort.

	Face_WSZT *Tab[NbCoeffMax];
	ListeDeFace *parcours;
	int i;
	// Partie lagage***********************************************
	// On prend la liste des facettes candidates a l'applatissement
	// On les trie et on procede...

	// liste est recopie dans Tab
	i=0;
	parcours=liste;
	while (parcours!=NULL) {
		Tab[i]=parcours->F;	
		i++;
		parcours=parcours->next;
	}

	// Puis trie
	qsort( (void *)Tab, (size_t)i, sizeof(Face_WSZT*), compareFace );
	
	// Partie rendering**********************************************


	// Suppression des facettes de Tab
	for (;i>0; i--) {
		if (Tab[i-1]->children[0]!=NULL) {
			
			if (fabs(Tab[i-1]->children[3]->sommetCoin[0]->g[0]-0.5*
				(Tab[i-1]->children[3]->sommetCoin[0]->parentV[0]->g[0]+Tab[i-1]->children[3]->sommetCoin[0]->parentV[1]->g[0])
				<epsilon) &&
			
				fabs(Tab[i-1]->children[3]->sommetCoin[0]->g[1]-0.5*
				(Tab[i-1]->children[3]->sommetCoin[0]->parentV[0]->g[1]+Tab[i-1]->children[3]->sommetCoin[0]->parentV[1]->g[1])
				<epsilon) &&

				fabs(Tab[i-1]->children[3]->sommetCoin[0]->g[2]-0.5*
				(Tab[i-1]->children[3]->sommetCoin[0]->parentV[0]->g[2]+Tab[i-1]->children[3]->sommetCoin[0]->parentV[1]->g[2])
				<epsilon)
				
				&&
				
				fabs(Tab[i-1]->children[3]->sommetCoin[1]->g[0]-0.5*
				(Tab[i-1]->children[3]->sommetCoin[1]->parentV[0]->g[0]+Tab[i-1]->children[3]->sommetCoin[1]->parentV[1]->g[0])
				<epsilon) &&
			
				fabs(Tab[i-1]->children[3]->sommetCoin[1]->g[1]-0.5*
				(Tab[i-1]->children[3]->sommetCoin[1]->parentV[0]->g[1]+Tab[i-1]->children[3]->sommetCoin[1]->parentV[1]->g[1])
				<epsilon) &&

				fabs(Tab[i-1]->children[3]->sommetCoin[1]->g[2]-0.5*
				(Tab[i-1]->children[3]->sommetCoin[1]->parentV[0]->g[2]+Tab[i-1]->children[3]->sommetCoin[1]->parentV[1]->g[2])
				<epsilon)
				
				&&
				
				fabs(Tab[i-1]->children[3]->sommetCoin[2]->g[0]-0.5*
				(Tab[i-1]->children[3]->sommetCoin[2]->parentV[0]->g[0]+Tab[i-1]->children[3]->sommetCoin[2]->parentV[1]->g[0])
				<epsilon) &&
			
				fabs(Tab[i-1]->children[3]->sommetCoin[2]->g[1]-0.5*
				(Tab[i-1]->children[3]->sommetCoin[2]->parentV[0]->g[1]+Tab[i-1]->children[3]->sommetCoin[2]->parentV[1]->g[1])
				<epsilon) &&

				fabs(Tab[i-1]->children[3]->sommetCoin[2]->g[2]-0.5*
				(Tab[i-1]->children[3]->sommetCoin[2]->parentV[0]->g[2]+Tab[i-1]->children[3]->sommetCoin[2]->parentV[1]->g[2])
				<epsilon))

			{// Ne pas oublier d'optimiser les accs plus tard...


	//		if (fabs(Tab[i-1]->children[3]->sommetCoin[0]->fGeom[0])<epsilon
	//			&& fabs(Tab[i-1]->children[3]->sommetCoin[0]->fGeom[1])<epsilon
	//			&& fabs(Tab[i-1]->children[3]->sommetCoin[0]->fGeom[2])<epsilon) {
					
				// Mise a jour des parentF alentours avant suppression
				for (int j=0; j<4; j++) {// Pour chaque fille
					for (int k=0; k<3; k++) {// Pour chaque sommet Arete
						if (Tab[i-1]->children[j]->sommetArete[k]!=NULL) {
							if (Tab[i-1]->children[j]->sommetArete[k]->parentF[0]==Tab[i-1]->children[j]) {
								Tab[i-1]->children[j]->sommetArete[k]->parentF[0]=
									Tab[i-1]->children[j]->sommetArete[k]->parentF[1];
								Tab[i-1]->children[j]->sommetArete[k]->parentF[1]=NULL;
							}
							if (Tab[i-1]->children[j]->sommetArete[k]->parentF[1]==Tab[i-1]->children[j]) 
								Tab[i-1]->children[j]->sommetArete[k]->parentF[1]=NULL;
						}		
					}	
				}
				// Suppression
				free(Tab[i-1]->children[0]);
				free(Tab[i-1]->children[1]);
				free(Tab[i-1]->children[2]);
				free(Tab[i-1]->children[3]);
				Tab[i-1]->children[0]=NULL;
				Tab[i-1]->children[1]=NULL;
				Tab[i-1]->children[2]=NULL;
				Tab[i-1]->children[3]=NULL;
			}
		}
	}


}


int isFlat(Face_WSZT *face) {
	
	// Renvoit 1 ssi face est plate

	int res=1;
	Sommet * u1, *u2, *u3;

	if (face->children[0]==NULL)
		return 0;

	u1=face->sommetArete[0];
	u2=face->sommetArete[1];
	u3=face->sommetArete[2];
	
	res=res && (fabs(u1->g[0]-0.5*(u1->parentV[0]->g[0]+u1->parentV[1]->g[0]))<epsilon*epsilon);
	res=res && (fabs(u2->g[0]-0.5*(u2->parentV[0]->g[0]+u2->parentV[1]->g[0]))<epsilon*epsilon);
	res=res && (fabs(u3->g[0]-0.5*(u3->parentV[0]->g[0]+u3->parentV[1]->g[0]))<epsilon*epsilon);

	res=res && (fabs(u1->g[1]-0.5*(u1->parentV[0]->g[1]+u1->parentV[1]->g[1]))<epsilon*epsilon);
	res=res && (fabs(u2->g[1]-0.5*(u2->parentV[0]->g[1]+u2->parentV[1]->g[1]))<epsilon*epsilon);
	res=res && (fabs(u3->g[1]-0.5*(u3->parentV[0]->g[1]+u3->parentV[1]->g[1]))<epsilon*epsilon);

	res=res && (fabs(u1->g[2]-0.5*(u1->parentV[0]->g[2]+u1->parentV[1]->g[2]))<epsilon*epsilon);
	res=res && (fabs(u2->g[2]-0.5*(u2->parentV[0]->g[2]+u2->parentV[1]->g[2]))<epsilon*epsilon);
	res=res && (fabs(u3->g[2]-0.5*(u3->parentV[0]->g[2]+u3->parentV[1]->g[2]))<epsilon*epsilon);

	res=res && (face->children[0]->children[0]==NULL);
	res=res && (face->children[1]->children[0]==NULL);
	res=res && (face->children[2]->children[0]==NULL);
	res=res && (face->children[3]->children[0]==NULL);

// DEBUG
if (res) {
	res=res;
}
	return res;

}	
	
void aplatisNaif(Face_WSZT *f, Qtree *Q, Mesh *mesh) {
	
	if (f->children[0]!=NULL) {
		aplatisNaif(f->children[0], Q, mesh);
		aplatisNaif(f->children[1], Q, mesh);
		aplatisNaif(f->children[2], Q, mesh);
		aplatisNaif(f->children[3], Q, mesh);
	}

	// Traitement
	if (isFlat(f)) {
		
		int cas;
		// On avertit les voisins du dmnagement. Tres coteux !!! 
		if (f->Voisins[0]!=NULL && f->Voisins[0]->children[0]!=NULL) 
		{
			cas=(f->Voisins[0]->Voisins[0]==f)+2*(f->Voisins[0]->Voisins[1]==f)+4*(f->Voisins[0]->Voisins[2]==f);
			switch(cas) {
			case 1:
				f->Voisins[0]->children[0]->Voisins[0]=NULL;
				f->Voisins[0]->children[1]->Voisins[0]=NULL;
				if (f->Voisins[0]->children[0]->children[0]!=NULL)
				if (f->Voisins[0]->children[0]->sommetArete[0]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[0]->children[0]->sommetArete[0]->parentF[0]=NULL;
				else
					f->Voisins[0]->children[0]->sommetArete[0]->parentF[1]=NULL;
				if (f->Voisins[0]->children[1]->children[0]!=NULL)
				if (f->Voisins[0]->children[1]->sommetArete[0]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[0]->children[1]->sommetArete[0]->parentF[0]=NULL;
				else
					f->Voisins[0]->children[1]->sommetArete[0]->parentF[1]=NULL;
				break;
			case 2:
				f->Voisins[0]->children[1]->Voisins[1]=NULL;
				f->Voisins[0]->children[2]->Voisins[1]=NULL;
				if (f->Voisins[0]->children[1]->children[0]!=NULL)
				if (f->Voisins[0]->children[1]->sommetArete[1]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[0]->children[1]->sommetArete[1]->parentF[0]=NULL;
				else
					f->Voisins[0]->children[1]->sommetArete[1]->parentF[1]=NULL;
				if (f->Voisins[0]->children[2]->children[0]!=NULL)
				if (f->Voisins[0]->children[2]->sommetArete[1]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[0]->children[2]->sommetArete[1]->parentF[0]=NULL;
				else
					f->Voisins[0]->children[2]->sommetArete[1]->parentF[1]=NULL;
				break;
			case 4:
				f->Voisins[0]->children[2]->Voisins[2]=NULL;
				f->Voisins[0]->children[0]->Voisins[2]=NULL;
				if (f->Voisins[0]->children[2]->children[0]!=NULL)
				if (f->Voisins[0]->children[2]->sommetArete[2]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[0]->children[2]->sommetArete[2]->parentF[0]=NULL;
				else
					f->Voisins[0]->children[2]->sommetArete[2]->parentF[1]=NULL;
				if (f->Voisins[0]->children[0]->children[0]!=NULL)
				if (f->Voisins[0]->children[0]->sommetArete[2]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[0]->children[0]->sommetArete[2]->parentF[0]=NULL;
				else
					f->Voisins[0]->children[0]->sommetArete[2]->parentF[1]=NULL;
				break;
			}
		}
		if (f->Voisins[1]!=NULL && f->Voisins[1]->children[0]!=NULL) 
		{
			cas=(f->Voisins[1]->Voisins[0]==f)+2*(f->Voisins[1]->Voisins[1]==f)+4*(f->Voisins[1]->Voisins[2]==f);
			switch(cas) {
			case 1:
				f->Voisins[1]->children[0]->Voisins[0]=NULL;
				f->Voisins[1]->children[1]->Voisins[0]=NULL;
				if (f->Voisins[1]->children[0]->children[0]!=NULL)
				if (f->Voisins[1]->children[0]->sommetArete[0]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[1]->children[0]->sommetArete[0]->parentF[0]=NULL;
				else
					f->Voisins[1]->children[0]->sommetArete[0]->parentF[1]=NULL;
				if (f->Voisins[1]->children[1]->children[0]!=NULL)
				if (f->Voisins[1]->children[1]->sommetArete[0]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[1]->children[1]->sommetArete[0]->parentF[0]=NULL;
				else
					f->Voisins[1]->children[1]->sommetArete[0]->parentF[1]=NULL;
				break;
			case 2:
				f->Voisins[1]->children[1]->Voisins[1]=NULL;
				f->Voisins[1]->children[2]->Voisins[1]=NULL;
				if (f->Voisins[1]->children[1]->children[0]!=NULL)
				if (f->Voisins[1]->children[1]->sommetArete[1]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[1]->children[1]->sommetArete[1]->parentF[0]=NULL;
				else
					f->Voisins[1]->children[1]->sommetArete[1]->parentF[1]=NULL;
				if (f->Voisins[1]->children[2]->children[0]!=NULL)
				if (f->Voisins[1]->children[2]->sommetArete[1]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[1]->children[2]->sommetArete[1]->parentF[0]=NULL;
				else
					f->Voisins[1]->children[2]->sommetArete[1]->parentF[1]=NULL;
				break;
			case 4:
				f->Voisins[1]->children[2]->Voisins[2]=NULL;
				f->Voisins[1]->children[0]->Voisins[2]=NULL;
				if (f->Voisins[1]->children[2]->children[0]!=NULL)
				if (f->Voisins[1]->children[2]->sommetArete[2]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[1]->children[2]->sommetArete[2]->parentF[0]=NULL;
				else
					f->Voisins[1]->children[2]->sommetArete[2]->parentF[1]=NULL;
				if (f->Voisins[1]->children[0]->children[0]!=NULL)
				if (f->Voisins[1]->children[0]->sommetArete[2]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[1]->children[0]->sommetArete[2]->parentF[0]=NULL;
				else
					f->Voisins[1]->children[0]->sommetArete[2]->parentF[1]=NULL;
				break;
			}
		}
		if (f->Voisins[2]!=NULL && f->Voisins[2]->children[0]!=NULL) 
		{
			cas=(f->Voisins[2]->Voisins[0]==f)+2*(f->Voisins[2]->Voisins[1]==f)+4*(f->Voisins[2]->Voisins[2]==f);
			switch(cas) {
			case 1:
				f->Voisins[2]->children[0]->Voisins[0]=NULL;
				f->Voisins[2]->children[1]->Voisins[0]=NULL;
				if (f->Voisins[2]->children[0]->children[0]!=NULL)
				if (f->Voisins[2]->children[0]->sommetArete[0]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[2]->children[0]->sommetArete[0]->parentF[0]=NULL;
				else
					f->Voisins[2]->children[0]->sommetArete[0]->parentF[1]=NULL;
				if (f->Voisins[2]->children[1]->children[0]!=NULL)
				if (f->Voisins[2]->children[1]->sommetArete[0]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[2]->children[1]->sommetArete[0]->parentF[0]=NULL;
				else
					f->Voisins[2]->children[1]->sommetArete[0]->parentF[1]=NULL;
				break;
			case 2:
				f->Voisins[2]->children[1]->Voisins[1]=NULL;
				f->Voisins[2]->children[2]->Voisins[1]=NULL;
				if (f->Voisins[2]->children[1]->children[0]!=NULL)
				if (f->Voisins[2]->children[1]->sommetArete[1]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[2]->children[1]->sommetArete[1]->parentF[0]=NULL;
				else
					f->Voisins[2]->children[1]->sommetArete[1]->parentF[1]=NULL;
				if (f->Voisins[2]->children[2]->children[0]!=NULL)
				if (f->Voisins[2]->children[2]->sommetArete[1]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[2]->children[2]->sommetArete[1]->parentF[0]=NULL;
				else
					f->Voisins[2]->children[2]->sommetArete[1]->parentF[1]=NULL;
				break;
			case 4:
				f->Voisins[2]->children[2]->Voisins[2]=NULL;
				f->Voisins[2]->children[0]->Voisins[2]=NULL;
				if (f->Voisins[2]->children[2]->children[0]!=NULL)
				if (f->Voisins[2]->children[2]->sommetArete[2]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[2]->children[2]->sommetArete[2]->parentF[0]=NULL;
				else
					f->Voisins[2]->children[2]->sommetArete[2]->parentF[1]=NULL;
				if (f->Voisins[2]->children[0]->children[0]!=NULL)
				if (f->Voisins[2]->children[0]->sommetArete[2]->parentF[0]==f) // 11 - 05 - 2001
					f->Voisins[2]->children[0]->sommetArete[2]->parentF[0]=NULL;
				else
					f->Voisins[2]->children[0]->sommetArete[2]->parentF[1]=NULL;
				break;
			}
		}
		// On libere les sommets inutiles
		if ((f->sommetArete[0]->parentF[0]==NULL
			|| (f->sommetArete[0]->parentF[0]!=NULL && f->sommetArete[0]->parentF[0]->children[0]==NULL)) 
			&& (f->sommetArete[0]->parentF[1]==NULL
			|| (f->sommetArete[0]->parentF[1]!=NULL && f->sommetArete[0]->parentF[1]->children[0]==NULL))) {
			PileDeSommets *insert=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			insert->sommet=f->sommetArete[0]->indice;
			insert->next=Q->Gap;
			Q->Gap=insert;
			Q->VertexTable[f->sommetArete[0]->indice]=NULL;
			free(f->sommetArete[0]);
		}
		if ((f->sommetArete[1]->parentF[0]==NULL || 
			(f->sommetArete[1]->parentF[0]!=NULL && f->sommetArete[1]->parentF[0]->children[0]==NULL)) 
			&& ((f->sommetArete[1]->parentF[1]==NULL) ||
			(f->sommetArete[1]->parentF[1]!=NULL && f->sommetArete[1]->parentF[1]->children[0]==NULL))) {
			PileDeSommets *insert=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			insert->sommet=f->sommetArete[1]->indice;
			insert->next=Q->Gap;
			Q->Gap=insert;
			Q->VertexTable[f->sommetArete[1]->indice]=NULL;
			free(f->sommetArete[1]);
		}
		if ((f->sommetArete[2]->parentF[0]==NULL || 
			(f->sommetArete[2]->parentF[0]!=NULL && f->sommetArete[2]->parentF[0]->children[0]==NULL)) 
			&& (f->sommetArete[2]->parentF[1]==NULL ||
			(f->sommetArete[2]->parentF[1]!=NULL && f->sommetArete[2]->parentF[1]->children[0]==NULL))) {
			PileDeSommets *insert=(PileDeSommets *)malloc(sizeof(PileDeSommets));
			insert->sommet=f->sommetArete[2]->indice;
			insert->next=Q->Gap;
			Q->Gap=insert;
			Q->VertexTable[f->sommetArete[2]->indice]=NULL;
			free(f->sommetArete[2]);
		}

		// Mise  jour de Gap et de la displaylist
		{ 
			PileDeFaces *tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
			tmp->face=f->children[0]->indice;
			tmp->next=mesh->FaceGap;
			mesh->FacePresente[tmp->face]=0;
			mesh->FaceGap=tmp;

			tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
			tmp->face=f->children[1]->indice;
			tmp->next=mesh->FaceGap;
			mesh->FacePresente[tmp->face]=0;
			mesh->FaceGap=tmp;

			tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
			tmp->face=f->children[2]->indice;
			tmp->next=mesh->FaceGap;
			mesh->FacePresente[tmp->face]=0;
			mesh->FaceGap=tmp;

			tmp=(PileDeFaces *)malloc(sizeof(PileDeFaces));
			tmp->face=f->children[3]->indice;
			tmp->next=mesh->FaceGap;
			mesh->FacePresente[tmp->face]=0;
			mesh->FaceGap=tmp;

			mesh->FacePresente[f->children[0]->indice]=0;
			mesh->FacePresente[f->children[1]->indice]=0;
			mesh->FacePresente[f->children[2]->indice]=0;
			mesh->FacePresente[f->children[3]->indice]=0;
		}

		// Ajout du parent  la displaylist
		// Note : FaceGap ne peut etre NULL  ce stade
		{
			PileDeFaces *lib;
			mesh->Face[mesh->FaceGap->face][0]=f->sommetCoin[0]->indice;
			mesh->Face[mesh->FaceGap->face][1]=f->sommetCoin[1]->indice;
			mesh->Face[mesh->FaceGap->face][2]=f->sommetCoin[2]->indice;
			f->indice=mesh->FaceGap->face;
			mesh->FacePresente[mesh->FaceGap->face]=1;
			lib=mesh->FaceGap;
			mesh->FaceGap=mesh->FaceGap->next;
			free(lib);
		}

		// Liberation
		free(f->children[0]);
		free(f->children[1]);
		free(f->children[2]);
		free(f->children[3]);
		f->children[0]=f->children[1]=
		f->children[2]=f->children[3]=NULL;
					
	}

}


void elagueNaif(Qtree *Q, Mesh *mesh) {
	
	// Parcourt tout l'arbre pour laguer

	int i;

	for (i=0; i<Q->NbRacine; i++) {
		aplatisNaif(Q->racines[i], Q, mesh);
	}
	
}

void receptionCoeff61(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {

	// Liste sommets par coefficient

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;

	i=premier;
	while((unsigned)i<wr->NbCoeff && cmpt+premier<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		if (!Invite)
			ok=0;
		else {
			if (Invite[face]==1)
				ok=0;
			if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
				ok=0;
			//ok=ok || (wr->tab[i]->x*wr->tab[i]->x
			//	+wr->tab[i]->y*wr->tab[i]->y
			//	+wr->tab[i]->z*wr->tab[i]->z<dist*dist);
		}
		if (!ok && i>=0 && i<wr->NbCoeff) { 

			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate4(Q, face, level,  alpha, beta, gamma, i, mesh);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;

			/*if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0  && Q->Remember!=-1)) {*/
				Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
				Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
				Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
			//}
			// Texture

			Q->VertexTable[Q->Remember]->u=wr->tab[i]->u;
			Q->VertexTable[Q->Remember]->v=wr->tab[i]->v;

			// Mise a jour de VPC
			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}

			/* Perturbations */
		/*
			if (level>0 && Q->Remember!=-1) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				if (ALPHA1>epsilon && ALPHA2>epsilon) {
					globalAccomodate4(Q, face, level-1,  a, b, c, i, mesh);
					globalAccomodate4(Q, face, level-1,  aa, bb, cc, i, mesh);

					Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem1;
						insert->alpha=ALPHA1;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}	
			
			
					Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem2;
						insert->alpha=ALPHA2;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}
				}
			}*/
		}
		i++;
	}
}


void receptionCoeff61Loc(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {

	// Liste sommets par coefficient

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;
	double vecu[3], vecv[3], vecn[3], vecn1[3], vecn2[3];
	float x, y, z;

	i=premier;
	while((unsigned)i<wr->NbCoeff && cmpt+premier<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		if (!ok && i>=0 && i<wr->NbCoeff) { 
#if defined(DEB_INF)
if (i==18) 
{FILE *f=fopen("journal.log", "a");fprintf(f, "Plante1\n");fclose(f);}
#endif
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate4(Q, face, level,  alpha, beta, gamma, i, mesh);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;

			
			//Passage au repre global
			if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma>1) {
				//Rappel : que lazy et que si l'ordre des niveaux est respect
				// normale  la premiere face
				moins(Q->VertexTable[Q->Remember]->parentF[0]->sommetCoin[1]->g, Q->VertexTable[Q->Remember]->parentF[0]->sommetCoin[0]->g, vecu);
				moins(Q->VertexTable[Q->Remember]->parentF[0]->sommetCoin[2]->g, Q->VertexTable[Q->Remember]->parentF[0]->sommetCoin[0]->g, vecv);
				vect(vecu, vecv, vecn1);
				normalize(vecn1);
				// normalizeale  la premiere face
				moins(Q->VertexTable[Q->Remember]->parentF[1]->sommetCoin[1]->g, Q->VertexTable[Q->Remember]->parentF[1]->sommetCoin[0]->g, vecu);
				moins(Q->VertexTable[Q->Remember]->parentF[1]->sommetCoin[2]->g, Q->VertexTable[Q->Remember]->parentF[1]->sommetCoin[0]->g, vecv);
				vect(vecu, vecv, vecn2);
				normalize(vecn2);
				//normalizeale moyenne
				vecn[0]=vecn1[0]+vecn2[0];
				vecn[1]=vecn1[1]+vecn2[1];
				vecn[2]=vecn1[2]+vecn2[2];
				normalize(vecn);
				//compltion de la base
				vecv[0]=Q->VertexTable[Q->Remember]->parentV[0]->g[0]-Q->VertexTable[Q->Remember]->parentV[1]->g[0];
				vecv[1]=Q->VertexTable[Q->Remember]->parentV[0]->g[1]-Q->VertexTable[Q->Remember]->parentV[1]->g[1];
				vecv[2]=Q->VertexTable[Q->Remember]->parentV[0]->g[2]-Q->VertexTable[Q->Remember]->parentV[1]->g[2];
				normalize(vecv); // inutile normalizealement...
				vect(vecn, vecv, vecu);
				normalize(vecu);
				// changement de repre
				x=coeff[0]*vecu[0]+coeff[1]*vecv[0]+coeff[2]*vecn[0];
				y=coeff[0]*vecu[1]+coeff[1]*vecv[1]+coeff[2]*vecn[1];
				z=coeff[0]*vecu[2]+coeff[1]*vecv[2]+coeff[2]*vecn[2];
			} else {
				x=coeff[0];
				y=coeff[1];
				z=coeff[2];
			}
			
			Q->VertexTable[Q->Remember]->hGeom[level][0]+=x;
			Q->VertexTable[Q->Remember]->hGeom[level][1]+=y;
			Q->VertexTable[Q->Remember]->hGeom[level][2]+=z;

			// Texture

			Q->VertexTable[Q->Remember]->u=wr->tab[i]->u;
			Q->VertexTable[Q->Remember]->v=wr->tab[i]->v;

			// Mise a jour de VPC
			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}

			
		}
		i++;
	}
}

void receptionCoeff81(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {
	
	// 0-disks prises en comptes ICI

	// Liste sommets par coefficient

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;

	i=premier;
	while((unsigned)i<wr->NbCoeff && cmpt+premier<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
	//	ok=ok || (wr->tab[i]->x*wr->tab[i]->x
	//		+wr->tab[i]->y*wr->tab[i]->y
	//		+wr->tab[i]->z*wr->tab[i]->z<dist*dist);
		if (!ok && i>=0 && i<wr->NbCoeff) { 
#if defined(DEB_INF)
if (i==18) 
{FILE *f=fopen("journal.log", "a");fprintf(f, "Plante1\n");fclose(f);}
#endif
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			coeff[0]=wr->tab[i]->x;
			gamma=wr->tab[i]->gamma;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
//{FILE *f=fopen("journal.log", "a");fprintf(f, "%d %d %d %d %f %f %f\n", face, alpha, beta, gamma, coeff[0], coeff[1], coeff[2]);fclose(f);}	
			/* Pic central */

			if (level>0) 
				globalAccomodate4(Q, face, level,  alpha, beta, gamma, i, mesh);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
#if defined(DEB_INF)
if (i==18) 
{FILE *f=fopen("journal.log", "a");fprintf(f, "remember genere par\n alpha=%d\n beta=%d\n gamma=%d\n\n", alpha, beta, gamma);fclose(f);}
#endif
			/*if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0  && Q->Remember!=-1)) {*/
				Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
				Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
				Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
			//}
			// Texture

			Q->VertexTable[Q->Remember]->u=wr->tab[i]->u;
			Q->VertexTable[Q->Remember]->v=wr->tab[i]->v;

			// Mise a jour de VPC
			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}

			/* Perturbations */

			if (level>1 && Q->Remember!=-1) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				//ALPHA(n1, n2, &ALPHA1, &ALPHA2);
				ALPHA(6, 6, &ALPHA1, &ALPHA2);
		
				if (fabs(ALPHA1)>epsilon && fabs(ALPHA2)>epsilon) {
					globalAccomodate4(Q, face, level-1,  a, b, c, i, mesh);
					globalAccomodate4(Q, face, level-1,  aa, bb, cc, i, mesh);

					Q->VertexTable[rem1]->hGeom[level-1][0]+=coeff[0]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][1]+=coeff[1]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][2]+=coeff[2]*ALPHA1;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem1;
						insert->alpha=ALPHA1;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}	
			
			
					Q->VertexTable[rem2]->hGeom[level-1][0]+=coeff[0]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][1]+=coeff[1]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][2]+=coeff[2]*ALPHA2;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem2;
						insert->alpha=ALPHA2;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}
				}
			}
		}
		i++;
	}
}



void receptionCoeff61miroirGeom(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, ListeDeFace **liste) {

	// Pas utilis

	int i;
	ListeDeSommets *parcours;
	ListeDeFace *ajout;

	for (i=nbc+1; i<=premier; i++) {
		parcours=VPC->LDS[i];
		while (parcours!=NULL) {
			
			// Soustraction du coeff
			Q->VertexTable[parcours->id]->g[0]-=parcours->alpha*wr->tab[i]->x;
			Q->VertexTable[parcours->id]->g[1]-=parcours->alpha*wr->tab[i]->y;
			Q->VertexTable[parcours->id]->g[2]-=parcours->alpha*wr->tab[i]->z;

			// Ajout des facettes concernes a la liste 
			if (Q->VertexTable[parcours->id]->parentF[0]!=NULL) {
				ajout=(ListeDeFace *)malloc(sizeof(ListeDeFace));
				ajout->F=Q->VertexTable[parcours->id]->parentF[0];
				ajout->next=*liste;
				*liste=ajout;
			}
			if (Q->VertexTable[parcours->id]->parentF[1]!=NULL) {
				ajout=(ListeDeFace *)malloc(sizeof(ListeDeFace));
				ajout->F=Q->VertexTable[parcours->id]->parentF[1];
				ajout->next=*liste;
				*liste=ajout;
			}

			parcours=parcours->next;
		}
		VPC->LDS[i]=NULL;
	}
}


void receptionCoeff61miroir(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, ListeDeFace **liste, Mesh *mesh) {

	// Liste sommets par coefficient

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;
	ListeDeSommets *parcours;
	ListeDeFace *ajout;

	i=premier;
	while((unsigned)i<wr->NbCoeff && cmpt+premier<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		if (Invite[face]==-1)
			ok=0;
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		ok=ok;// || (wr->tab[i]->x*wr->tab[i]->x
			//+wr->tab[i]->y*wr->tab[i]->y
			//+wr->tab[i]->z*wr->tab[i]->z<dist/700/700);
		if (!ok) {
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate4(Q, face, level,  alpha, beta, gamma, i, mesh);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			/*if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0 && Q->Remember!=-1)) {*/

				Q->VertexTable[Q->Remember]->hGeom[level][0]-=coeff[0];
				Q->VertexTable[Q->Remember]->hGeom[level][1]-=coeff[1];
				Q->VertexTable[Q->Remember]->hGeom[level][2]-=coeff[2];
			//}
			// Mise a jour de VPC (a miroiriser bien sur...)		
/*			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}
*/
			// Mise a jour de la liste
			parcours=VPC->LDS[i];
			while (parcours!=NULL) {
	
				// Ajout des facettes concernes a la liste 
				if (Q->VertexTable[parcours->id]->parentF[0]!=NULL) {
					ajout=(ListeDeFace *)malloc(sizeof(ListeDeFace));
					ajout->F=Q->VertexTable[parcours->id]->parentF[0];
					ajout->next=*liste;
					*liste=ajout;
				}
				if (Q->VertexTable[parcours->id]->parentF[1]!=NULL) {
					ajout=(ListeDeFace *)malloc(sizeof(ListeDeFace));
					ajout->F=Q->VertexTable[parcours->id]->parentF[1];
					ajout->next=*liste;
					*liste=ajout;
				}
				
				parcours=parcours->next;
				
			}
			free(VPC->LDS[i]);
			VPC->LDS[i]=NULL; //Cette ligne est a mettre en commentaire si elle est execute a partir de Aplatis()
			// Fin mise a jour de la liste

			/* Perturbations */
		/*
			if (level>0 && Q->Remember!=-1) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				if (ALPHA1>epsilon && ALPHA2>epsilon) {
					globalAccomodate4(Q, face, level-1,  a, b, c, i, mesh);
					globalAccomodate4(Q, face, level-1,  aa, bb, cc, i, mesh);

					Q->VertexTable[rem1]->hGeom[level-1][0]+=coeff[0]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][1]+=coeff[1]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][2]+=coeff[2]*ALPHA1;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem1;
						insert->alpha=ALPHA1;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}
			
			
					Q->VertexTable[rem2]->hGeom[level-1][0]+=coeff[0]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][1]+=coeff[1]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][2]+=coeff[2]*ALPHA2;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem2;
						insert->alpha=ALPHA2;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}
				}
			}*/
		}
		i++;
	}
}

void receptionCoeff81miroir(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, ListeDeFace **liste, Mesh *mesh) {

	// Liste sommets par coefficient

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;
	ListeDeSommets *parcours;
	ListeDeFace *ajout;

	i=premier;
	while((unsigned)i<wr->NbCoeff && cmpt+premier<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		ok=ok;// || (wr->tab[i]->x*wr->tab[i]->x
			//+wr->tab[i]->y*wr->tab[i]->y
			//+wr->tab[i]->z*wr->tab[i]->z<dist/700/700);
		if (!ok) {
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate4(Q, face, level,  alpha, beta, gamma, i, mesh);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			/*if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0 && Q->Remember!=-1)) {*/

				Q->VertexTable[Q->Remember]->hGeom[level][0]-=coeff[0];
				Q->VertexTable[Q->Remember]->hGeom[level][1]-=coeff[1];
				Q->VertexTable[Q->Remember]->hGeom[level][2]-=coeff[2];
			//}
			// Mise a jour de VPC (a miroiriser bien sur...)		
/*			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}
*/
			// Mise a jour de la liste
			parcours=VPC->LDS[i];
			while (parcours!=NULL) {
	
				// Ajout des facettes concernes a la liste 
				if (Q->VertexTable[parcours->id]->parentF[0]!=NULL) {
					ajout=(ListeDeFace *)malloc(sizeof(ListeDeFace));
					ajout->F=Q->VertexTable[parcours->id]->parentF[0];
					ajout->next=*liste;
					*liste=ajout;
				}
				if (Q->VertexTable[parcours->id]->parentF[1]!=NULL) {
					ajout=(ListeDeFace *)malloc(sizeof(ListeDeFace));
					ajout->F=Q->VertexTable[parcours->id]->parentF[1];
					ajout->next=*liste;
					*liste=ajout;
				}
				
				parcours=parcours->next;
				
			}
			free(VPC->LDS[i]);
			VPC->LDS[i]=NULL; //Cette ligne est a mettre en commentaire si elle est execute a partir de Aplatis()
			// Fin mise a jour de la liste

			/* Perturbations */
		/*
			if (level>0 && Q->Remember!=-1) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				if (ALPHA1>epsilon && ALPHA2>epsilon) {
					globalAccomodate4(Q, face, level-1,  a, b, c, i, mesh);
					globalAccomodate4(Q, face, level-1,  aa, bb, cc, i, mesh);

					Q->VertexTable[rem1]->hGeom[level-1][0]+=coeff[0]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][1]+=coeff[1]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][2]+=coeff[2]*ALPHA1;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem1;
						insert->alpha=ALPHA1;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}
			
			
					Q->VertexTable[rem2]->hGeom[level-1][0]+=coeff[0]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][1]+=coeff[1]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][2]+=coeff[2]*ALPHA2;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem2;
						insert->alpha=ALPHA2;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}
				}
			}*/
		}
		i++;
	}
}

Face_WSZT *FindFaceParentFace(Face_WSZT *f) {

	// Renvoit la Face parente de f

	Face_WSZT *parent;
	Sommet *s;

	if (f->level==0)
		return NULL;

	if (f->sommetCoin[0]->level==f->sommetCoin[1]->level)
		s=f->sommetCoin[1];
	else s=f->sommetCoin[2];

	parent=s->parentF[0];
	if (f!=parent->children[0] &&
		f!=parent->children[1] &&
		f!=parent->children[2] &&
		f!=parent->children[3])

		parent=s->parentF[1];

	return(parent);

}


void Aplatis(int premier, int nbc, VertexPerCoeff *VPC, Qtree *Q) {

	Face_WSZT *currentFace1, *currentFace2;
	ListeDeSommets *parcours;
	int coeff;
	

	for (coeff=premier-1; coeff>=nbc; coeff--) {
		parcours=VPC->LDS[coeff];
		while (parcours!=NULL) {
			currentFace1=Q->VertexTable[parcours->id]->parentF[0];
			currentFace2=Q->VertexTable[parcours->id]->parentF[1];

			while (currentFace1!=NULL || currentFace2!=NULL) {
				
				// Cas de jonction
				if (currentFace1==currentFace2)
					currentFace2=NULL;
				
				if (currentFace1!=NULL) {
					if (isFlat(currentFace1)) {
					// Suppression des sommets						
						if (currentFace1->children[3]->sommetCoin[0]->parentF[0]==NULL &&
							currentFace1->children[3]->sommetCoin[0]->parentF[1]==NULL) {							
							Q->VertexTable[currentFace1->children[3]->sommetCoin[0]->indice]=NULL;
							PileDeSommets *insert=(PileDeSommets *)malloc(sizeof(PileDeSommets));
							insert->sommet=currentFace1->children[3]->sommetCoin[0]->indice;
							insert->next=Q->Gap;
							Q->Gap=insert;
							free(currentFace1->children[3]->sommetCoin[0]);
						}
						if (currentFace1->children[3]->sommetCoin[1]->parentF[0]==NULL &&
							currentFace1->children[3]->sommetCoin[1]->parentF[1]==NULL) {							
							Q->VertexTable[currentFace1->children[3]->sommetCoin[1]->indice]=NULL;
							PileDeSommets *insert=(PileDeSommets *)malloc(sizeof(PileDeSommets));
							insert->sommet=currentFace1->children[3]->sommetCoin[1]->indice;
							insert->next=Q->Gap;
							Q->Gap=insert;
							free(currentFace1->children[3]->sommetCoin[1]);
						}
						if (currentFace1->children[3]->sommetCoin[2]->parentF[0]==NULL &&
							currentFace1->children[3]->sommetCoin[2]->parentF[1]==NULL) {							
							Q->VertexTable[currentFace1->children[3]->sommetCoin[2]->indice]=NULL;
							PileDeSommets *insert=(PileDeSommets *)malloc(sizeof(PileDeSommets));
							insert->sommet=currentFace1->children[3]->sommetCoin[2]->indice;
							insert->next=Q->Gap;
							Q->Gap=insert;
							free(currentFace1->children[3]->sommetCoin[2]);
						}

						free(currentFace1->children[0]);
						free(currentFace1->children[1]);
						free(currentFace1->children[2]);
						free(currentFace1->children[3]);
						currentFace1->children[0]=currentFace1->children[1]=
						currentFace1->children[2]=currentFace1->children[3]=NULL;
					}
					currentFace1=FindFaceParentFace(currentFace1);
				}

				if (currentFace2!=NULL) {
					if (isFlat(currentFace2)) {
						// Suppression des sommets
						if (currentFace2->children[3]->sommetCoin[0]->parentF[0]==NULL &&
							currentFace2->children[3]->sommetCoin[0]->parentF[1]==NULL) {							
							Q->VertexTable[currentFace2->children[3]->sommetCoin[0]->indice]=NULL;
							free(currentFace2->children[3]->sommetCoin[0]);
						}
						if (currentFace2->children[3]->sommetCoin[1]->parentF[0]==NULL &&
							currentFace2->children[3]->sommetCoin[1]->parentF[1]==NULL) {							
							Q->VertexTable[currentFace2->children[3]->sommetCoin[1]->indice]=NULL;
							free(currentFace2->children[3]->sommetCoin[1]);
						}
						if (currentFace2->children[3]->sommetCoin[2]->parentF[0]==NULL &&
							currentFace2->children[3]->sommetCoin[2]->parentF[1]==NULL) {							
							Q->VertexTable[currentFace2->children[3]->sommetCoin[2]->indice]=NULL;
							free(currentFace2->children[3]->sommetCoin[2]);
						}

						free(currentFace2->children[0]);
						free(currentFace2->children[1]);
						free(currentFace2->children[2]);
						free(currentFace2->children[3]);
						currentFace2->children[0]=currentFace2->children[1]=
						currentFace2->children[2]=currentFace2->children[3]=NULL;
					}
					currentFace2=FindFaceParentFace(currentFace2);
				}
			}
			parcours=parcours->next;

		}
		VPC->LDS[coeff]=NULL;
	}
}	

void receptionCoeff6(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {

	if (premier<nbc) {

		receptionCoeff61(Q, wr, Invite, premier, nbc, dist, VPC, mesh, M0);
		evaluateQueue(Q, mesh);
		renderLight(Q, mesh);
	} else {
		
		ListeDeFace *liste=NULL;
		receptionCoeff61miroir(Q, wr, Invite, nbc, premier, dist, VPC, &liste, mesh);
		//receptionCoeff61miroirGeom(Q, wr, Invite, premier, nbc, dist, VPC, &liste);
		evaluateQueue(Q, mesh);
		//elagueVPC(Q, wr, Invite, premier, nbc, dist, liste);// Utiliser l'accs direct bien sur
		//Aplatis(premier, nbc, VPC, Q);
		elagueNaif(Q, mesh);
	//	renderLight(Q, mesh); 
	}
}

void receptionCoeff7(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {

	// Pour coeffs d'ondelettes (pas d'chelle)
	// 0-disks

	if (premier<nbc) {

		if (nbc > wr->NbCoeff)
			nbc=wr->NbCoeff;
		if (premier <= M0->NbVertex)
			nbc=M0->NbVertex;
		receptionCoeff61(Q, wr, Invite, M0->NbVertex+3*(premier-M0->NbVertex), M0->NbVertex+3*(nbc-M0->NbVertex), dist, VPC, mesh, M0);
		evaluateQueue(Q, mesh);
		renderLight(Q, mesh);
	} else {
		
		ListeDeFace *liste=NULL;
		receptionCoeff61miroir(Q, wr, Invite, nbc, premier, dist, VPC, &liste, mesh);
		//receptionCoeff61miroirGeom(Q, wr, Invite, premier, nbc, dist, VPC, &liste);
		evaluateQueue(Q, mesh);
		//elagueVPC(Q, wr, Invite, premier, nbc, dist, liste);// Utiliser l'accs direct bien sur
		//Aplatis(premier, nbc, VPC, Q);
		elagueNaif(Q, mesh);
	//	renderLight(Q, mesh); 
	}
}

void receptionCoeff8(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {

	if (premier<nbc) {

		receptionCoeff81(Q, wr, Invite, premier, nbc, dist, VPC, mesh, M0);
		evaluateQueue(Q, mesh);
		renderLight(Q, mesh);
	} else {
		
		ListeDeFace *liste=NULL;
		receptionCoeff81miroir(Q, wr, Invite, nbc, premier, dist, VPC, &liste, mesh);
		//receptionCoeff61miroirGeom(Q, wr, Invite, premier, nbc, dist, VPC, &liste);
		evaluateQueue(Q, mesh);
		//elagueVPC(Q, wr, Invite, premier, nbc, dist, liste);// Utiliser l'accs direct bien sur
		//Aplatis(premier, nbc, VPC, Q);
		elagueNaif(Q, mesh);
	//	renderLight(Q, mesh); 
	}
}

void receptionCoeff62(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0, unsigned int cco[NbVertexMax], unsigned int fa, unsigned int fr) {

	// Liste sommets par coefficient
	// Utilisation de CurrentCoeffs

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, k, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;

	for(k=0; (unsigned)k<fa; k++) {
		i=cco[NbCoeffMax-1-k];
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
	//	ok=ok || (wr->tab[i]->x*wr->tab[i]->x
	//		+wr->tab[i]->y*wr->tab[i]->y
	//		+wr->tab[i]->z*wr->tab[i]->z<dist);
		if (!ok) {
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate4(Q, face, level,  alpha, beta, gamma, i, mesh);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0 && Q->Remember!=-1)) {
				Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
				Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
				Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
			}

			// Texture

			Q->VertexTable[Q->Remember]->u=wr->tab[i]->u;
			Q->VertexTable[Q->Remember]->v=wr->tab[i]->v;

			// Mise a jour de VPC
			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}

			/* Perturbations */
		
			if (level>0 && Q->Remember!=-1) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				if (ALPHA1>epsilon && ALPHA2>epsilon) {
					globalAccomodate4(Q, face, level-1,  a, b, c, i, mesh);
					globalAccomodate4(Q, face, level-1,  aa, bb, cc, i, mesh);

					Q->VertexTable[rem1]->hGeom[level-1][0]-=coeff[0]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][1]-=coeff[1]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][2]-=coeff[2]*ALPHA1;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem1;
						insert->alpha=ALPHA1;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}	
			
			
					Q->VertexTable[rem2]->hGeom[level-1][0]-=coeff[0]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][1]-=coeff[1]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][2]-=coeff[2]*ALPHA2;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem2;
						insert->alpha=ALPHA2;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}
				}
			}
		}
	}
}

void receptionCoeff62miroir(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, ListeDeFace **liste, Mesh *mesh, unsigned int cco[NbCoeffMax], unsigned int fa, unsigned int fr) {

	// Liste sommets par coefficient

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, k, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;
	ListeDeSommets *parcours;
	ListeDeFace *ajout;

	for (k=0; (unsigned)k<fr; k++) {
		i=cco[k];
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		ok=ok;// || (wr->tab[i]->x*wr->tab[i]->x
			//+wr->tab[i]->y*wr->tab[i]->y
			//+wr->tab[i]->z*wr->tab[i]->z<dist/700/700);
		if (!ok) {
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate4(Q, face, level,  alpha, beta, gamma, i, mesh);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;
			if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0 && Q->Remember!=-1)) {

				Q->VertexTable[Q->Remember]->hGeom[level][0]-=coeff[0];
				Q->VertexTable[Q->Remember]->hGeom[level][1]-=coeff[1];
				Q->VertexTable[Q->Remember]->hGeom[level][2]-=coeff[2];
			}
			// Mise a jour de VPC (a miroiriser bien sur...)		
/*			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}
*/
			// Mise a jour de la liste
			parcours=VPC->LDS[i];
			while (parcours!=NULL) {
	
				// Ajout des facettes concernes a la liste 
				if (Q->VertexTable[parcours->id]->parentF[0]!=NULL) {
					ajout=(ListeDeFace *)malloc(sizeof(ListeDeFace));
					ajout->F=Q->VertexTable[parcours->id]->parentF[0];
					ajout->next=*liste;
					*liste=ajout;
				}
				if (Q->VertexTable[parcours->id]->parentF[1]!=NULL) {
					ajout=(ListeDeFace *)malloc(sizeof(ListeDeFace));
					ajout->F=Q->VertexTable[parcours->id]->parentF[1];
					ajout->next=*liste;
					*liste=ajout;
				}
	
				parcours=parcours->next;
			}
			VPC->LDS[i]=NULL; //Cette ligne est a mettre en commentaire si elle est execute a partir de Aplatis()
			// Fin mise a jour de la liste

			/* Perturbations */
		
			if (level>0 && Q->Remember!=-1) {

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta-1)/2)*2==beta-1)&&
					((gamma/2)*2==gamma)) {

					a=(alpha+1)/2;
					b=(beta-1)/2;
					c=gamma/2;

					aa=(alpha-1)/2;
					bb=(beta+1)/2;
					cc=gamma/2;
				}

				if ((((alpha+1)/2)*2==alpha+1)&&(((beta)/2)*2==beta)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=(alpha+1)/2;
					b=beta/2;
					c=(gamma-1)/2;

					aa=(alpha-1)/2;
					bb=beta/2;
					cc=(gamma+1)/2;
				}

				if (((alpha/2)*2==alpha)&&(((beta+1)/2)*2==beta+1)&&
					(((gamma-1)/2)*2==gamma-1)) {

					a=alpha/2;
					b=(beta+1)/2;
					c=(gamma-1)/2;

					aa=alpha/2;
					bb=(beta-1)/2;
					cc=(gamma+1)/2;
				}

				rem1=Q->VertexTable[Q->Remember]->parentV[0]->indice;
				if (Q->VertexTable[rem1]->level>0) n1=6;
				else n1=Q->Valance[rem1];		
				rem2=Q->VertexTable[Q->Remember]->parentV[1]->indice;
				if (Q->VertexTable[rem2]->level>0) n2=6;
				else n2=Q->Valance[rem2];
				ALPHA(n1, n2, &ALPHA1, &ALPHA2);
	
				if (ALPHA1>epsilon && ALPHA2>epsilon) {
					globalAccomodate4(Q, face, level-1,  a, b, c, i, mesh);
					globalAccomodate4(Q, face, level-1,  aa, bb, cc, i, mesh);

					Q->VertexTable[rem1]->hGeom[level-1][0]+=coeff[0]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][1]+=coeff[1]*ALPHA1;
					Q->VertexTable[rem1]->hGeom[level-1][2]+=coeff[2]*ALPHA1;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem1;
						insert->alpha=ALPHA1;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}
			
			
					Q->VertexTable[rem2]->hGeom[level-1][0]+=coeff[0]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][1]+=coeff[1]*ALPHA2;
					Q->VertexTable[rem2]->hGeom[level-1][2]+=coeff[2]*ALPHA2;
					//VPC
					{
						ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));
	
						insert->id=rem2;
						insert->alpha=ALPHA2;
						insert->next=VPC->LDS[i];
						VPC->LDS[i]=insert;
					}
				}
			}
		}
	}
}

/*
void receptionCoeff7(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0, unsigned int cc[NbVertexMax], unsigned int fa, unsigned int fr) {

	// Utilise CurrentCoeffs
	
	ListeDeFace *liste=NULL;
	
	
	receptionCoeff62miroir(Q, wr, Invite, nbc, premier, dist, VPC, &liste, mesh, cc, fa, fr);
	//receptionCoeff61miroirGeom(Q, wr, Invite, premier, nbc, dist, VPC, &liste);
	evaluateQueue(Q, mesh);
	//elagueVPC(Q, wr, Invite, premier, nbc, dist, liste);// Utiliser l'accs direct bien sur
	//Aplatis(premier, nbc, VPC, Q);
	elagueNaif(Q, mesh);
	//	renderLight(Q, mesh); 

	receptionCoeff62(Q, wr, Invite, premier, nbc, dist, VPC, mesh, M0, cc, fa, fr);
	evaluateQueue(Q, mesh);
	renderLight(Q, mesh);
	
}
*/

void receptionCoeffButterfly(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {
	
	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;
	void moveVertexButterfly(Qtree*);
	void moveVertexButterflyS(Sommet*);

	i=premier;
	while((unsigned)i<wr->NbCoeff && cmpt+premier<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
			//	ok=ok || (wr->tab[i]->x*wr->tab[i]->x
			//		+wr->tab[i]->y*wr->tab[i]->y
			//		+wr->tab[i]->z*wr->tab[i]->z<dist*dist);
		if (!ok && i>=0 && i<wr->NbCoeff) { 
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x; 
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);

			//Accomodation//////////////////////////////////////////////////////////////

			
			if (level>0) {
				globalAccomodateButterfly(Q, face, level,  alpha, beta, gamma, i, mesh);
			} else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;

			//Dplacement du sommet central
			//moveVertexButterflyS(Q->VertexTable[Q->Remember]);

			//Filtre passe haut
			/*if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0  && Q->Remember!=-1)) {*/
			Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
			Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
			Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
			//}

			// Texture
			//Q->VertexTable[Q->Remember]->u=wr->tab[i]->u;
			//Q->VertexTable[Q->Remember]->v=wr->tab[i]->v;

			// Mise a jour de VPC
			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}

			
		}
		i++;
	}
}

void receptionCoeffLoop(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {
	
	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;
	void globalAccomodateLoop(Qtree *, int, int,  int, int, int, int, Mesh *);

	i=premier;
	while((unsigned)i<wr->NbCoeff && cmpt+premier<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		while (Invite[j]!=-1) {
			if (Invite[j]==face) {
				ok=0;
				break;
			}
			j++;
		}
		if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
			//	ok=ok || (wr->tab[i]->x*wr->tab[i]->x
			//		+wr->tab[i]->y*wr->tab[i]->y
			//		+wr->tab[i]->z*wr->tab[i]->z<dist*dist);
		if (!ok && i>=0 && i<wr->NbCoeff) { 
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=0;//wr->tab[i]->x; // Temporaire
			coeff[1]=0;//wr->tab[i]->y;
			coeff[2]=0;//wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);

			//Accomodation//////////////////////////////////////////////////////////////

			
			if (level>0) {
				globalAccomodateLoop(Q, face, level,  alpha, beta, gamma, i, mesh);
			} else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;

			//Dplacement du sommet central
			//moveVertexButterflyS(Q->VertexTable[Q->Remember]);

			//Filtre passe haut
			/*if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
				|| (level!=0  && Q->Remember!=-1)) {*/
			Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
			Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
			Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
			//}

			// Texture
			//Q->VertexTable[Q->Remember]->u=wr->tab[i]->u;
			//Q->VertexTable[Q->Remember]->v=wr->tab[i]->v;

			// Mise a jour de VPC
			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}

			
		}
		i++;
	}
}


void updateCoeffButterfly(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {

	if (premier<nbc) { //Incrmentation

		receptionCoeffButterfly(Q, wr, Invite, premier, nbc, dist, VPC, mesh, M0);
		evaluateQueue/*Butterfly*/(Q, mesh);
		renderLight(Q, mesh);
	} else { //Coarsening
			
		// Vide pour l'instant
		
	}
}

void updateCoeffLoop(Qtree *Q, WaveRep *wr, int Invite[NbFaceMax], int premier, int nbc, double dist, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {

	if (premier<nbc) { //Incrmentation

		receptionCoeffLoop(Q, wr, Invite, premier, nbc, dist, VPC, mesh, M0);
		evaluateQueue(Q, mesh);
		renderLight(Q, mesh);
	} else { //Coarsening
			
		// Vide pour l'instant
		
	}
}

void receptionCoeff21Loc(Qtree *Q, WaveRep *wr, int premier, int nbc, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0, FILE *f) {

	// Liste sommets par coefficient
	//f doit tre ouvert

	int face, level, alpha, beta, gamma, a, b, c, aa, bb, cc, n1, n2, rem1, rem2, i=0, j, ok=1, cmpt=0;
	double coeff[3], ALPHA1, ALPHA2;
	double vecu[3], vecv[3], vecn[3], vecn1[3], vecn2[3];
	float x, y, z;

	i=premier;
	while((unsigned)i<wr->NbCoeff && cmpt+premier<nbc) {
		ok=1;
		face=wr->tab[i]->F0;
		j=0;
		//if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma==1)
			ok=0;
		if (!ok && i>=0 && i<wr->NbCoeff) { 
			cmpt++;
			alpha=wr->tab[i]->alpha;
			beta=wr->tab[i]->beta;
			gamma=wr->tab[i]->gamma;
			coeff[0]=wr->tab[i]->x;
			coeff[1]=wr->tab[i]->y;
			coeff[2]=wr->tab[i]->z;	
			Q->Remember=-1;
			level=log2(alpha+beta+gamma);
	
			/* Pic central */

			if (level>0) 
				globalAccomodate4(Q, face, level,  alpha, beta, gamma, i, mesh);
			else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
							 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
							 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;

			Q->VertexTable[Q->Remember]->hGeom[level][0]+=coeff[0];
			Q->VertexTable[Q->Remember]->hGeom[level][1]+=coeff[1];
			Q->VertexTable[Q->Remember]->hGeom[level][2]+=coeff[2];
		
			// Texture

			Q->VertexTable[Q->Remember]->u=wr->tab[i]->u;
			Q->VertexTable[Q->Remember]->v=wr->tab[i]->v;

			//Repres locaux
			if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma>1) {
				//Rappel : que lazy et que si l'ordre des niveaux est respect
				fprintf(f, "%d %d %d %d ", wr->tab[i]->F0, wr->tab[i]->alpha, wr->tab[i]->beta, wr->tab[i]->gamma);
				// normale  la premiere face
				moins(Q->VertexTable[Q->Remember]->parentF[0]->sommetCoin[1]->g, Q->VertexTable[Q->Remember]->parentF[0]->sommetCoin[0]->g, vecu);
				moins(Q->VertexTable[Q->Remember]->parentF[0]->sommetCoin[2]->g, Q->VertexTable[Q->Remember]->parentF[0]->sommetCoin[0]->g, vecv);
				vect(vecu, vecv, vecn1);
				normalize(vecn1);
				// normalizeale  la premiere face
				moins(Q->VertexTable[Q->Remember]->parentF[1]->sommetCoin[1]->g, Q->VertexTable[Q->Remember]->parentF[1]->sommetCoin[0]->g, vecu);
				moins(Q->VertexTable[Q->Remember]->parentF[1]->sommetCoin[2]->g, Q->VertexTable[Q->Remember]->parentF[1]->sommetCoin[0]->g, vecv);
				vect(vecu, vecv, vecn2);
				normalize(vecn2);
				//normalizeale moyenne
				vecn[0]=vecn1[0]+vecn2[0];
				vecn[1]=vecn1[1]+vecn2[1];
				vecn[2]=vecn1[2]+vecn2[2];
				normalize(vecn);
				//compltion de la base
				vecv[0]=Q->VertexTable[Q->Remember]->parentV[0]->g[0]-Q->VertexTable[Q->Remember]->parentV[1]->g[0];
				vecv[1]=Q->VertexTable[Q->Remember]->parentV[0]->g[1]-Q->VertexTable[Q->Remember]->parentV[1]->g[1];
				vecv[2]=Q->VertexTable[Q->Remember]->parentV[0]->g[2]-Q->VertexTable[Q->Remember]->parentV[1]->g[2];
				normalize(vecv); // inutile normalizealement...
				vect(vecn, vecv, vecu);
				normalize(vecu);
				// projection
				x=vecu[0]*wr->tab[i]->x+vecu[1]*wr->tab[i]->y+vecu[2]*wr->tab[i]->z;
				y=vecv[0]*wr->tab[i]->x+vecv[1]*wr->tab[i]->y+vecv[2]*wr->tab[i]->z;
				z=vecn[0]*wr->tab[i]->x+vecn[1]*wr->tab[i]->y+vecn[2]*wr->tab[i]->z;
				//ecriture
				fprintf(f, "%f %f %f\n", x, y, z);
			}


			// Mise a jour de VPC
			{
				ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

				insert->id=Q->Remember;
				insert->alpha=1;
				insert->next=VPC->LDS[i];
				VPC->LDS[i]=insert;
			}
		}
		i++;
	}
}

void receptionCoeff2Loc(Qtree *Q, WaveRep *wr, int premier, int nbc, VertexPerCoeff *VPC, Mesh *mesh, Mesh *M0) {

	int i;
	FILE *f=fopen("local.wv", "w");
	if (premier<nbc) {
		for (i=premier; i<nbc; i++) {
			receptionCoeff21Loc(Q, wr, i, i+1, VPC, mesh, M0, f);
			if (i!=nbc) { 
				if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma!=wr->tab[i+1]->alpha+wr->tab[i+1]->beta+wr->tab[i+1]->gamma) {
					evaluateQueue(Q, mesh);
					renderLight(Q, mesh);
				}
			} else {
				evaluateQueue(Q, mesh);
				renderLight(Q, mesh);
			}
		}
	} 
	fprintf(f, "-1");
	fclose(f);
}




/*int i;
	FILE *f=fopen("local.wv", "w");
	if (premier<nbc) {
		for (i=premier; i<nbc; i++) {
			receptionCoeff21Loc(Q, wr, i, i+1, VPC, mesh, M0, f);			
			evaluateQueue(Q, mesh);
			renderLight(Q, mesh);
		}
	} 
	fprintf(f, "-1");
	fclose(f);*/

/*
int i;
	FILE *f=fopen("local.wv", "w");
	if (premier<nbc) {
		for (i=premier; i<nbc; i++) {
			receptionCoeff21Loc(Q, wr, i, i+1, VPC, mesh, M0, f);
			if (i!=nbc) { 
				if (wr->tab[i]->alpha+wr->tab[i]->beta+wr->tab[i]->gamma!=wr->tab[i+1]->alpha+wr->tab[i+1]->beta+wr->tab[i+1]->gamma) {
					evaluateQueue(Q, mesh);
					renderLight(Q, mesh);
				}
			} else {
				evaluateQueue(Q, mesh);
				renderLight(Q, mesh);
			}
		}
	} 
	fprintf(f, "-1");
	fclose(f);*/

void absoluteLocalHighPassNLB(WaveCo *wc, int indice, Mesh *mesh, Qtree *Q, VertexPerCoeff *VPC) {

	int alpha, beta, gamma, level, face;
	double coeff[3];

	face=wc->F0;
	alpha=wc->alpha;
	beta=wc->beta;
	gamma=wc->gamma;
	coeff[0]=wc->x;
	coeff[1]=wc->y;
	coeff[2]=wc->z;	
	Q->Remember=-1;
	level=log2(alpha+beta+gamma);

	/* Pic central */

	if (level>0) 
		globalAccomodate4(Q, face, level,  alpha, beta, gamma, 0/* not used*/, mesh);
	else Q->Remember=(alpha!=0)*Q->racines[face]->sommetCoin[0]->indice+
					 (beta!=0)*Q->racines[face]->sommetCoin[1]->indice+
					 (gamma!=0)*Q->racines[face]->sommetCoin[2]->indice;

	/*if ((level==0 && norm(Q->VertexTable[Q->Remember]->g)==0)
		|| (level!=0  && Q->Remember!=-1)) {*/
		Q->VertexTable[Q->Remember]->fGeom[0]=coeff[0];
		Q->VertexTable[Q->Remember]->fGeom[1]=coeff[1];
		Q->VertexTable[Q->Remember]->fGeom[2]=coeff[2];
	
	//}


	// Mise a jour de VPC
	// Attention, il s'agit ici d'un CPV
	{
		ListeDeSommets *insert=(ListeDeSommets *)malloc(sizeof(ListeDeSommets));

		insert->id=indice;
		insert->alpha=1;
		insert->next=VPC->LDS[Q->Remember];
		VPC->LDS[Q->Remember]=insert;
	}
	
}