// -*- c++ -*-

#ifndef __IMPLICITPROXY_H__
#define __IMPLICITPROXY_H__

#include "../../geometry/GeometryProxy.h"

#include "DensityTLS.h"
#include "VolumeTreeNode/SGDLTools.h"
#include "SGDLPolygonise.h"

/// Implicit renderer node
class ImplicitProxy : public GeometryProxy
{
public:
  /// Constructor
  ImplicitProxy(Implicit* pImplicit);

  /// Destructor
  ~ImplicitProxy();

  /// Render object
  virtual BOOL		Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  /// Traverse scene graph, checking for intersection
  virtual BOOL		Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

  /// Render object description
  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

private:
    inline Implicit* GetImplicit() const{ return (Implicit*)GetMediaObject(); }

	DWORD updateTime_;
	bool checkUpdate();
	void setDisplayList(int dispLst);

public:
	Volume_Tree_Node *GetVolumeTreeNode();
	static Volume_Tree_Node* GetVolumeTreeNode(Implicit* obj);

	// is p outside the shape 
	Bool isOutside(const Vec3f &p);

	// added NURBS CURVE PROXY
    void GetBbox(Vec3f& rBboxSize, Vec3f& rBboxCenter) const;

	//protected members
protected : 
    static CString TextureURL;
};

#endif // __IMPLICITPROXY_H__
