#ifndef _QUADRIC_PROXY_
#define _QUADRIC_PROXY_

#include "../../geometry/GeometryProxy.h"

#include "DensityTLS.h"
#include "VolumeTreeNode/SGDLTools.h"
#include "SGDLPolygonise.h"

/* Quadric Proto templates */

enum eProto
{
     eProto_Cube = 0,
     eProto_Cylindre ,
     //eProto_Sphere ,
     eProto_Prisme ,
     //eProto_Eight_Of_Ellipsoide ,
     eProto_Cone ,
     eProto_Quarter_Cone ,
     eProto_Quarter_Cylinder ,
     eProto_Dual_Quarter_Cylinder,
     eProto_Count,
     eProto_Pad = 0xffff
};

class QuadricProxy : public GeometryProxy {
    // Protected members
protected:
    static double ControlPoints[eProto_Count][24];
    static CString TextureURL;

public:
	QuadricProxy(Quadric* pQuadric);
	virtual ~QuadricProxy();

	// is p outside the shape
	Bool isOutside(const Vec3f &p) ;

	Volume_Tree_Node *GetVolumeTreeNode();
    static double *Get_Current_Coeff(Quadric* obj, double coeff[10]);
	static Volume_Tree_Node* GetVolumeTreeNode(Quadric* obj);

private:
    inline Quadric* GetQuadric() const { return (Quadric*) GetMediaObject(); }

    DWORD updateTime_;
	bool checkUpdate();
	void setDisplayList(int dispLst);

public:
	virtual BOOL	Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	virtual BOOL	RenderBox(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	virtual BOOL	Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);
	virtual void	RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
};


#endif /*_QUADRIC_PROXY_*/
