#ifdef FIXME_OB

/********************************************************************/
//
//						gdsgdl.cpp
//
// Implementation of the polygonisation of SGDL primitives
//
//
/*******************************************************************/

#if 1 // FIXME_OB
# include <ZTL.h>
# include "point.h"
# include "pointa.h"
#endif

//**cm**
#include "stdafx.h"
#include "gdsgdl.h"
#include "gshell.h"
#include "gshelli.h"

#undef L
#undef R
#undef B
#undef T
#undef N
#undef F

static int cube_flags = SHELL_CONVEX|SHELL_CLOSED;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

GShellI *NewGDhxahxa(float dx,float dy,float dz, Point *fcolors,GShellI *o)
{

	//characteristics
	const int nbvertex=50;
	const int nbvertbyface=3;
	const int nbface=96;

    PointArray _p(nbvertex);
    Point params[4];
    PointArray norm(nbface * nbvertbyface);

    int p,i=0,j,k;
    p= 0;

    Point Po(0,0,0);
    //coordonnes des 50 sommets
    for (k = 0; k < 2; k++)
    {
        //Face 1,6 0 to 3
        for (int i = 0; i < 4; i++)
        {
           _p[p++].Set(dx*0.5,dy*0.5 - dy*float(k),-dz*0.5 +i*dz/4 );
           Po = _p[p - 1];
        }

        //Face 1,6 4 to 7
        for (i = 0; i < 4; i++)
        {
           _p[p++].Set(dx*0.5 - i*dx/4 ,dy*0.5 - dy*float(k),dz*0.5 );
           Po = _p[p - 1];
        }

        //Face 1,6 8 to 11
        for (i = 0; i < 4; i++)
        {
           _p[p++].Set(-dx*0.5,dy*0.5 - dy*float(k),dz*0.5 - i*dz/4 );
           Po = _p[p - 1];
        }

        //Face 1,6 12 to 15
        for (i = 0; i < 4; i++)
        {
            _p[p++].Set(-dx*0.5 + i*dx/4,dy*0.5 - dy*float(k),-dz*0.5 );
            Po = _p[p - 1];
        }
    }

    //32 to 34
    for (i = 1; i < 4; i++)
    {
        _p[p++].Set(dx*0.5 ,dy*0.5 - i*dy/4,-dz*0.5);
        Po = _p[p - 1];
    }

    //35 to 37
    for (i = 1; i < 4; i++)
    {
        _p[p++].Set(dx*0.5 ,dy*0.5 - i*dy/4,dz*0.5);
        Po = _p[p - 1];
    }

    //38 to 40
    for (i = 1; i < 4; i++)
    {
        _p[p++].Set(-dx*0.5 ,dy*0.5 - i*dy/4,dz*0.5);
        Po = _p[p - 1];
    }

    //41 to 43
    for (i = 1; i < 4; i++)
    {
        _p[p++].Set(-dx*0.5,dy*0.5 - i*dy/4,-dz*0.5);
        Po = _p[p - 1];
    }

    //Center faces points
     //44
     _p[p++].Set(0, dy*0.5, 0);

     //45
     _p[p++].Set(dx*0.5, 0, 0);

     //46
     _p[p++].Set(0 , 0 , -dz*0.5);

     //47
     _p[p++].Set( 0,  0 , dz*0.5);

     //48
     _p[p++].Set(-dx*0.5, 0 , 0);

     //49
     _p[p++].Set(0, -dy*0.5, 0);

	if (!o)
	    o = new GShellI;

	GVertexI *verts = new GVertexI[nbface * nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface * (nbvertbyface + 1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif
	int f,vi= 0,vn =0;

int rendu_verts = 0;
int pas_rap;
int deb;
int fin;
int rendu;
int centre;

//FACE1
rendu = 0;
centre = 44;
  for ( i = 0; i < 16; i++)
  {
    verts[rendu_verts++].v = rendu;
    if ( rendu == 15 )
       rendu = -1;

    verts[rendu_verts++].v = centre;
    verts[rendu_verts++].v = ++rendu;
  }

//FACE6
rendu = 31;
centre = 49;
  for ( i = 0; i < 16; i++)
  {
    verts[rendu_verts++].v = rendu;
    if ( rendu == 16 )
       rendu = 32;

    verts[rendu_verts++].v = centre;
    verts[rendu_verts++].v = --rendu;
  }

//FACE3
pas_rap = 0;
deb = 12;
fin = 15;
centre = 46;
  for ( i = 0; i < 4; i++)
  {
    verts[rendu_verts++].v = deb;

    if ( deb == fin )
        verts[rendu_verts++].v = pas_rap;
    else
        verts[rendu_verts++].v = ++deb;
     verts[rendu_verts++].v = centre;
  }

deb = 28;
fin = 31;

  for ( i = 0; i < 4; i++)
  {
    verts[rendu_verts++].v = deb;
    if ( deb == fin )
       deb = 15;

    verts[rendu_verts++].v = centre;
    verts[rendu_verts++].v = ++deb;
  }

deb = 41;
fin = 43;
pas_rap = 28;

  for ( i = 0; i < 3; i++)
  {
    verts[rendu_verts++].v = deb;
    verts[rendu_verts++].v = centre;
    if ( deb == fin )
        verts[rendu_verts++].v = pas_rap;
    else
        verts[rendu_verts++].v = ++deb;

  }

deb = 32;
fin = 34;
pas_rap = 16;

  for (i = 0; i < 3; i++)
  {
    verts[rendu_verts++].v = deb;

    if ( deb == fin )
        verts[rendu_verts++].v = pas_rap;
    else
        verts[rendu_verts++].v = ++deb;
    verts[rendu_verts++].v = centre;
  }

verts[rendu_verts++].v = 12;
verts[rendu_verts++].v = centre;
verts[rendu_verts++].v = 41;

verts[rendu_verts++].v = 0;
verts[rendu_verts++].v = 32;
verts[rendu_verts++].v = centre;

//FACE4
deb = 4;
fin = 8;
centre = 47;
  for ( i = 0; i < 4; i++)
  {
    verts[rendu_verts++].v = deb;
    verts[rendu_verts++].v = ++deb;
    verts[rendu_verts++].v = centre;
  }

deb = 20;
fin = 24;
  for ( i = 0; i < 4; i++)
  {
    verts[rendu_verts++].v = deb;
    verts[rendu_verts++].v = centre;
    verts[rendu_verts++].v = ++deb;
  }

deb = 35;
fin = 37;
pas_rap = 20;

  for ( i = 0; i < 3; i++)
  {
    verts[rendu_verts++].v = deb;
    verts[rendu_verts++].v = centre;
    if ( deb == fin )
        verts[rendu_verts++].v = pas_rap;
    else
        verts[rendu_verts++].v = ++deb;

  }

deb = 38;
fin = 40;
pas_rap = 24;

  for ( i = 0; i < 3; i++)
  {
    verts[rendu_verts++].v = deb;

    if ( deb == fin )
        verts[rendu_verts++].v = pas_rap;
    else
        verts[rendu_verts++].v = ++deb;
     verts[rendu_verts++].v = centre;

  }

verts[rendu_verts++].v = 4;
verts[rendu_verts++].v = centre;
verts[rendu_verts++].v = 35;

verts[rendu_verts++].v = 8;
verts[rendu_verts++].v = 38;
verts[rendu_verts++].v = centre;

//FACE5
deb = 8;
fin = 12;
centre = 48;
  for ( i = 0; i < 4; i++)
  {
    verts[rendu_verts++].v = deb;
    verts[rendu_verts++].v = ++deb;
    verts[rendu_verts++].v = centre;
  }

deb = 24;
fin = 28;
  for ( i = 0; i < 4; i++)
  {
    verts[rendu_verts++].v = deb;
    verts[rendu_verts++].v = centre;
    verts[rendu_verts++].v = ++deb;
  }

deb = 38;
fin = 40;
pas_rap = 24;

  for ( i = 0; i < 3; i++)
  {
    verts[rendu_verts++].v = deb;
    verts[rendu_verts++].v = centre;
    if ( deb == fin )
        verts[rendu_verts++].v = pas_rap;
    else
        verts[rendu_verts++].v = ++deb;

  }

deb = 41;
fin = 43;
pas_rap = 28;

  for ( i = 0; i < 3; i++)
  {
    verts[rendu_verts++].v = deb;

    if ( deb == fin )
        verts[rendu_verts++].v = pas_rap;
    else
        verts[rendu_verts++].v = ++deb;
    verts[rendu_verts++].v = centre;
  }

verts[rendu_verts++].v = 8;
verts[rendu_verts++].v = centre;
verts[rendu_verts++].v = 38;

verts[rendu_verts++].v = 12;
verts[rendu_verts++].v = 41;
verts[rendu_verts++].v = centre;

//FACE2
deb = 0;
fin = 4;
centre = 45;
  for ( i = 0; i < 4; i++)
  {
    verts[rendu_verts++].v = deb;

    verts[rendu_verts++].v = ++deb;
    verts[rendu_verts++].v = centre;
  }

deb = 16;
fin = 20;
  for ( i = 0; i < 4; i++)
  {
    verts[rendu_verts++].v = deb;

    verts[rendu_verts++].v = centre;
    verts[rendu_verts++].v = ++deb;
  }

deb = 32;
fin = 34;
pas_rap = 16;

  for ( i = 0; i < 3; i++)
  {
    verts[rendu_verts++].v = deb;
    verts[rendu_verts++].v = centre;
    if ( deb == fin )
        verts[rendu_verts++].v = pas_rap;
    else
        verts[rendu_verts++].v = ++deb;

  }

deb = 35;
fin = 37;
pas_rap = 20;

  for ( i = 0; i < 3; i++)
  {
    verts[rendu_verts++].v = deb;

    if ( deb == fin )
        verts[rendu_verts++].v = pas_rap;
    else
        verts[rendu_verts++].v = ++deb;
    verts[rendu_verts++].v = centre;
  }

verts[rendu_verts++].v = 0;
verts[rendu_verts++].v = centre;
verts[rendu_verts++].v = 32;

verts[rendu_verts++].v = 4;
verts[rendu_verts++].v = 35;
verts[rendu_verts++].v = centre;


    for (j = 0; j < nbvertex ; j++)
    {
        norm[j].x = (f%2 * pow(-1, f%3));
		norm[j].z = 0;
		norm[j].y = (f + 1)%2 * pow(-1, f%3);
		norm[j].Normalize();

    }

	for ( k=0; k<rendu_verts; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<rendu_verts;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);
	params[3].Set(0.0,0.0,0.0);

  	o->SetV(50,_p);
    o->SetVP(3,params);
    o->SetVertices(rendu_verts,verts);

    delete verts;

	o->SetFaceList(flist);
    o->nfaces = nbface;

   return(o);

}

//cre un prisme circonscrit dans une boite dont la grandeur est spcifie par dx,dy,dz
//create prism circumscribed in a box( the size is specified by dx, dy, dz)
GShellI *NewGDprihxa(float dx,float dy,float dz, Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=6;
	const int nbvertbyface=3;
	const int nbface=8;

   Point _p[nbvertex];
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //coordonnees des sommets//vertex coordinates
   for(k=0; k<=1; k++){
	   _p[p++].Set(-dx*0.5,-dy*0.5,-dz*0.5 + dz*float(k));
	   _p[p++].Set(0,dy*0.5,-dz*0.5 + dz*float(k));
	   _p[p++].Set(dx*0.5,-dy*0.5,-dz*0.5 + dz*float(k));
   }


	if (!o)
			  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif
	int r,vi=0,nbrow=3;
	for (r=0; r<nbrow; r++){
		//face de cote
		//sides
		if(r==1){
		verts[vi++].v=r-1;	verts[vi++].v=r; verts[vi++].v=r+1;
		verts[vi++].v=r+4; verts[vi++].v=r+3; verts[vi++].v=r+2;
		}
		//triangle 1
		verts[vi++].v=(r+1)%3;
		verts[vi++].v=r;
		verts[vi++].v=r+3;

		//triangle 2
		verts[vi++].v=r+3;
		verts[vi++].v=(r+1)%3 + 3;
		verts[vi++].v=(r+1)%3;
	}

	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(nbvertex,_p);
	o->SetVN(nbface*nbvertbyface);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);


	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(cube_flags);
	o->nfaces=nbface;


	return(o);
}


//cre une pyramide circonscrite dans une boite dont la grandeur est spcifie par dx,dy,dz
//create pyramid circumscribed in a box( the size is specified by dx, dy, dz)
GShellI *NewGDpyrhxa(float dx,float dy,float dz, Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=5;
	const int nbvertbyface=3;
	const int nbface=6;

   Point _p[nbvertex];
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //top vertex
   _p[p++].Set(0,dy*0.5,0);
   //coordonnees des sommets//vertex coordinates//
   for(k=0; k<=1; k++){
	   _p[p++].Set(-dx*0.5 + dx*float(k),-dy*0.5,-dz*0.5 + dz*float(k));
	   _p[p++].Set(dx*0.5 - dx*float(k),-dy*0.5,-dz*0.5 + dz*float(k));
   }


	if (!o)
			  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif

	int r,vi=0;
	for (r=0; r<4; r++){
		//4 faces de la pyramide
		verts[vi++].v=r+1;
		verts[vi++].v=0;
		verts[vi++].v=(r+1)%4+1;
	}
	//base
	verts[vi++].v=4; verts[vi++].v=1; verts[vi++].v=2;
	verts[vi++].v=2; verts[vi++].v=3; verts[vi++].v=4;

	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(nbvertex,_p);
	o->SetVN(nbface*nbvertbyface);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(cube_flags);
	o->nfaces=nbface;

	return(o);
}


//cre une ttrahdre circonscrit dans une boite dont la grandeur est spcifie par dx,dy,dz
//create tetrahedron circumscribed in a box( the size is specified by dx, dy, dz)
GShellI *NewGDtethxa(float dx,float dy,float dz, Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=4;
	const int nbvertbyface=3;
	const int nbface=4;

   Point _p[nbvertex];
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //coordonnees des sommets//vertex coordinates
   for(k=0; k<=1; k++){
	   _p[p++].Set(-dx*0.5 ,-dy*0.5 + dy*float(k),-dz*0.5 + dz*float(k));
	   _p[p++].Set(dx*0.5 ,dy*0.5 - dy*float(k),-dz*0.5 + dz*float(k));
   }


	if (!o)
		  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif

	int r,vi=0;
	for (r=0; r<2; r++){
		verts[vi++].v=0; verts[vi++].v=(r+1)%5; verts[vi++].v=(r+1)%5+1;
		verts[vi++].v=3; verts[vi++].v=(r+1)%3; verts[vi++].v=r%3;
	}

	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(nbvertex,_p);
	o->SetVN(nbface*nbvertbyface);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(cube_flags);
	o->nfaces=nbface;
	return(o);
}

//cre un octadre circonscrit dans une boite dont la grandeur est spcifie par dx,dy,dz
//create octahedron circumscribed in a box( the size is specified by dx, dy, dz)
GShellI *NewGDocthxa(float dx,float dy,float dz, Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=6;
	const int nbvertbyface=3;
	const int nbface=8;

   Point _p[nbvertex];
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //coordonees des sommets//vertex coordinates
   for(k=0; k<=1; k++){
	   _p[p++].Set(-dx*0.5 + dx*float(k),0,0);
	   _p[p++].Set(0,0,dz*0.5 - dz*float(k));
   }
   for(k=0; k<=1; k++) _p[p++].Set(0,dy*0.5-dy*float(k),0);

	if (!o)
		  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif

	int vi=0;
	for (i=0; i<4; i++){
		//triangle 1
		verts[vi++].v=(i+1)%4; verts[vi++].v=4; verts[vi++].v=(i+2)%4;
		//triangle 2
		verts[vi++].v=(i+2)%4; verts[vi++].v=5; verts[vi++].v=(i+1)%4;
	}

	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(nbvertex,_p);
	o->SetVN(nbface*nbvertbyface);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(cube_flags);
	o->nfaces=nbface;
	return(o);
}


//permet de construire un paraboloide hyperbolique circonscrit dans une boite
//creates hyperbolic paraboloid circumscribed
/*GShellI *NewGDphyhxa(float dx,float dy,float dz,int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int ndiv=nbr;
	const int nbvertex=2*nbr+4;
	const int nbvertbyface=3;
	const int nbface=2*nbr+6;

	float dist=sqrt(dz*dz + dy*dy);
	float incr=dist/nbr;
	float teta1=atan(dy/dz);
	float teta2=atan(dz/dy);
	float x0=-dx*0.5;
	float y0=-dy*0.5;
	float z0=-dz*0.5;
	float x,y,z;


   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //vertex array
   for(k=0; k<=ndiv; k++){
	   x=x0;
	   y=y0+sin(teta1)*float(k)*incr;
	   z=z0+cos(teta1)*float(k)*incr;
	   _p[p++].Set(x,y,z);
	   x=x0+dx;
	   y=(y0+dy)-cos(teta2)*float(k)*incr;
	   z=z0+sin(teta2)*float(k)*incr;
	   _p[p++].Set(x,y,z);
   }
   for(k=0; k<=1; k++){
	   _p[p++].Set(x0+dx*float(k),y0,z0+dz*float(1-k));
   }

	if (!o)
	  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface+2*(nbr+2)];
	GFaceList flist(nbface*(nbvertbyface+1)+2*(nbr+3));
	flist.SetLength(0);

	//face courbe//curved face
	int vi=0;
	for (i=0; i<2*nbr; i++){
		//triangle 1
		verts[vi++].v=i; verts[vi++].v=i+2; verts[vi++].v=i+1;
		i++;
		//triangle 2
		verts[vi++].v=i; verts[vi++].v=i+1; verts[vi++].v=i+2;
	}

	//fond
	verts[vi++].v=_p.Length()-1; verts[vi++].v=2*nbr+1; verts[vi++].v=0;
	verts[vi++].v=2*nbr+1; verts[vi++].v=_p.Length()-2; verts[vi++].v=0;

	verts[vi++].v=1; verts[vi++].v=_p.Length()-1; verts[vi++].v=0;
	verts[vi++].v=2*nbr; verts[vi++].v=_p.Length()-2; verts[vi++].v=2*nbr+1;


	int endcurvedfaces=vi;
	int *face1=new int[nbr+2];
	int *face2=new int[nbr+2];
	//essai autre facon de faire les cots pour que ca marche ds opengeom  a finir!!!!
	for(i=0,j=0; i<=nbr; i++,j++){
		face1[j]=vi;
		verts[vi++].v=2*i+1;
	}
	face1[j]=vi;
	verts[vi++].v=_p.Length()-1;
	for(i=nbr,j=0; i>=0; i--,j++){
		face2[j]=vi;
		verts[vi++].v=2*i;
	}
	face2[j]=vi;
	verts[vi++].v=_p.Length()-2;

	//cotes//sides
	//verts[vi++].v=2*nbr; verts[vi++].v=0; verts[vi++].v=_p.Length()-2;




	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<endcurvedfaces;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}
	flist.AppendPoly(nbr+2,face1);
	flist.AppendPoly(nbr+2,face2);


	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(_p);
	o->SetVN(nbface*nbvertbyface);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(cube_flags);
	o->nfaces=nbface;
	return(o);
}*/

//permet de construire un cylindre circonscrit dans une boite
//creates a cylinder circumsribed in a box
GShellI *NewGDcylhxa(float dx,float dy,float dz,int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=2*nbr+2;
	const int nbvertbyface=3;
	const int nbface=4*nbr; //bon nbr de faces. a t chang pour test
	//const int nbface=2*nbr;
	int offset=nbr+1;

	float teta=2*PI/nbr;
	float x,y,z;

   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //vertex array//
   for (int f=0; f<2; f++){
	   //center
	   _p[p++].Set(0,0.5*dy-dy*float(f),0);
	//tour
   for(k=0; k<nbr; k++){
	   x=0.5*dx*cos(k*teta);
	   y=dy*0.5-dy*float(f);
	   z=0.5*dz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}
   }


	if (!o)
	  o = new GShellI;

	//+10 rajoute seulement pour test
	GVertexI *verts = new GVertexI[nbface*nbvertbyface+2*(nbr+1)];
#ifdef FIXME_OB
	GFaceList flist((nbface)*(nbvertbyface+1)+2*(nbr+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif

	int vi=0;
	//triangles pour les 2 faces


	j=0;
	for (i=0; i<(nbr-1); i++){
			verts[vi++].v=j; verts[vi++].v=j+i+2; verts[vi++].v=j+i+1;
	}
	verts[vi++].v=j; verts[vi++].v=j+1; verts[vi++].v=nbr+j;
	j=offset;
	for (i=0; i<(nbr-1); i++){
		verts[vi++].v=j; verts[vi++].v=j+i+1; verts[vi++].v=j+i+2;
	}
	verts[vi++].v=j; verts[vi++].v=nbr+j; verts[vi++].v=j+1;



	for(i=1; i<nbr; i++){
		//triangle 1
		verts[vi++].v=i; verts[vi++].v=i+1; verts[vi++].v=i+offset;
		//triangle 2
		verts[vi++].v=i+1; verts[vi++].v=i+offset+1; verts[vi++].v=i+offset;
	}
	//entre premier et dernier
		//triangle 1
		verts[vi++].v=nbr; verts[vi++].v=1; verts[vi++].v=_p.Length()-1;
		//triangle 2
		verts[vi++].v=1; verts[vi++].v=offset+1; verts[vi++].v=_p.Length()-1;


	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}
	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(_p);
	o->SetVN(nbface*nbvertbyface+2*(nbr+1),(Point *)NULL);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi/*+2*(nbr+1)*/,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(SHELL_CONVEX);
	o->nfaces=nbface;
	return(o);
}


//permet de construire un quart de cylindre circonscrit dans une boite avec possibilite d'une epaisseur
//creates a quarter of cylinder with a given thickness circumsribed in a box
GShellI *NewGDqcthxa(float dx,float dy,float dz,float dist, int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=4*(nbr+1)+2;
	const int nbvertbyface=3;
	const int nbface=8*nbr+4;
	//difference between a bottom vertex and the corresponding top vertex
	int height=nbr+1;
	//corresponding position in the vertex array of the top center(of the cylinder)  vertex
	int topcent=0;
	//corresponding position in the vertex array of the bottom center(of the cylinder)  vertex
	int botcent=topcent+1;

	//la position dans le tableau de sommet correspondant au coin suprieur droit
	//the position in the vertex array corresponding to the top corner right
	int topcornerr=botcent+1+height;
		//la position dans le tableau de sommet correspondant au coin suprieur gauche
	//the position in the vertex array corresponding to the top corner left
	int topcornerl=topcornerr+nbr;
	//difference between an "external" vertex and the corresponding "internal" vertex
	int width=2*nbr+2;
	//pour les cas o on a une ellipse
	float radx=dx-dist;
	float radz=dz-dist;

	float teta=(PI/2)/nbr;
	float x,y,z;

	if ( dist>=dx || dist>=dz || dist==0) return NewGDqcyhxa(dx,dy,dz,nbr,fcolors,o);

   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //center top
	   _p[p++].Set(-dx*0.5,0.5*dy,-dz*0.5);
	   _p[p++].Set(-dx*0.5,-dy*0.5,-dz*0.5);
   //vertex array
   for (int f=0; f<2; f++){
	//tour
   for(k=0; k<=nbr; k++){
	   x=-dx*0.5+dx*cos(k*teta);
	   y=-dy*0.5+dy*float(f);
	   z=-dz*0.5+dz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}
   }
   //coordonnes pour trou//hole coordinates
   for (f=0; f<2; f++){
	  //tour
   for(k=0; k<=nbr; k++){
	   x=-dx*0.5+radx*cos(k*teta);
	   y=-dy*0.5+dy*float(f);
	   z=-dz*0.5+radz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}
   }

	if (!o)
	  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif

	int vi=0;
	i=botcent+1;
	//triangles pour les 2 faces
	for(j=0;j<2;j++){
		for (; i<(topcornerr-1+j*height); i++){
			//triangle 1
			verts[vi++].v=i+(1-j)*(width+1); verts[vi++].v=i+width; verts[vi++].v=i+j*(width+1);
			//triangle 2
			verts[vi++].v=i+j*(width+1); verts[vi++].v=i+1; verts[vi++].v=i+(1-j)*(width+1);
		}
		i=topcornerr;
	}

	i=2;
	for(j=0;j<2;j++){
		for(; i<(topcornerr-1+j*width); i++){
		//triangle 1
		verts[vi++].v=i+(1-j)*(1+height); verts[vi++].v=i+1;  verts[vi++].v=i+j*(1+height);
		//triangle 2
		verts[vi++].v=i+(1-j)*height; verts[vi++].v=i+height+1; verts[vi++].v=i+j*height;
		}
		i=topcornerr-height+width;
	}

	//faces planes
	int last=_p.Length()-1;//last vertex of the vertex array
	//triangle 1
	verts[vi++].v=last-height;  verts[vi++].v=topcornerl;  verts[vi++].v=last;
	//traingle 2
	verts[vi++].v=topcornerl-height;verts[vi++].v=topcornerl;  verts[vi++].v=last-height;

	verts[vi++].v=topcornerr+width; verts[vi++].v=topcornerr;   verts[vi++].v=topcornerr-height;
	verts[vi++].v=topcornerr-height+width;  verts[vi++].v=topcornerr+width; verts[vi++].v=topcornerr-height;

	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(_p);
	o->SetVN(nbface*nbvertbyface,(Point *)NULL);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(SHELL_CONVEX);
	o->nfaces=nbface;

	return(o);
}

//permet de construire un cylindre troue circonscrit dans une boite avec possibilite d'une epaisseur
//creates a cylinder with a given thickness circumscribed in a box
GShellI *NewGDcthhxa(float dx,float dy,float dz,float dist, int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=4*nbr;
	const int nbvertbyface=3;
	const int nbface=8*nbr;
	//difference between a bottom vertex and the corresponding top vertex
	int height=2*nbr;
	//difference between an "external" vertex and the corresponding "internal" vertex
	int width=nbr;
	//hole radius
	float radx=0.5*dx-dist;
	float radz=0.5*dz-dist;

	//angle
	float teta=2*PI/nbr;
	float x,y,z;

	if ( dist>=dx || dist>=dz || dist==0) return NewGDcylhxa(dx,dy,dz,nbr,fcolors,o);

   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //center top
   //vertex array
   for (int f=0; f<2; f++){
	   //tour
	for(k=0; k<nbr; k++){
	   x=0.5*dx*cos(k*teta);
	   y=-dy*0.5+dy*float(f);
	   z=0.5*dz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}
	//holes vertex
	for(k=0; k<nbr; k++){
	   x=radx*cos(k*teta);
	   y=-dy*0.5+dy*float(f);
	   z=radz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}
   }


	if (!o)
	  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif

	int vi=0;
	i=0;
	//triangles pour les 2 faces
	for(j=0;j<2;j++){
		for (; i<(nbr-1+j*height); i++){
			//triangle 1
			verts[vi++].v=i+(1-j)*(width+1); verts[vi++].v=i+width; verts[vi++].v=i+j*(width+1);
			//triangle 2
			verts[vi++].v=i+j*(width+1); verts[vi++].v=i+1; verts[vi++].v=i+(1-j)*(width+1);
		}
		//triangle 1
		verts[vi++].v=j*i+(1-j)*(width+j*height); verts[vi++].v=i+width; verts[vi++].v=j*(width+height)+(1-j)*i;
		//triangle 2
		verts[vi++].v=j*(width+j*height)+(1-j)*i; verts[vi++].v=j*height; verts[vi++].v=j*i+(1-j)*(width+j*height);
		i=height;
	}

	i=0;
	//bord et trou
	for(j=0;j<2;j++){
		for(; i<(nbr-1+j*width); i++){
			//triangle 1
			verts[vi++].v=i+(1-j)*(1+height); verts[vi++].v=i+1;  verts[vi++].v=i+j*(1+height);
			//triangle 2
			verts[vi++].v=i+(1-j)*height; verts[vi++].v=i+height+1; verts[vi++].v=i+j*height;
		}
		verts[vi++].v=(1-j)*i+j*(height+width);verts[vi++].v=i+height;  verts[vi++].v=(1-j)*(height)+j*i;
		verts[vi++].v=(1-j)*(height+j*width)+j*i;  verts[vi++].v=j*width; verts[vi++].v=(1-j)*i+j*(height+j*width);
		i=width;
	}


	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(_p);
	o->SetVN(nbface*nbvertbyface,(Point *)NULL);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(SHELL_CONVEX);
	o->nfaces=nbface;

	return(o);
}

//permet de construire un quart de cylindre circonscrit dans une boite
//creates a quarter of cylinder circumscribed in a box
GShellI *NewGDqcyhxa(float dx,float dy,float dz,int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=2*(nbr+1)+2;
	const int nbvertbyface=3;
	const int nbface=4*nbr+4;
	//distance between a "bottom" vertex and the corresponding "top" vertex
	int offset=nbr+2;
	//position of the top center of the cylinder in the vertex array
	int topcent=0;
	//position of the bottom center of the cylinder in the vertex array
	int botcent=offset;
	// position of the top corner left in the vertex array
	int topcornerl=topcent+1;
	//position of the top corner right in the vertex array
	int topcornerr=offset-1;

	float teta=(-PI/2)/nbr;
	float x,y,z;


   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //vertex array
   for (int f=0; f<2; f++){
	   //center
	   _p[p++].Set(-dx*0.5,0.5*dy-dy*float(f),-dz*0.5);
	//tour
   for(k=0; k<=nbr; k++){
	   x=-dx*0.5+dx*cos(k*teta);
	   y=dy*0.5-dy*float(f);
	   z=-dz*0.5-dz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}
   }


	if (!o)
	  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif

	int vi=0;
	//triangles pour les 2 faces
	j=0;
	for (i=0; i<nbr; i++){
		verts[vi++].v=j+i+1; verts[vi++].v=j; verts[vi++].v=j+i+2;
	}
	j=offset;
	for (i=0; i<nbr; i++){
		verts[vi++].v=j+i+2; verts[vi++].v=j; verts[vi++].v=j+i+1;
	}

	for(i=1; i<(nbr+1); i++){
		//triangle 1
		verts[vi++].v=i; verts[vi++].v=i+1;  verts[vi++].v=i+1+offset;
		//triangle 2
		verts[vi++].v=i; verts[vi++].v=i+offset+1; verts[vi++].v=i+offset;
	}

	//faces planes
	//triangle 1
	verts[vi++].v=botcent; verts[vi++].v=topcent; verts[vi++].v=topcornerl;
	//triangle 2
	verts[vi++].v=topcornerl; verts[vi++].v=topcornerl+offset; verts[vi++].v=botcent;

	//triangle 1
	verts[vi++].v=topcornerr+offset; verts[vi++].v=topcornerr; verts[vi++].v=topcent;
	//triangle 2
	verts[vi++].v=topcent; verts[vi++].v=botcent; verts[vi++].v=topcornerr+offset;


	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(_p);
	o->SetVN(nbface*nbvertbyface,(Point *)NULL);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(SHELL_CONVEX);
	o->nfaces=nbface;

	return(o);
}


//permet de construire le dual d'un quart de cylindre circonscrit dans une boite
//creates the dual of the cylinder circumscribed in a box
GShellI *NewGDlychxa(float dx,float dy,float dz,int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=2*(nbr+1)+2;
	const int nbvertbyface=3;
	const int nbface=4*nbr+4;
	//distance between a "top" vertex and the corresponding "bottom" vertex
	int offset=nbr+2;
	//position of the top center in the vertex array
	int topcent=0;
	//position of the bottom center in the vertex array
	int botcent=offset+topcent;
	//position of the top corner left in the vertex array
	int topcornerl=topcent+1;
	//position of the top corner right in the vertex array
	int topcornerr=offset-1;

	float teta=(-PI/2)/nbr;
	float x,y,z;


   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //vertex array
   for (int f=0; f<2; f++){
	   //center
	   _p[p++].Set(dx*0.5,0.5*dy-dy*float(f),dz*0.5);
	//tour
   for(k=0; k<=nbr; k++){
	   x=-dx*0.5+dx*cos(k*teta);
	   y=dy*0.5-dy*float(f);
	   z=-dz*0.5-dz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}
   }


	if (!o)
		  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif

	int vi=0;
	//triangles pour les 2 faces
	j=0;
	for (i=0; i<nbr; i++){
		verts[vi++].v=j+i+2; verts[vi++].v=j; verts[vi++].v=j+i+1;
	}
	j=offset;
	for (i=0; i<nbr; i++){
		verts[vi++].v=j+i+1; verts[vi++].v=j; verts[vi++].v=j+i+2;
	}

	for(i=1; i<(nbr+1); i++){
		//triangle 1
		verts[vi++].v=i;  verts[vi++].v=i+1+offset; verts[vi++].v=i+1;
		//triangle 2
		verts[vi++].v=i; verts[vi++].v=i+offset; verts[vi++].v=i+offset+1;
	}

	//faces plates
	verts[vi++].v=topcent; verts[vi++].v=botcent; verts[vi++].v=topcornerl+offset;
	verts[vi++].v=topcornerl+offset; verts[vi++].v=topcornerl;  verts[vi++].v=topcent;
	verts[vi++].v=topcornerr; verts[vi++].v=topcornerr+offset; verts[vi++].v=botcent;
	verts[vi++].v=botcent; verts[vi++].v=topcent; verts[vi++].v=topcornerr;



	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(_p);
	o->SetVN(nbface*nbvertbyface,(Point *)NULL);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(SHELL_CONVEX);
	o->nfaces=nbface;

	return(o);
}

//pas utilise comme primitive car pas bonne construction
//permet de construire un quart de ?? circonscrit dans une boite
GShellI *NewGDqwahxa(float dx,float dy,float dz,int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=2*(nbr+1)+1;
	const int nbvertbyface=3;
	const int nbface=3*nbr+3;
	int diff=nbr+1;

	float teta=PI/(2*nbr);
	float dist=dx/nbr;
	float x0=-0.5*dx; float y0=-0.5*dy; float z0=-0.5*dz;
	float x,y,z;


   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //vertex array
   //center
   _p[p++].Set(x0,y0,z0);
   //tour
   for(k=0; k<=nbr; k++){
	   x=x0+dx*cos(k*teta);
	   y=y0;
	   z=z0+dz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}
   //droite en haut
   for(k=0; k<=nbr; k++)_p[p++].Set(-x0-float(k)*dist,-y0,-0.5*dz);


			if (!o)
			  o = new GShellI;


		GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
		GFaceList flist(nbface*(nbvertbyface+1));
		flist.SetLength(0);
#else
	GFaceList flist;
#endif
		int test=_p.Length();


		int vi=0;
		//triangles pour le dessous
		for (i=0; i<nbr; i++){
				verts[vi++].v=i+1; verts[vi++].v=0; verts[vi++].v=i+2;
			}
		//triangles pour les cotes
		verts[vi++].v=1; verts[vi++].v=diff+1; verts[vi++].v=0;
		verts[vi++].v=_p.Length()-1; verts[vi++].v=0; verts[vi++].v=diff+1;
		verts[vi++].v=0; verts[vi++].v=_p.Length()-1; verts[vi++].v=diff;

		i=1,k=0;
		for(; i<=nbr; i++){
				//triangle
				verts[vi++].v=i+1;
				verts[vi++].v=i+1+diff;
				verts[vi++].v=i+diff;
				//triangle 2
				verts[vi++].v=i+diff;
				verts[vi++].v=i;
				verts[vi++].v=i+1;
			}


		for ( k=0; k<vi; k++){
			verts[k].n = k;
			verts[k].p = k%3;
			verts[k].c = verts[k].v;
		}
		for (j=0; j<vi;){
			flist.AppendTri(j,j+1,j+2);
			j+=3;
		}

		params[0].Set(1.0,0.0,0.0);
		params[1].Set(1.0,1.0,0.0);
		params[2].Set(0.0,1.0,0.0);
		//params[3].Set(0.0,0.0,0.0);

		o->SetV(_p);
		o->SetVN(nbface*nbvertbyface,(Point *)NULL);
		o->SetVP(nbvertbyface,params);
		o->SetVertices(vi,verts);
		o->SetFN(nbface,(Point *)NULL);
		delete verts;

		o->SetFaceList(flist);
		o->SetFlag(SHELL_CONVEX);
		//o->UpdateActions();
		//o->UnSetAction(SHELL_COMPUTE_VNORMALS);
		o->nfaces=nbface;


		return(o);
}

//pas utilise comme primitive car pas bonne construction
//permet de construire un demi ?? circonscrit dans une boite
GShellI *NewGDhwahxa(float dx,float dy,float dz,int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=2*(nbr+1)+1;
	const int nbvertbyface=3;
	const int nbface=3*nbr+2;
	int diff=nbr+1;

	float teta=PI/nbr;
	float dist=dx/nbr;
	float x0=-0.5*dx; float y0=-0.5*dy; float z0=-0.5*dz;
	float x,y,z;


   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //vertex array
   //center
   _p[p++].Set(0,y0,z0);

   //_p[p++].Set(x0,y0,z0);
   //tour
   for(k=0; k<=nbr; k++){
	   x=0.5*dx*cos(k*teta);
	   y=y0;
	   z=z0+0.5*dz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}
   //droite en haut
   for(k=0; k<=nbr; k++)_p[p++].Set(-x0-float(k)*dist,-y0,-0.5*dz);


			if (!o)
			  o = new GShellI;


		GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
		GFaceList flist(nbface*(nbvertbyface+1));
		flist.SetLength(0);
#else
	GFaceList flist;
#endif
		int test=_p.Length();


		int vi=0;
		//triangles pour le dessous
		for (i=0; i<nbr; i++){
				verts[vi++].v=i+2; verts[vi++].v=0; verts[vi++].v=i+1;
			}
		//triangles pour les cotes
		verts[vi++].v=nbr+1; verts[vi++].v=diff+1; verts[vi++].v=1;
		verts[vi++].v=1+diff; verts[vi++].v=nbr+1; verts[vi++].v=nbr+diff+1;

		i=1,k=0;
		for(; i<=nbr; i++){
				//triangle
				verts[vi++].v=i+diff;
				verts[vi++].v=i+1+diff;
				verts[vi++].v=i+1;
				//triangle 2
				verts[vi++].v=i+1;
				verts[vi++].v=i;
				verts[vi++].v=i+diff;
			}


		for ( k=0; k<vi; k++){
			verts[k].n = k;
			verts[k].p = k%3;
			verts[k].c = verts[k].v;
		}
		for (j=0; j<vi;){
			flist.AppendTri(j,j+1,j+2);
			j+=3;
		}

		params[0].Set(1.0,0.0,0.0);
		params[1].Set(1.0,1.0,0.0);
		params[2].Set(0.0,1.0,0.0);
		//params[3].Set(0.0,0.0,0.0);

		o->SetV(_p);
		o->SetVN(nbface*nbvertbyface,(Point *)NULL);
		o->SetVP(nbvertbyface,params);
		o->SetVertices(vi,verts);
		o->SetFN(nbface,(Point *)NULL);
		delete verts;

		o->SetFaceList(flist);
		o->SetFlag(SHELL_CONVEX);
		//o->UpdateActions();
		//o->UnSetAction(SHELL_COMPUTE_VNORMALS);


		return(o);
}

//permet de construire un cone circonscrit dans une boite
//creates a cone circumscribed in a box
GShellI *NewGDconhxa(float dx,float dy,float dz,int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=nbr+2;
	const int nbvertbyface=3;
	const int nbface=2*nbr;
	//position of the bottom center in the vertex array
	int botcenter=1;
	//position of the top vertex in the vertex array
	int topcenter=0;

	float teta=2*PI/nbr;
	float x,y,z;


   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //sommet en haut
   _p[p++].Set(0,0.5*dy,0);
   _p[p++].Set(0,-0.5*dy,0);

   //vertex array
	//tour
   for(k=0; k<nbr; k++){
	   x=0.5*dx*cos(k*teta);
	   y=-dy*0.5;
	   z=0.5*dz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}



	if (!o)
	  o = new GShellI;


	GVertexI *verts = new GVertexI[(2+nbface)*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif
	//position of the last vertex in the vertex array
	int last=_p.Length()-1;


	int vi=0;
	//triangles pour les 2 faces
	j=0;
	for (i=botcenter; i<(last-1); i++){
		verts[vi++].v=i+2; verts[vi++].v=botcenter; verts[vi++].v=i+1;
	}
	verts[vi++].v=botcenter+1; verts[vi++].v=botcenter; verts[vi++].v=last;
	for (i=botcenter+1; i<last; i++){
		verts[vi++].v=i; verts[vi++].v=topcenter; verts[vi++].v=i+1;
	}
	verts[vi++].v=last; verts[vi++].v=topcenter; verts[vi++].v=botcenter+1;


	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(_p);
	//o->SetVN(nbface*nbvertbyface,(Point *)NULL); // FIXME_OB
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	//o->SetFN(nbface,(Point *)NULL); // FIXME_OB
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(SHELL_CONVEX);
	o->nfaces=nbface;

	return(o);
}

//permet de construire un quart de cone circonscrit dans une boite
//creates a quarter of cone circumscribed in a box
GShellI *NewGDqcohxa(float dx,float dy,float dz,int nbr,Point *fcolors,GShellI *o)
{
	//characteristics
	const int nbvertex=nbr+3;
	const int nbvertbyface=3;
	const int nbface=2*nbr+2;
	//position of the bottom center of the cone in the vertex array
	int botcenter=1;
	//position of the top vertex of the cone in the vertex array
	int topcenter=0;

	float teta=PI/(2*nbr);
	float x,y,z;


   PointArray _p(nbvertex);
   Point params[nbvertbyface];
   int p,i=0,j,k;
   p= 0;

   //sommet en haut//top vertex
   _p[p++].Set(-0.5*dx,0.5*dy,-0.5*dz);
   _p[p++].Set(-0.5*dx,-0.5*dy,-0.5*dz);

   //vertex array
	//tour
   for(k=0; k<=nbr; k++){
	   x=-dx*0.5+dx*cos(k*teta);
	   y=-dy*0.5;
	   z=-dz*0.5+dz*sin(k*teta);
	   _p[p++].Set(x,y,z);
	}



	if (!o)
	  o = new GShellI;


	GVertexI *verts = new GVertexI[nbface*nbvertbyface];
#ifdef FIXME_OB
	GFaceList flist(nbface*(nbvertbyface+1));
	flist.SetLength(0);
#else
	GFaceList flist;
#endif
	//position of the last vertex in the vertex array
	int last=_p.Length()-1;


	int vi=0;
	//triangles pour le dessous//bottom triangles
	j=0;
	for (i=botcenter; i<(last-1); i++){
		verts[vi++].v=i+2; verts[vi++].v=botcenter; verts[vi++].v=i+1;
	}
	for (i=botcenter+1; i<last; i++){
		verts[vi++].v=i; verts[vi++].v=topcenter; verts[vi++].v=i+1;
	}
	//deux triangles//side triangles
	verts[vi++].v=botcenter; verts[vi++].v=topcenter; verts[vi++].v=botcenter+1;
	verts[vi++].v=last; verts[vi++].v=topcenter; verts[vi++].v=botcenter;

	for ( k=0; k<vi; k++){
		verts[k].n = k;
		verts[k].p = k%3;
		verts[k].c = verts[k].v;
	}
	for (j=0; j<vi;){
		flist.AppendTri(j,j+1,j+2);
		j+=3;
	}

	params[0].Set(1.0,0.0,0.0);
	params[1].Set(1.0,1.0,0.0);
	params[2].Set(0.0,1.0,0.0);

	o->SetV(_p);
	o->SetVN(nbface*nbvertbyface,(Point *)NULL);
	o->SetVP(nbvertbyface,params);
	o->SetVertices(vi,verts);
	o->SetFN(nbface,(Point *)NULL);
	delete verts;

	o->SetFaceList(flist);
	o->SetFlag(SHELL_CONVEX);
	o->nfaces=nbface;

	return(o);
}

#endif // FIXME_OB
